Fri Dec 20 15:23:26 2002  Owen Taylor  <otaylor@redhat.com>

	* === Released 2.2.0 ===

	* configure.in: Version 2.2.0, interface age 0, binary age 200.

	* README.in: Update the release notes.

	* INSTALL.in: Mention that Pango-1.0 can be used with GTK+-2.2.

	* NEWS: Update.

2002-12-20  Sven Neumann  <sven@gimp.org>

	* examples/gtkdial/gtkdial.c: use G_PI instead of M_PI.

Thu Dec 19 11:42:00 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c (gdk_event_translate): Call
	the filters on the window where the event is received,
	not on the window the event is "about". (#101512,
	Bolian Yin.)

Thu Dec 19 03:58:36 2002  Kristian Rietveld  <kris@gtk.org>

	* tests/testtreeflow.c: the rand variable should be static to
	avoid conflicts with rand(). (#100844, reported by Soeren Sandmann,
	fix pointed out by Matthias Clasen).

Thu Dec 19 03:56:23 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_real_select_cursor_row): if we
	started editing, we handled this key signal, so return TRUE.
	(#100532, reported by Soeren Sandmann).

2002-12-18  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkwidget.c: Add docs.

Wed Dec 18 12:05:33 2002  Owen Taylor  <otaylor@redhat.com>

	* NEWS: Various name fixes.

Mon Dec 16 22:38:11 2002  Owen Taylor  <otaylor@redhat.com>

	* === Released 2.1.5 ===

	* configure.in: GTK+-2.1.5, interface age 2, binary age 105.

	* NEWS: Updated.

	* gtk/Makefile.am (gtk_c_sources): Remove reference to fnmatch.h

Mon Dec 16 22:12:01 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Don't use AC_CHECK_LIB() when
	checking for FreeType, Pango, Atk since that get
	the ordering wrong. Instead, set LIBS ourself
	and call AC_TRY_LINK_FUNC(). (#98406)

Mon Dec 16 21:39:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_enter_text): Call
	gtk_entry_set_position_internal() that takes a
	new "reset_IM" parameter, so that we avoid the
	problem where committing text would reset the
	input method. (#74381, Kang Jeong-Hee)

2002-12-17  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkcontainer.c: Fix a few doc comments.

2002-12-17  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkglobals-win32.c: Minor cosmetics.

	Implement two missing functions (#101369)

	* gdk/win32/gdkevents-win32.c
	(gdk_display_add_client_message_filter): Implement by calling
	gdk_add_client_message_filter(), no separate displays on Windows,
	at least not yet.

	* gdk/win32/gdkgc-win32.c (gdk_gc_get_screen): Implement by
	returning the only screen so far, _gdk_screen.

	* gdk/gdk.def: Add here, too.

Mon Dec 16 16:18:15 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktexttag.c (gtk_text_tag_get_property): Get rid
	of incorrect calls to g_value_init(). (#100669, Johan
	Dahlin, James Henstridge)

Mon Dec 16 17:20:02 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkaccellabel.c: Implement Owen's susggestion from
	#80764. Fixes #101314.

Sun Dec 15 18:47:30 2002  Owen Taylor  <otaylor@redhat.com>

	Some fixes for modal hint setting based on a patch
	from Arvind Samptur (#100416)

	* gtk/gtkdialog.c (gtk_dialog_run): Call gtk_window_set_modal
	before showing the window for efficiency.

	* gtk/gtkwindow.c (gtk_window_realize): Ignore the EWMH
	constraint that the transient-for hint must always be
	set on windows with the modal hint and just always set
	the modal hint.

	* gtk/gtkwindow.c (gtk_window_set_modal): Update the
	modal hint on the GdkWindow when the window is realized.

Sun Dec 15 18:39:09 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Hard-code GTK_BINARY_VERSION=2.2.0 for
	now; should stay the same until we branch for 2.3. (#100598)

Sun Dec 15 18:14:16 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenuitem.c (gtk_real_menu_item_activate_item): 
	Pass TRUE for search_sensitive - prevents a problem
	where after hitting Alt-F to bring up the File menu,
	the mnemonics for the items in the menu might not
	be usable. (#89336)

Sat Dec 14 22:18:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (gdk_window_get_frame_extents):
	Fix a bug with checking the private flag on the wrong
	window; improve the answer on failure a bit; push
	an error trap around the X operations. (#100933)

Sat Dec 14 22:03:21 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/gtkimcontextxim.c (status_window_hide): Don't
	call status_window_set_text() if the status window doesn't
	already exist. (#100933, reported by Anand Subra)

	* modules/input/gtkimcontextxim.c (status_window_show): 
	Don't bother creating the status window here, wait for
	the set_text(). (Fixes a warning)

2002-12-15  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkcalendar.c:
	* gtk/gtkfilesel.c:
	* gtk/gtkfontsel.c:
	* gtk/gtkhruler.c:
	* gtk/gtkinputdialog.c:
	* gtk/gtkprogress.c:
	* gtk/gtktreemodel.c:
	* gtk/gtkvruler.c:
	* gtk/queryimmodules.c:
	* gtk/theme-bits/decompose-bits.c:
	* gdk-pixbuf/gdk-pixbuf-csource.c:
	* gdk-pixbuf/make-inline-pixbuf.c:
	* gdk-pixbuf/queryloaders.c:
	* gdk/gdkkeynames.c:
	* gdk/gdkrgb.c:
	* gdk/linux-fb/gdkfbmanager.c:
	* gdk/win32/gdkevents-win32.c:
	* gdk/win32/gdkmain-win32.c:
	* gdk/win32/gdkproperty-win32.c:
	* gdk/x11/gdkmain-x11.c: Use g_printf instead of system 
	printf.  (#99327)  

	* gtk/gtkcontainer.c (gtk_container_class_install_child_property): 
	(gtk_container_child_get_valist): 
	(gtk_container_child_get_property): 
	(gtk_container_child_set_valist): 
	(gtk_container_child_set_property): 
	(gtk_container_add_with_properties): 
	(gtk_container_child_set): 
	(gtk_container_child_get): Add docs.

	* gtk/gtkwindow.c (gtk_window_activate_default): 
	(gtk_window_activate_focus): Add docs.

2002-12-14  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkmenuitem.c (gtk_menu_item_position_menu): Made
	Xinerama-aware.  (#85711)

Sat Dec 14 14:19:16 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c: Add a new binding signal, "move_scroll",
	and use it to hook up Home/End/Page_Up/Page_Down keybindings.
	(#80484, Narayana Pattipati, Marius Andreiana)

	* gtk/gtkmenu.c (gtk_menu_scroll_item_visible): Fix some
	bugs in the computation of when an item is visible. (#99545)
	
	* gtk/gtkbindings.[ch] (_gtk_binding_signal_new) gtk/gtkmenushell.c:
	Move here, export privately.

	* gtk/gtkmenushell.c (_gtk_menu_shell_select_last): Export
	privately.

	* gtk/gtkmenushell.c (gtk_menu_shell_select_item): Don't
	select the item if it is already selected.

Sat Dec 14 01:51:05 2002  Chema Celorio  <chema@celorio.com>

	* gtk/gtkdialog.c (gtk_dialog_add_buttons_valist): minor coding
	style fix.

Sat Dec 14 01:22:05 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkaccellabel.[ch] (gtk_accel_label_refetch): Don't
	recalculate the acceleration label in an idle handler.

Sat Dec 14 01:00:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_position): Handle the case
	where the pointer isn't on the same screen as the widget
	by centering the menu on the widget's screen. (#94563)

Fri Dec 13 23:58:06 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkscreen.c (gdk_screen_get_monitor_at_point)
	* gdk/gdkscreen.c (gdk_screen_get_monitor_at_window): 
	Provide a useful fallback on failure - return a monitor
	close to the point or window. (#79991)

	* gtk/gtkmenu.c (gtk_menu_position): Remove a now
	unneeded check for failure of 
	gdk_screen_get_monitor_at_point()

Fri Dec 13 23:10:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c: Fix a problem with the focus row
	ending up off the list when rows were deleted
	(#94812, Christian Reis, Jon Nelson).

Fri Dec 13 22:55:27 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (menu_change_screen): If the screen
	for the menu changes while the menu is torn off, move
	the tearoff along with it. (#85669)

	* gtk/gtkmenu.c (gtk_menu_set_tearoff_state): When 
	reattaching, get rid of the get rid of the tearoff window.

Fri Dec 13 21:35:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkhandlebox.c (gtk_handle_box_motion): Handle
	the case where the pointer is moved between screens
	during a handle box drag by resetting the original
	location. (#94562)

	* gtk/gtkinputdialog.c (gtk_input_dialog_get_private): 
	Fix a leftover variable name from cut-and-paste.

Fri Dec 13 18:57:20 2002  Owen Taylor  <otaylor@redhat.com>

 	* gtk/gtkdialog.c: Change the Escape key binding to only close
 	if the dialog contains a cancel button.  (Patch from
	James Willcox, #74221)
 
Fri Dec 13 18:22:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (compare_cmpl_dir): Use 
	g_utf8_collate_key() to sort in human-friendly order.
	(#94473, Gregory Merchan)

Fri Dec 13 17:45:40 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/fnmatch.c gtk/gtkprivate.h gtk/gtkfilesel.c: 
	System fnmatch wasn't going to be UTF-8 clean, neither 
	was our	version. Redo our fnmatch.c to be UTF-8, add 
	test cases, fix all sorts of bugs inherited
	from the antique GNU fnmatch code. Change interface
	to get rid of fnmatch.h constants. Fixes basic
	non-workingness of filesel with non-ASCII filenames.
	(#78758, Kang Jeong-Hee)

	* gtk/fnmatch.h: No longer needed.

Fri Dec 13 12:15:09 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (find_parent_dir_fullname): If
	getting the parent of the directory name, make
	an attempt to change back to the original directory.

Thu Dec 12 20:07:25 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (cmpl_completion_fullname): Const
	warning fix.

Thu Dec 12 19:51:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (open_new_dir): Include "."
	and ".." in the list of entries; they are needed for 
	correct	handling of .<TAB>, ..<TAB>; were lost
	with the GDir conversion. (Francisco Bustamante,
	#89972)

	* gtk/gtkfilesel.c (open_new_dir): If we hit
	EOF unexpectedly, that's OK... a file was just
	deleted while we were reading the directory.

Thu Dec 12 18:02:34 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_main_do_event): Intercept events
	of type GDK_SETTING before we check to see if there
	was an event widget or not. (#97451, Simon Wong,
	Bastien Nocera)

Thu Dec 12 17:58:41 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.key.emacs: Add C-u/C-h/C-w. (#72245)

Thu Dec 12 17:01:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_find_widget): Skip insensitive
	widgets. (#84061)

Thu Dec 12 15:08:01 2002  Owen Taylor  <otaylor@redhat.com>

	* acinclude.m4: Remove unneeded bits of AM_GTK_GNU_TEXT
	macros.

Thu Dec 12 18:25:17 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtktextview.c (gtk_text_view_button_press_event): 
	return TRUE when button 3 is pressed, fixes #78324.

Thu Dec 12 10:12:39 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextview.c: Turn off DEBUG_VALIDATION_AND_SCROLLING
	that got turned on in an accidental commit.

Wed Dec 11 18:30:05 2002  Owen Taylor  <otaylor@redhat.com>

	* === Released GTK+-2.1.4 ===

	* NEWS: Updated.

	* modules/input/Makefile.am (INCLUDES): Remove GTK_LOCALEDIR
	from here as well. (Manish Singh)

2002-12-11  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkpixmap-win32.c (gdk_pixmap_new,
	gdk_bitmap_create_from_data, gdk_pixmap_create_from_data)
	* gdk/win32/gdkprivate-win32.h
	* gdk/win32/gdkimage-win32.c (_gdk_win32_setup_pixmap_image):
	Functions now take a GdkDrawable instead of GdkWindow parameter,
	like in X11 and linux-fb backends (#100780)

	* gdk/win32/gdkwindow-win32.c (get_default_title): Do use
	g_get_application_name() (I now have a fresh enough GLib).

Wed Dec 11 14:04:23 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: version 2.1.4, interface age 1.
	
	* configure.in: Require GLib-2.1.4, so we will catch
	the need for the new AM_GLIB_DEFINE_LOCALEDIR() in
	an obvious way.

	* configure.in gtk/Makefile.am: Use AM_GLIB_DEFINE_LOCALEDIR()

Tue Dec 10 15:46:01 PST 2002  Manish Singh  <yosh@gimp.org>

	* gdk/x11/gdkwindow-x11.c (set_initial_hints): 
	gdk_x11_get_xatom_by_name_for_display takes a GdkDisplay *,
	not an XDisplay * (obvious typo fix for the previous commit)

2002-12-11  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkwindow-x11.c (set_initial_hints): Delete EWMH
	properties if no private->state flags are set.  (#66754)

2002-12-10  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkwidget.c (gtk_widget_class_find_style_property): 
	* gtk/gtkcontainer.c (gtk_container_class_find_child_property):
	Doc typo fixes.

	* gtk/tree_plus.xpm: 
	* gtk/tree_plus.xbm: 
	* gtk/tree_minus.xpm: 
	* gtk/tree_minus.xbm: 
	* gtk/line-wrap.xbm: 
	* gtk/line-arrow.xbm: 
	* gtk/gtktextview.c: 
	* gtk/gtktextutil.c: 
	* gtk/gtkstyle.c: 
	* gtk/gtkstock.c: 
	* gtk/gtksizegroup.c: 
	* gtk/gtkselection.c: 
	* gtk/gtkoptionmenu.c: 
	* gtk/gtklist.c: 
	* gtk/gtkfilesel.c: 
	* gtk/gtkentry.c: 
	* gtk/gtkcolorsel.c: 
	* gtk/gtkclist.c: 
	* gtk/gtkclipboard.c: 
	* gtk/gtkbutton.c: Data constness fixes.  (#75754)

Tue Dec 10 14:37:41 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c (gdk_event_translate)
	  gdk/x11/gdkwindow-x11.h: Separate out tracking of the X server
	  focus window from tracking our idea of what the focus window is,
	  because the PointerRoot code needs to know the real pointer
	  window. (Mostly accidentally committed a bit earlier.)

Tue Dec 10 12:57:00 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (adjust_adjustments): Fix typo with
	hadjustment/vadjustment introduce prior to 2.0.0.
	(#84621, Charles Kerr)

Tue Dec 10 12:40:30 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenuitem.c, gtk/gtkstyle.c, gtk/gtkrc.c: new default
	color scheme based on the GNOME stock icon palette. (#80691,
	Tuomas Kuosmanen, Garrett LeSage, Owen Taylor)

	* gtk/gtknotebook.c (gtk_notebook_real_remove): take a new
	parameter, "destroying", and don't emit the switch-page signals
	when it is true (fix #64832, reported by Jarred Keuch)

	* gtk/gtklabel.c (gtk_label_set_property): remove unused
	variable. 

Tue Dec 10 02:14:12 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_get_path_at_pos): x can be in
	the range [0, upper], which can be bigger than [0, page_size].
	(Fixed #99778, reported and testcase provided by Carlos Garnacho
	Parro).

Mon Dec  9 19:49:03 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_move_resize): Remove
	a couple of places if (widget->window), this function
	will only ever be called on a realized window.
	(#80225)

Tue Dec 10 01:58:43 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (validate_visible_area): implement a working
	use_align = FALSE implementation (also mentioned in #91335, reported
	by Juri Pakaste).

	* gtk/gtktreeview.c (validate_visible_area): only free the
	scroll_to_path if we are done with validating (fixes #93584, reported
	and testcase provided by Erik Simonsen).

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_cell_process_action):
	set the GTK_CELL_RENDERER_FOCUSED flag where appropriate. (fixes
	#75745, reported by Richard Hult).

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_cell_get_position):
	initialize cellinfo to NULL to silence the compiler.

Mon Dec  9 19:31:59 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c (draw_spinbutton_shadow): Remove
	unused draw_spin_entry_shadow(). (#80229)

Mon Dec  9 18:50:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkinput-x11.c (_gdk_input_common_find_events):
	Remove selection for DeviceButtonRelease, we no longer need
	it now that gxi is gone. (#32617, reported by Garry
	Osgood)

Tue Dec 10 00:49:35 2002  Kristian Rietveld  <kris@gtk.org>

	* gdk/gdkpixmap.h (gdk_pixmap_new), (gdk_bitmap_create_from_data),
	(gdk_pixmap_create_from_xpm), (gdk_pixmap_colormap_create_from_xpm),
	(gdk_pixmap_create_from_xpm_d),
	(gdk_pixmap_colormap_create_from_xpm_d): update to allow a
	GdkDrawable instead of a GdkWindow.

	* gdk/gdkpixmap.c (gdk_pixmap_colormap_create_from_xpm),
	(gdk_pixmap_create_from_xpm), (gdk_pixmap_colormap_create_from_xpm_d),
	(gdk_pixmap_create_from_xpm_d): update to allow a GdkDrawable
	instead of a GdkWindow.

	* gdk/linux-fb/gdkpixmap-fb.c (gdk_pixmap_new),
	(gdk_bitmap_create_from_data), (gdk_pixmap_create_from_data): update
	to allow a GdkDrawable instead of a GdkWindow.

	* gdk/x11/gdkpixmap-x11.c (gdk_pixmap_new),
	(gdk_bitmap_create_from_data), (gdk_pixmap_create_from_data): likewise

Mon Dec  9 17:31:06 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkiconfactory.c (icon_size_lookup_intern): Remove
	unnecessary leftover check that was causing a UMR.
	(#100768, Kjartan Maraas)

Mon Dec  9 19:11:22 2002  Artis Trops  <hornet@navigator.lv>

	* configure.in: Added Latvian (lv) to ALL_LINGUAS.

Mon Dec  9 10:44:59 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_alloc_colors_private):
	Fix a bug in one of my earlier changes. (From Naofumi Yasufuku,
	#100023)

Sun Dec  8 21:43:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkcolor-x11.c: Fix spacing in a bunch of 
	for (i=0; i<ncolors; i++).

	* gdk/x11/gdkcolor-x11.c: Various g_return_if_fail()
	cleanup.

Sun Dec  8 21:29:10 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_alloc1): Fix
	a lost refcount in the case where we get a duplicate
	back from the X server.

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_alloc_colors_writeable):
	Set success[] for all colors when allocation of colors
	cells via XAllocColorCells succeeds.

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_alloc_colors_private):
	Don't match against colors cells allocated writeable.

Sun Dec  8 21:22:46 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_alloc_colors_private): 
	When allocating non-writeable colors, fill in the flags
	field of the XColor, and insert the returned color into
	our color hash. (#100023, Naofumi Yasufuku)

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_free_colors): 
	Fix a typo (my fault) that slipped in in the last patch.

Sun Dec  8 20:32:23 2002  Owen Taylor  <otaylor@redhat.com>

	More fixes for GdkColormapX11 (#100023, Naofumi Yasufuku)

	* gdk/x11/gdkcolor-x11.c (gdk_colors_free) 
	(gdk_colormap_free_colors): Don't call XFreeColors() for  
	private colorsmaps.

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_alloc_colors_writeable,
	gdk_colormap_colors_private, gdk_colormap_alloc_colors_shared):
	Fix return values to return number remaining not number
	allocated.
	
	* gdk/x11/gdkcolor-x11.c (gdk_colormap_alloc_colors_shared,
	gdk_colormap_alloc_colors_private): Clean up some a stray 
	initializations.

Sun Dec  8 20:19:22 2002  Owen Taylor  <otaylor@redhat.com>

	Fixes for GdkColormapX11 (#100023, Naofumi Yasufuku)

	* gdk/x11/gdkcolor-x11.c (gdk_x11_colormap_foreign_new): 
	Fix typo that caused us to always return the system
	colormap.

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_new): When allocating
	a private colormap and copying the system palette
	to prevent flashing, handle colormap->size greater than
	system_colormap->size.

	* gdk/x11/gdkcolor-x11.c (gdk_x11_colormap_get_xdisplay):
	Get rid of the last remains of private->xdisplay
	in favor of using private->screen. 

2002-12-09  Tor Lillqvist  <tml@iki.fi>

	Merge from stable:
	
	* gdk/win32/gdkdrawable-win32.c (generic_draw): Don't leak
	stipple_gc. More checks for errors. Use correct ternary ROP when
	blitting the foreground into the tile pixmap onto those pixels
	where the stipple is set. (I didn't notice that I had used the
	wrong one, as it didn't matter on Win2k, where DIB sections
	apparently are zeroed upon creation. But on Win98 they have random
	initial contents. Thanks to Hans Breuer for reporting this.)
	(gdk_win32_draw_rectangle, gdk_win32_draw_arc,
	gdk_win32_draw_polygon): Don't pass the LINE_ATTRIBUTES bits to
	generic_draw() if drawing a filled figure.

	* gdk/win32/gdkmain-win32.c (_gdk_win32_print_dc): Minor cosmetics.
	(_gdk_win32_gcvalues_mask_to_string): Initialize buffer as empty.
	(_gdk_win32_window_state_to_string): New debugging output helper
	function.
	
	* gdk/win32/gdkevents-win32.c: Minor debugging output changes.
	(gdk_event_translate): Ignore the WM_SHOWWINDOW/SW_OTHERUNZOOM or
	SW_OTHERZOOM messages. Do not generate a GDK_UNMAP event for
	WM_SIZE/SIZE_MINIMIZED messages, they do not really corrspond to
	unmapping on X11. Set window state correctly for all three of
	SIZE_{MINIMIZED,MAXIMIZED,RESTORED}. A maximized and then iconified
	("minimized" in Windows terminology) window still has the
	"maximized" property, i.e. when deiconified, it will reappear as
	maximized. (#10557)

	* gdk/win32/gdkprivate-win32.h: Declare new function.
	(WIN32_API_FAILED, WIN32_GDI_FAILED, OTHER_API_FAILED): Don't use
	__PRETTY_FUNCTION__ if __GNUC__ >= 3, to avoid warning message.

	* gdk/win32/gdkwindow-win32.c (show_window_internal): Handle more
	situations. Add parameter to tell whether deiconifying. Code
	reorg: Return early when appropriate instead of using nested if
	statements. If just deiconifying without raising, restore active
	window. (#10557)

	(gdk_window_hide, gdk_window_withdraw, gdk_window_iconify,
	gdk_window_deiconify, gdk_window_maximize, gdk_window_unmaximize,
	gdk_window_focus): Use _gdk_win32_window_state_to_string() in
	debugging output.

	(gdk_window_iconify): Restore active window after calling
	ShowWindow(). Otherwise the "next" window gets activated.

	(gdk_window_stick, gdk_window_unstick): Don't output any warnings.

	(gdk_window_set_transient_for): Rewrite. Just call SetWindowLong()
	with GWL_HWNDPARENT, which despite its name sets the *owner*
	window, which should be exactly what we want. The PSDK
	documentation is said to be misleading. testgtk's modal window
	test now works much better. (#50586)

Sun Dec  8 18:28:51 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_modify_fg/bg/base/text/font): 
	Remove left-over NULL checks that were preventing the
	NULL to "unmodify" feature from actually working.
	(#100702, Jon-Kare Hellan)

2002-12-08  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkcolorsel.c (gtk_color_selection_set_previous_color): 
	(gtk_color_selection_set_previous_alpha): Reset priv->changing 
	before returning.  (#100443)

Sat Dec  7 14:45:50 GMT 2002  Tony Gale <gale@gtk.org>

	* docs/tutorial/gtk-tut.sgml: minor fixes

	* examples/pixmap: don't use deprecated function

Fri Dec  6 19:00:59 2002  Owen Taylor  <otaylor@redhat.com>

	* demos/gtk-demo/testview.c tests/testgtk.c
	tests/testtext.c tests/testtextbuffer.c: Use
	octal escapes rather than literal UTF-8.

Fri Dec  6 17:50:57 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkpixmap.c (PACKED_COLOR): Fix incorrect
	masks in PACKED_COLOR definition. (#99795, 
	John Finlay)

Fri Dec  6 17:46:42 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_window_size_request): Use
	the correct screen for getting the height.
	(Fix from Stephen Browne, #96777)

Thu Dec  5 16:01:14 2002  Eric Warmenhoven <eric@warmenhoven.org>

	* gdk/{linux-fb,win32}/Makefile.am: Fix gdkenumtypes.h hack

2002-12-06  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkcolor.c: 
	* gdk/gdkfont.c: Add some Deprecation info. 

Wed Dec  4 19:41:14 2002  Eric Warmenhoven <eric@warmenhoven.org>

	* gdk/linux-fb/gdkglobals-fb.c gdk/linux-fb/gdkkeyboard-fb.c
	gdk/linux-fb/gdkmain-fb.c gdk/linux-fb/gdkprivate-fb.h
	gdk/linux-fb/gdkrender-fb.c: More proper vt switch handling

Wed Dec  4 14:31:46 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdnd-x11.c: Always look up and create the
	Motif drag window as a child of the root window of screen 0
	rather than the default screen.	(#100362, Erwann Chenede)

	* gdk/x11/gdkdnd-x11.c (motif_read_initiator_info):
	Return FALSE, not GDK_FILTER_REMOVE on failure; this
	isn't a filter function.
	
	* gdk/x11/gdkselection-x11.c gtk/gtkselection.c: Add
	some g_return_if_fail() to catch selection == None more 
	gracefully than an X error.

2002-12-04  Christian Neumair  <chris@gnome-de.org>

	* gtk/gtkcellrendertoggle.c: Fixed typo in property
	description.

Wed Dec  4 12:44:50 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcombo.c (gtk_combo_selection_changed): Add
	back the monitoring of the selection when the combo
	isn't popped down; apparently people depended upon
	the side-effect where gtk_combo_set_popdown_strings()
	would wipe out the contents of the list when browse-mode
	autoselected the first item in the list. (#100347)

Tue Dec  3 17:47:24 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkgeometry-x11.c (gdk_window_guffaw_scroll): Fix wrong 
	sign for queued translation. (Found by Chris Blizzard,
	#100274)

2002-12-03  Matthias Clasen  <maclas@gmx.de>

	Moveresize emulation for all edges.  (#52833)
	
	* gdk/x11/gdkwindow-x11.c (update_pos): Support all edges. 
	(calculate_unmoving_origin): New function which calculates the
	ICCCM reference point for the window depending on the gravity.
	(emulate_resize_drag): use calculate_unmoving_origin().
	(emulate_move_drag): use calculate_unmoving_origin().

	RTL flipping for statusbars.  (#96832)
	
	* gtk/gtkstatusbar.c (get_grip_edge): New function returning the
	appropriate grip edge for a statusbar.
	(get_grip_rect): Do the right thing in RTL mode.
	(gtk_statusbar_button_press): Initiate a resize drag on the
	appropriate edge. 
	(gtk_statusbar_expose_event): Paint the resize grip for the
	appropriate edge.

2002-12-03  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkstyle.c: Fix doc comment.

Mon Dec  2 20:36:28 2002  Owen Taylor  <otaylor@redhat.com>

	* === Released GTK+-2.1.3 ===

	* configure.in: Version 2.1.3, interface ago 0.

	* NEWS: Update

2002-12-02  Murray Cumming  <murrayc@usa.net>

	* gtk/gtktreemodel.h: Declare gtk_tree_row_reference_get_type(). It is
	already used by a macro in the same header.

2002-11-28  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkdisplay.c: 
	* gdk/gdkdisplaymanager.c: 
	* gdk/gdk.c: 
	* gdk/gdkdraw.c:
	* gdk/gdkevents.c:
	* gdk/gdkrgb.c:
	* gdk/gdkscreen.c:
	* gdk/gdkwindow.c:
	* gdk/x11/gdkcolor-x11.c:
	* gdk/x11/gdkcursor-x11.c:
	* gdk/x11/gdkdisplay-x11.c:
	* gdk/x11/gdkdnd-x11.c:
	* gdk/x11/gdkevents-x11.c:
	* gdk/x11/gdkfont-x11.c:
	* gdk/x11/gdkgc-x11.c:
	* gdk/x11/gdkinput.c:
	* gdk/x11/gdkkeys-x11.c:
	* gdk/x11/gdkpango-x11.c:
	* gdk/x11/gdkpixmap-x11.c:
	* gdk/x11/gdkproperty-x11.c:
	* gdk/x11/gdkscreen-x11.c:
	* gdk/x11/gdkselection-x11.c:
	* gdk/x11/gdkvisual-x11.c:
	* gdk/x11/gdkwindow-x11.c:
	* gdk/x11/gdkxid.c:
	* gtk/gtkclipboard.c:
	* gtk/gtkcolorsel.c:
	* gtk/gtkiconfactory.c:
	* gtk/gtkinvisible.c:
	* gtk/gtkliststore.c:
	* gtk/gtkmenu.c:
	* gtk/gtkmenushell.c:
	* gtk/gtknotebook.c:
	* gtk/gtkplug.c:
	* gtk/gtkselection.c:
	* gtk/gtksettings.c:
	* gtk/gtktreemodel.c:
	* gtk/gtktreemodelsort.c:
	* gtk/gtktreeselection.c:
	* gtk/gtktreestore.c:
	* gtk/gtktreeview.c:
	* gtk/gtktreeviewcolumn.c:
	* gtk/gtkwidget.c:
	* gtk/gtkwindow.c: Document 2.2 API additions. I'm not
	going to list all individual functions here; if you want to see
	the list, grep for "Since: 2.2".	

Tue Nov 26 13:07:56 2002  HideToshi Tajima  <hidetoshi.tajima@sun.com>

	* modules/input/gtkimcontextxim.c
	(gtk_im_context_xim_filter_keypress):
	Fix #99593: Fix a memory leak when XmbLookupString returns
	XBufferOverflow

2002-11-26  Daniel Elstner  <daniel.elstner@gmx.net>

	* gtk/gtktoolbar.c (elide_underscores): Fix nasty typo (#99653):
	strlen (original + 1) -> strlen (original) + 1

Tue Nov 26 22:26:04 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtk{tree,list}store.c (gtk_{tree,list}_store_real_set_value):
	add a gtk_list_store_sort_iter_changed line for some special
	case ... (#96647 (issue 1), testcases from Soeren Sandmann and
	Daniel Elstner).

Tue Nov 26 22:18:06 2002  Kristian Rietveld  <kris@gtk.org>

	Inconsistent state for toggle renderers, requested by Paolo Bacchilega
	in #88130.

	* gtk/gtktreeprivate.h: move GtkCellRendererInfo here.

	* gtk/gtkcellrenderer.c: moved GtkCellRendererInfo away,
	fix some indentation issues.

	* gtk/gtkcellrenderertoggle.c (gtk_cell_renderer_toggle_class_init),
	(gtk_cell_renderer_toggle_set_property),
	(gtk_cell_renderer_toggle_get_property),
	(gtk_cell_renderer_toggle_render): add an inconsistent property.

	* gtk/gtkstyle.c (gtk_default_draw_check),
	(gtk_default_draw_option): support drawing inconsistent
	options/checks for cells.

Tue Nov 26 22:14:14 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkcellrenderertext.c (gtk_cell_renderer_text_editing_done),
	(gtk_cell_renderer_text_start_editing): add a focus_out_id to avoid
	calling _editing_done twice (which has nasty side-effects). (#96647,
	(issue 2) testcase from Soeren Sandmann).

Tue Nov 26 22:12:21 2002  Kristian Rietveld  <kris@gtk.org>

	#82739, patch from Padraig O'Briain.

	* gtk/gtktreeviewcolumn.[ch]: add
	gtk_tree_view_column_cell_get_position()

Tue Nov 26 22:06:29 2002  Kristian Rietveld  <kris@gtk.org>

	Yes, this chunk breaks ABI compatibility. Owen knows about it and
	agreed with it. It doesn't break ABI that bad though, things will
	still work. Please keep it silent :P.

	This patch fixes some keynav issues reported by Narayana Pattipati
	in #81633. (Also mentioned in #92037 (Sun tracking bug)).

	* gtk/gtkmarshalers.list: add two silly marshalers

	* gtk/gtktreeview.[ch] (gtk_tree_view_real_select_all),
	(gtk_tree_view_real_unselect_all),
	(gtk_tree_view_real_select_cursor_row),
	(gtk_tree_view_real_toggle_cursor_row),
	(gtk_tree_view_real_expand_collapse_cursor_row),
	(gtk_tree_view_real_start_interactive_search): change the return
	type from void to gboolean, update prototypes, functions, signals and
	entries in GtkTreeViewClass,
	(gtk_tree_view_class_init): add select_cursor_row binding for
	enter key,
	(gtk_tree_view_key_press): only navigate the header button if the
	header is also visible ...

Tue Nov 26 22:05:48 2002  Kristian Rietveld  <kris@gtk.org>

	API bit of #75745, reported by Richard Hult.

	* gtk/gtkcellrenderer.h (GtkCellRendererState): add
	GTK_CELL_RENDERER_FOCUSED, rest of this bug fix will follow later.

Tue Nov 26 18:28:58 GMT 2002  Tony Gale <gale@gtk.org>

	* docs/tutorial/package-db-tutorial.sh:
	(see #71679) create split package files

Tue Nov 26 01:55:47 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkprogressbar.c (gtk_progress_bar_paint_text): don't offset
	one pixel when calculating the x position of the text.

Tue Nov 26 00:40:53 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkprogressbar.c (gtk_progress_bar_paint_text): draw text
	twice, once with the prelight state and clipped to the progress
	bar, and once with the normal state and clipped to the visible
	part of the trough. Also fix a spelling error pointed out by
	Matthias Clasen.

Mon Nov 25 17:44:09 2002  Owen Taylor  <otaylor@redhat.com>

	Fixes from #98358, Havoc Pennington.

	* gdk/{x11,win32,linux-fb}/gdkcolor-*.c (gdk_colormap_finalize): 
	Free the private structure.

	* gdk/x11,win32,linxu-fb}/gdkscreen-*.c (gdk_screen_set_default_colormap):
	  gdk/x11/gdkwindow-x11.c (_gdk_windowing_window_init): 
	Keep a ref to the default colormap.

	* gdk/x11/gdkscreen-x11.c (gdk_screen_x11_dispose): Unref
	the default colormap.

	* gdk/x11/gdkwindow-x11.c (gdk_window_impl_x11_set_colormap):
	Handle the CMAP == NULL case even when the window is
	destroyed.

	* gdk/x11/gdkwindow-x11.c (_gdk_windowing_window_init):
	Add a missing ref for the system colormap. 

Mon Nov 25 17:10:54 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksettings.c (gtk_settings_set_property_value): 
	Fix missing adjustments for new type of
	gtk_settings_set_property_value_internal(). (#99436,
	Iain Holmes.)

	* gtk/gtksettings.c (apply_queued_setting): Set the
	source _after_ we call g_object_set_property, or otherwise
	we get the APPLICATION source from our setter 
	implemenatation.

2002-11-25  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkevents-win32.c (print_event_state,
	print_window_state, print_event): Enclose in #ifdef
	G_ENABLE_DEBUG, as they use functions only available with
	G_ENABLE_DEBUG, and are called only when G_ENABLE_DEBUG. (#99494,
	Arnaud Charlet)

Mon Nov 25 16:58:27 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c: Use _NET_WM_WINDOW_TYPE_SPLASH,
	not TYPE_SPLASHSCREEN. (#99482, Gregory Merchan)

2002-11-25  Matthias Clasen  <maclas@gmx.de>

 	* docs/tutorial/gtk-tut.sgml: Fix the ftp download url.
	
Mon Nov 25 19:10:54 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkprogressbar.c: Style improvements that I forgot about
	in last commit.	

Mon Nov 25 18:56:55 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkprogressbar.c (gtk_progress_bar_paint): Break this
	function into simpler functions:
	gtk_progress_bar_paint_text(), gtk_progress_bar_paint_discrete(),
	gtk_progress_bar_paint_continous(),
	gtk_progress_bar_paint_activity().

Mon Nov 25 12:34:44 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdialog.c (gtk_dialog_set_default_response): 
	Remove code to grab the focus here, it is no longer
	needed since we focus a widget on map, and can cause
	harm. (#99048, Daniel Elstner)

2002-11-24  Tor Lillqvist  <tml@iki.fi>

	Merge from stable:
	
	Implement tiles and stipples for all drawing methids (except the
	deprecated draw_text() and draw_text_wc()).

	* gdk/win32/gdkdrawable-win32.c: Remove the already ifdeffed-out
	code that didn't use generic_draw().

	(generic_draw): When drawing into the mask (for tiled/stippled
	fill styles), copy the line attributes from the actual GC. Also
	ask for text drawing setup if needed. Use differently set up HDCs
	in the normal and tiled/stippled cases.

	(draw_lines, gdk_win32_draw_lines, draw_polygon,
	gdk_win32_draw_polygon, draw_segments, gdk_win32_draw_segments,
	draw_arc, gdk_win32_draw_arc): Use generic_draw(), thus
	implementing tiled and stippled fill styles for lines, polygons,
	segments, and args.

	(gdk_win32_draw_points): Use Rectangle() instead of
	SetPixel(). Rectangle() uses the function (raster op) set for the
	HDC, SetPixel() doesn't.

	(widen_bounds): New function, refactoring.
	
	* gdk/win32/gdkgc-win32.c: Remove ifdeffed-out code.

	(predraw_set_foreground, gdk_win32_hdc_get): Some code moved
	around. Call SetROP2() only if necessary. Call SetTextColor() only
	if GDK_GC_FOREGROUND flag present. Don't handle
	GDK_OPAQUE_STIPPLED here, has been superseded by the code in
	generic_draw(). Always create a solid brush.

	Remove background color handling from here. The background color
	of a GdkGC is supposed to affect only GDK_OPAQUE_STIPPLED fill
	style, which it is already handled in generic_draw(), and
	GDK_LINE_DOUBLE_DASH lines, which aren't implemented properly
	anyway. Calling SetBkColor() is unnecessary as we always use
	TRANSPARENT text output.

	(gdk_win32_hdc_get, gdk_win32_hdc_release): Add doc comments, as
	these are public functions.

	* gdk/win32/gdkevents-win32.c (synthesize_expose_events): Don't
	synthesize expose events for GDK_INPUT_ONLY windows.
	(gdk_event_translate): On WM_SIZE, call
	gdk_synthesize_window_state() if window was iconified, restored or
	maximized. (#98983, Arnaud Charlet)

	* gtk+/gdk/win32/gdkwindow-win32.c
	(gdk_window_get_frame_extents): Fix typo in setting y.  (#98983,
	Arnaud Charlet)

2002-11-23  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkcursor-x11.c (gdk_cursor_new_from_pixmap): 
	Remove period from title of example in docs.

2002-11-21 15:43:54 2002 Dan Mills  <thunder@ximian.com>

	* configure.in: replace gtk-doc version check with an all-sh
	version that works better,
	also up the required gtk-doc version to 0.10 (#99216).

2002-11-21  Matthias Clasen  <maclas@gmx.de>

	* configure.in: Generate docs/reference/*/version.xml.

	* gtk/gtkwidget.c (gtk_widget_get_ancestor): Add a note about
	reflexive ancestry.  (#99085, Frederic Lespez)

	* docs/tutorial/gtk-tut.sgml: 
	* examples/calendar/calendar.c: Numerous fixes to the calendar 
	example.  (#97956, Owen Taylor)

	* gtk/gtktreeview.c (gtk_tree_view_set_cursor): Fix doc 
	comment typos.  (#97432, Vitaly Tishkov)

	* gtk/gtktreemodel.c (gtk_tree_model_iter_nth_child): Fix doc 
	comment typos.  (#98158, Vitaly Tishkov)

	* gtk/gtkmenu.c (gtk_menu_set_screen): Fix doc comment
	typos.  (#98480, Vitaly Tishkov)

Wed Nov 20 23:13:19 2002  Kristian Rietveld  <kris@gtk.org>

	* docs/RELEASE-HOWTO: small tweaks.

Wed Nov 20 19:29:50 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkrbtree.c (gtk_rbtree_reorder_sort_func): return a value
	in the range of [-1, 1] instead [0, 1],
	(gtk_rbtree_reorder_invert_func): ditto,
	This makes treeview reordering working on platforms as FreeBSD and
	solaris, thanks go to Heiner Eichmann for finding this out and
	sending in a patch (#98251).

Wed Nov 20 19:27:07 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreestore.c (node_free): only free the data list if
	node->data is not NULL,
	(gtk_tree_store_remove): free the data list from the node if
	needed. (#94728, pointed out by Peter Bloomfield).

Wed Nov 20 19:23:13 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_remove_column): stop editing
	and set the edited_column to NULL if edited_column is set.
	(#91288, modified patch from Josh Parsons).

Wed Nov 20 19:20:34 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_size_allocate): do a full
	redraw if vadjustment->value is bigger than tree_view->priv->height,
	(gtk_tree_view_row_deleted): free the row ref if it isn't valid
	anymore. (#83726, reported by Robert Kinsella).

Tue Nov 19 17:05:51 2002 Manish Singh  <yosh@gimp.org>

	* gtk/Makefile.am: add -DGTK_DISABLE_DEPRECATED. #undef it at the
	top of gtktypebuiltins.c.

	* gtk/gtkclist.c
	* gtk/gtkcombo.c
	* gtk/gtkctree.c
	* gtk/gtklist.c
	* gtk/gtklistitem.c
	* gtk/gtkoldeditable.c
	* gtk/gtkpixmap.c
	* gtk/gtkpreview.c
	* gtk/gtksignal.c
	* gtk/gtktext.c
	* gtk/gtktipsquery.c
	* gtk/gtktree.c
	* gtk/gtktreeitem.c
	* gtk/gtktypeutils.c: #undef GTK_DISABLE_DEPRECATED, deprecated widgets
	and compat code.

	* gtk/gtkcolorsel.c: move gtk_color_selection_set_color implementation
	to set_color_internal, and use that. The deprecated function now
	merely wraps it.

	* gtk/gtkfontsel.c: same as above, except with
	gtk_font_selection_get_font.

	* gtk/gtknotebook.c: same as above, except with
	gtk_notebook_set_homogeneous, and gtk_notebook_set_tab_{border,
	hborder,vborder}.

	* gtk/gtkprogressbar.c: same as above, except with
	gtk_progress_bar_set_{bar_stype,discrete_blocks,activity_step,
	activity_blocks}.

	* gtk/gtkstyle.c: same as above, except with gtk_style_get_font.

	* gtk/gtkwidget.c: same as above, except with gtk_widget_set_usize.

	* gtk/gtkitemfactory.h: declare compatibility functions for deprecated
	GtkMenuFactory stuff if GTK_COMPILATION, since they are used
	internally by the compat code.

	* gtk/gtkitemfactory.c (gtk_item_factory_create_item): remove
	use of deprecated gtk_check_menu_item_set_show_toggle (it is a noop
	now).

	* gtk/gtkmain.c: replaced deprecated GTK_TYPE_* with G_TYPE_*.

	* gtk/gtkobject.c: replaced various deprecated functions. In set and
	get_property, use g_object_{set,get}_data with "user_data" instead
	of gtk_object_{set,get}_user_data.

	* gtk/gtkprogress.h: API declared if GTK_COMPILATION

	* gtk/gtkprogress.c: port get_type to GObject API.

	* gtk/gtktypeutils.h: declare GtkArg stuff and gtk_type_init,
	if GTK_COMPILATION.

	* gtk/gtkwidget.c: define gtk_widget_queue_clear in terms of
	gtk_widget_queue_draw instead of the other way around.

	* tests/Makefile.am: define -DGTK_DISABLE_DEPRECATED

	* tests/testgtk.c
	* tests/testselection.c
	* tests/testsocket.c: #undef GTK_DISABLE_DEPRECATED, makes use of
	deprecated stuff.

Tue Nov 19 17:01:40 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtktreeselection.c (gtk_tree_selection_real_modify_range):
	initialize anchor_path to NULL.

	* examples/buttonbox/buttonbox.c: remove useless static qualifier.

2002-11-19  Matthias Clasen  <maclas@gmx.de>

	* tests/testgtk.c (do_bench): 
	(do_real_bench): 
	(bench_iteration): Add a dummy widget and pass it as first
	argument to the various create functions when in --bench mode, 
	since these call gtk_widget_get_screen () on their first argument.

Mon Nov 18 17:15:07 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkwindow-decorate.c (gtk_decorated_window_paint): use
	gdk_drawable_get_size instead of gdk_window_get_size. Fixes
	#98957.

Tue Nov 19 00:45:34 2002  Kristian Rietveld  <kris@gtk.org>

	* docs/RELEASE-HOWTO: new file describing the release process.

	* docs/Makefile.am: added RELEASE-HOWTO to EXTRA_DIST.
	
Mon Nov 18 18:15:56 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksettings.c (gtk_settings_get_property): Clean up
	a bit of duplicated code.

Mon Nov 18 20:42:27 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_expand_to_path): modify and
	free tmp instead of path ... (patch from #97927).

Mon Nov 18 20:31:20 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkcellrenderertext.c (gtk_cell_renderer_text_start_editing):
	only _set_text if celltext->text is not NULL. (#97815, reported
	and testcase provided by Vitaly Tishkov).

Mon Nov 18 20:28:28 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeselection.c (gtk_tree_selection_real_modify_range):
	also update the anchor_path, makes behaviour consistent with the
	other selection modification functions. (#96801, reported and
	testcase provided by Vitaly Tishkov).

Mon Nov 18 20:17:56 2002  Kristian Rietveld  <kris@gtk.org>

	Hrm, this fixes up lots of mistakes in my swap/move code ... Some
	of these mistakes where pointed out by Vitaly Tishkov in bugs
	#97403, #97404, #97412, #97618.

	* gtktreestore.[ch]: gtk_tree_store_move is now private, use
	gtk_tree_store_move_{before,after} instead now. Lots of fixes
	(more like a rewrite :) in the _move and _swap functions.

	* gtkliststore.[ch]: likewise.
	
2002-11-18  Abigail Brady  <morwen@evilmagic.org>

	* gtk/gtkimmodule.c: (_gtk_im_module_list): Sort the list of Input 
	Modules	by name, keeping Default at top.

Sun Nov 17 13:45:08 2002  Manish Singh  <yosh@gimp.org>

	* gdk/Makefile.am: add -DGDK_DISABLE_DEPRECATED

	* gdk/gdk.c (gdk_exit): remove obsolete comment

	* gdk/gdk.h: declare gdk_input_add_full if GTK_COMPILATION for
	gtk_input_add_full

	* gdk/gdkcolor.c (gdk_color_white, gdk_color_black): use
	gdk_colormap_alloc_color instead of gdk_color_alloc

	* gdk/gdkcolor.h: declare gdk_colormap_change if GDK_COMPILATION for
	gdk_colors_store. Also, gdk_colors_{alloc,free} for
	gdk_rgb_try_colormap

	* gdk/gdkdrawable.h: declare gdk_draw_string if GTK_COMPILATION for
	gtk_default_draw_string. Also, gdk_draw_text and gdk_draw_text_wc
	if GDK_COMPILATION for the respective gdk_window_ and gdk_pixmap_
	functions.

	* gdk/gdkfont.c: #undef GDK_DISABLE_DEPRECATED, completely compat
	code here

	* gdk/gdkfont.h: allow the GdkFont structure and a few gdk_font_
	functions for compat code in GDK_COMPILATION and GTK_COMPILATION.

	* gdk/gdkrgb.c (gdk_rgb_cmap_fail, gdk_rgb_try_colormap): use
	gdk_colormap_free_colors instead of gdk_colors_free.

	* gdk/gdkrgb.c (gdk_draw_rgb_image_core): no need to set fg/bg
	for own_gc, unused.

	* gdk/gdkwindow.h: declare gdk_window_get_deskrelative_origin if
	GTK_COMPILATION for gtk_handle_box_button_changed.

	* gdk/x11/Makefile.am: add -DGDK_DISABLE_DEPRECATED, renmae
	-DINSIDE_GDK_X11 to -DGDK_COMPILATION

	* gdk/x11/gdkcolor-x11.c: remove duplicate doc string for
	gdk_colormap_alloc_colors.

	* gdk/x11/gdkfont-x11.c:  #undef GDK_DISABLE_DEPRECATED, completely
	compat code here

	* gdk/x11/gdkx.h: use GDK_COMPILATION instead of INSIDE_GDK_X11,
	allow a few gdk_x11_font_ functions if GDK_COMPILATION for compat
	code

	* gtk/Makefile.am: add -DGDK_DISABLE_DEPRECATED

	* gtk/gtkclist.c
	* gtk/gtkctree.c
	* gtk/gtkpixmap.c
	* gtk/gtkpreview.c
	* gtk/gtktext.c: #undef GDK_DISABLE_DEPRECATED, deprecated widget

	* gtk/gtkhandlebox.c (gtk_handle_box_motion): use
	gdk_window_set_geometry_hints instead of gdk_window_set_hints.

	* gtk/gtkmain.c (gtk_exit): call exit directly

	* gtktipsquery.c (gtk_tips_query_real_start_query)
	* gtk/gtktreeitem.c (gtk_tree_item_add_pixmaps): remove some
	deprecated GDK usage.

Sun Nov 17 10:49:28 2002  Jonathan Blandford  <jrb@gnome.org>

	* gtk/gtksettings.c (gtk_settings_get_property): remove bogus
	gvalue initialization/freeing.

2002-11-16  Tor Lillqvist  <tml@iki.fi>

	* gdk/gdk.def: Add missing entries, needed by gtk.

	* gdk/win32/gdkcolor-win32.c (gdk_screen_get_system_colormap):
	Remove g_return_val_if_fail call. This function is called from
	gdk_display_open() with the _gdk_screen it just created, but when
	gdk_screen_get_default() still returns NULL.

	* gdk/win32/gdkdisplay-win32.c
	* gdk/win32/gdkscreen-win32.c: Make more like the linux-fb
	versions. For instance, don't call
	gdk_display_manager_set_default_display() from gdk_display_open().

	* gdk/win32/gdkglobals-win32.c: Move _gdk_display, _gdk_screen and
	_gdk_parent_root here.

	* gdk/win32/gdkinput.c (gdk_display_list_devices): New function.

	* gdk/win32/gdkmain-win32.c (gdk_get_display): New function.

	* gdk/win32/gdkvisual-win32.c (gdk_screen_get_system_visual):
	Don't require that the screen parameter is non-NULL. It can be,
	and the linux-fb version doesn't check either.
	
	* gdk/win32/gdkwindow-win32.c (gdk_window_set_skip_taskbar_hint,
	gdk_window_set_skip_pager_hint, gdk_window_fullscreen,
	gdk_window_unfullscreen): Implement as no-ops.

	* gtk/gtk.def: Remove obsolete entries.

Fri Nov 15 19:12:56 2002  Jonathan Blandford  <jrb@gnome.org>

	* gtk/gtksettings.c: Allow g_object_set to work with GtkSettings.

2002-11-15  Tor Lillqvist  <tml@iki.fi>

	* gdk/gdk.def: Reflect recent renamings and removals of functions. 
	
	Merge from stable:
	
	Start implementing all fill styles (i.e. tiled, stippled, and
	opaque stippled in addition to the plain solid style) in the Win32
	backend in an elegant and generic way. For now only did the
	draw_rectangle() and draw_glyphs() methods. The rest will
	follow. Previously some of the drawing methods implemented opaque
	stippling, but not tiles or non-opaque stippling.

	Seems to work fine, now the check marks show up in check buttons,
	the stippled background and stippled text in gtk-demo's Text
	Widget look as they should, and GtkText's line wrap arrow shows
	correctly instead of an ugly rectangle.

	The implementation does do a lot of pixmap handling and blitting
	back and forth, especially on Win9x. But performance is hopefully
	not an issue. I don't think many applications do a lot of tiled or
	stippled drawing.

	* gdk/win32/gdkprivate-win32.h: Define a new macro, GDI_CALL, that
	calls a GDI function and prints a warning if it failed. Also
	API_CALL for non-GDI calls. Cleans all the the if (!BlaBla())
	WIN32_GDI_FAILED ("BlaBla") snippets, these can now be written
	GDI_CALL (BlaBla, ()). Declare new functions.

	* gdk/win32/gdkdrawable-win32.c: Use GDI_CALL macro in lots of places.

	(generic_draw): New function that handles all the blitting
	necessary to implement tiles and stipples. A function that
	actually draws stuff is passed as a parameter to
	generic_draw(). If the fill style is solid, it is called
	directly, to draw on the destination drawable. Otherwise it is
	called to draw on a temporary mask bitmap, which then is used in
	blitting operations. The tiles and/or stipples are rendered into
	another temporary pixmap. If MaskBlt() is available (on NT/2k/XP),
	it is used, otherwise a sequence of BitBlt() is used to do the
	final composition onto the destination drawable.

	(draw_tiles_lowlevel, draw_tiles): Some renaming and code
	reorg. Use BitBlt() to blit each tile, not gdk_draw_drawable().

	(rop2_to_rop3): New function, does binary->ternary rop mapping.

	(blit_from_pixmap, blit_inside_window, blit_from_window): Use
	rop2_to_rop3(). Previously used SRCCOPY always...

	(draw_rectangle, gdk_win32_draw_rectangle, draw_glyphs,
	gdk_win32_draw_glyphs): Split functionality into two functions,
	with generic_draw() doing its magic inbetween.

	* gdk/win32/gdkevents-win32.c: Remove the TrackMouseEvent code, it
	was ifdeffed out and wouldn't have done anything even if
	enabled. Remove the GDK_EVENT_FUNC_FROM_WINDOW_PROC code, didn't
	have any effect any more anyway after all the changes GTK+ has
	gone through in the last years. Remove some #if 0 code.

	* gdk/win32/gdkgc-win32.c (gdk_gc_copy): Set the copy's hdc field
	to NULL in case a GC is copied while it has a Windows DC active.

	* gdk/win32/gdkprivate-win32.h
	* gdk/win32/gdkglobals-win32.c: Remove gdk_event_func_from_window_proc.
	
	* gdk/win32/gdkmain-win32.c: Remove -event-func-from-window-proc
	option. If there is a PRETEND_WIN9X envvar, set windows_version as
	if on Win9x.

	* gdk/win32/gdkpixmap-win32.c (_gdk_win32_pixmap_new,
	gdk_pixmap_new): Combine these two, _gdk_win32_pixmap_new() wasn't
	used or exported. Make a bit more like the X11 version. Hopefully
	I didn't break the fragile palettized display ("pseudocolor")
	code.

	* gdk/win32/gdkgc-win32.c: Various debugging output improvements.
	
	(predraw_set_foreground): Check whether
	tile/stipple origins are valid when calling SetBrushOrgEx().

	(gdk_win32_hdc_get): Ifdef out code that tries to handle the
	stipple by converting it into a region, and combining the clip
	region with that. A stipple shouldn't work like that, it should
	replicate in x and y directions. Stipples are now handled by
	generic_draw() in gdkdrawable-win32.c.

	* gdk/win32/gdkmain-win32.c: (gdk_win32_gcvalues_mask_to_string,
	gdk_win32_rop2_to_string): New debugging functions.

	(gdk_win32_print_dc): Print also DC's rop2 and text color.

Thu Nov 14 14:58:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (gdk_window_set_icon_name): 
	Fix display/window typo. (#98511, Soeren Sandmann)

Fri Nov  8 18:04:16 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/{linux-fb,win32,11}/Makefile.am: Try a different
	hack to force gdkenumtypes.h to be updated before
	building the subdir, last hack caused contents
	to be rebuilt on every make.

Wed Nov 13 21:45:36 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkhsv.c: get rid of deprecated gdk_rgb_gc_set_foreground
	usage in favor of gdk_gc_set_rgb_fg_color.

Thu Nov 14 00:33:26 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (attach_widget_screen_changed): Monitor
	the screen of the attach widget continually, rather than only 
	setting the screen only on popup (#85710)

	* gtk/gtkmenu.c (gtk_menu_set_screen): Allow %NULL to
	go back to getting the screen from the attach widget.

Wed Nov 13 17:03:19 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcombo.c: Change so that updates of selection
	don't take effect immediately, but only when popdown
	is closed with a button release within the combo
	or Return/Enter.

	* gtk/gtkcombo.c: Support Alt-Down to pop down the 
	combo, Alt-Up to pop it back up, Space to immediately 
	select current item.
	
	* gtk/gtkcombo.c (gtk_combo_entry_key_press): Don't
	move the focus when we get to the ends of the list
	entries.

	* gtk/gtkcombo.c: Fix handling of state in ad-hoc 
	keybinding handling to be a bit more reasonable.

	* gtk/gtkcombo.c (gtk_combo_popup_list): Clear 
	last_focus_child when no item is selected so we 
	don't start focusing from some random place.

	* gtk/gtkcombo.c (gtk_combo_init): Make
	gtk_combo_set_use_arrows_always, enable_arrows_always 
	properties have no effect, they were an awful idea.
	Always behave as if enable_arrows_always is true.

	* gtk/gtknotebook.c: Fix a warning.

Wed Nov 13 13:50:25 2002  Eric Warmenhoven <warmenhoven@yahoo.com>

	* gdk/linux-fb/gdkinput.c: add gdk_display_get_devices to fix
	compilation

Wed Nov 13 15:52:53 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcombo.c (gtk_combo_activate): Fix warning.
	
	* gtk/gtkcombo.c: Fix code that was meant to delay
	grabbing events on the list until we had an enter-notify.
	(#54353, reported by Mike Fulbright, others)

2002-11-13  Matthias Clasen  <maclas@gmx.de>

	* gtk/theme-bits/decompose-bits.c (do_part): Add a const here.

	* gtk/gtkcolorsel.c: 
	* gtk/gtkimcontextsimple.c: 
	* gtk/gtkstyle.c: Mark constant data as const to give the compiler
	a chance to put it in a readonly section.  (#75754)

Wed Nov 13 10:53:37 2002  HideToshi Tajima  <hidetoshi.tajima@sun.com>

	* modules/input/gtkimcontextxim.c:
	Fix #90661: add im_info->im switch at the top of setup_im() and
	get_ic_real().
	Fix #97674: make sure only one status window for the focused
	input context should be shown.

Wed Nov 13 11:55:25 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_button_press): 
	When clicking on a non-active tab, focus the first
	widget in the tab, not the tab itself. (#98322)

	* gtk/gtknotebook.c (gtk_notebook_focus_changed):
	Eliminate synchronous drawing, just call redraw_tabs.
	
	* gtk/gtknotebook.c (gtk_notebook_init): Don't set
	the RECEIVES_DEFAULT flag, we no longer do anything
	with Return/Enter key.

Tue Nov 12 17:10:10 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcombo.c: Fix up grabs to be robust; grab
	the keyboard as well as the pointer so we won't
	leave the window behind if the user switches desktops
	with a keyboard combination. (Based on a patch
	from Matthias Clasen, #82525)

Wed Nov 13 14:01:44 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkstyle.c: 

          - comment out check_inconsistent_aa_bits[].

          - use fg/bg with a generated aa color to draw check and option
	    marks in menu items.

	  - use text/base to draw check and option buttons, except when
	    state is ACTIVE, in which case we use fg/bg with a generated
	    aa color.

	* tests/testgtk.c (menu_items): Add three check items.
	
2002-11-12  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkprivate-win32.h
	* gdk/win32/*.c: Rename all global variables and functions to
	start with underscore.

	Merge from stable:
	
	More work on the Win32 backend. The cause of some scrolling
	problems was that SetWindowPos() and ScrollWindowEx() don't blit
	those parts of the window they think are invalid. As we didn't
	keep Windows's update region in synch with GDK's, Windows thought
	those areas that in fact had been updated were invalid. Calling
	ValidateRgn() in _gdk_windowing_window_queue_antiexpose() seems to
	be an elegant and efficient solution, removing from Windows's
	update region those areas we are about to repaint proactively.

	In some cases garbage leftover values were used for the clip
	origin in GdkGCWin32. This showed up as odd blank areas around the
	pixmaps included in the Text Widget in gtk-demo.

	Having the clip region either as a GdkRegion or a HRGN in
	GdkGCWin32 was unnecessary, it's better to just use a HRGN.

	The translation and antiexpose queue handling in
	gdkgeometry-win32.c seems unnecessary (and not implementable in
	the same way as on X11 anyway, no serial numbers) on Windows,
	ifdeffed out.
	
	Don't (try to) do guffaw scrolling as there is no static window
	gravity on Windows. Guffaw scrolling would be unnecessary anyway,
	as there is the ScrollWindow() API. This improves the behaviour of
	the Text Widget demo in gtk-demo a lot. But I have no idea how the
	lack of static win gravity should be handled in other places where
	the X11 code uses it. Especially _gdk_window_move_resize_child().

	There is still some problem in expose handling. By moving an
	obscuring window back and forth over testgtk's main window, for
	instance, every now and then you typically get narrow vertical or
	horizontal strips of pixels that haven't been properly redrawn
	after being exposed. A fencepost error somewhere?

	Otherwise, all of testgtk and gtk-demo except "big windows" now
	seem to work pretty well. (Well, that is in the stable branch, I
	haven't really tested HEAD. Only checked that gdk/win32 compiles.)

	Bug #79720 should be fixed now.
	
	* gdk/win32/gdkcolor-win32.c (gdk_win32_color_to_string,
	gdk_win32_print_paletteentries, gdk_win32_print_system_palette,
	gdk_win32_print_hpalette)
	* gdk/win32/gdkdrawable-win32.c (gdk_win32_drawable_description)
	* gdk/win32/gdkevents-win32.c (gdk_win32_message_name):
	Move all debugging helper functions to gdkmain-win32.c.

	* gdk/win32/gdkdrawable-win32.c (_gdk_win32_draw_tiles):
	Rewrite. Make static. Must take tile origin parameters, too.

	(gdk_win32_draw_rectangle): Pass the tile/stipple origin to
	_gdk_win32_draw_tiles(). Remove #if 0 code.

	(blit_inside_window): Don't call ScrollDC(), that didn't work at
	all like I thought. A simple call to BitBlt() is enough.
	
	* gdk/win32/gdkevents-win32.c (gdk_event_translate) Remove unused
	latin_locale_loaded variable.

	(_gdk_win32_get_next_tick): New function. Used to make sure
	timestamps of events are always increasing, both in events
	generated from the window procedure and in events gotten via
	PeekMessage(). Not sure whether this is actually useful, but it
	seemed as a good idea.

	(real_window_procedure): Don't use a local GdkEventPrivate
	variable. Don't attempt any compression of configure or expose
	events here, handled elsewhere.

	(erase_background): Accumulate window offsets when traversing up
	the parent chain for GDK_PARENT_RELATIVE_BG, in order to get
	correct alignment of background pixmaps. Don't fill with
	BLACK_BRUSH if GDK_NO_BG.

	(gdk_event_get_graphics_expose): A bit more verbose debugging output.

	(gdk_event_translate): Use _gdk_win32_get_next_tick(). In the
	WM_PAINT handler, don't check for empty update rect. When we get a
	WM_PAINT, the update region isn't empty. And if it for some
	strange reason is, that will be handled later anyway. Call
	GetUpdateRgn() before calling BeginPaint() and EndPaint() (which
	empty the update region).

	* gdk/win32/gdkdnd-win32.c
	* gdk/win32/gdkinput-win32.c:
	Use _gdk_win32_get_next_tick().
	
	* gdk/win32/gdkfont-win32.c: Use %p to print HFONTs.

	(gdk_text_size): Remove, unused.

	* gdk/win32/gdkgc-win32.c:  Set clip origins to zero
	when appropriate.

	(gdk_gc_copy): Increase refcount on colormap if present.

	(gdk_win32_hdc_get): Handle just hcliprgn. If we have a stipple,
	combine it with clip region after selecting into the DC.

	(_gdk_win32_bitmap_to_hrgn): Rename from _gdk_win32_bitmap_to_region.

	(_gdk_win3_gdkregion_to_hrgn): New function, code snippet
	extracted from gdk_win32_hdc_get().

	* gdk/win32/gdkgeometry-win32.c: Ifdef out the translate_queue
	handling.

	(gdk_window_copy_area_scroll): Increase clipRect to avoid
	ScrollWindowEx() not scrolling pixels it thinks are invalid.
	Scroll also children with the ScrollWindowEx() call. No need to
	call gdk_window_move() on the children.

	(gdk_window_scroll): Don't do guffaw scrolling.

	(gdk_window_compute_position): Fix typo, used win32_y where x was
	intended.

	(gdk_window_premove, gdk_window_postmove,
	gdk_window_clip_changed): Add debugging output.

	(_gdk_windowing_window_queue_antiexpose): Just call ValidateRgn()
	on the region.

	(_gdk_window_process_expose): No use for the serial number
	parameter now. Instead of a rectangle, take a region parameter, as
	Windows gives us one in WM_PAINT.

	* gdk/win32/gdkmain-win32.c (_gdk_win32_lbstyle_to_string,
	_gdk_win32_pstype_to_string, _gdk_win32_psstyle_to_string,
	_gdk_win32_psendcap_to_string, _gdk_win32_psjoin_to_string,
	_gdk_win32_rect_to_string, _gdk_win32_gdkrectangle_to_string,
	_gdk_win32_gdkregion_to_string): New debugging functions.

	(static_printf): Helper function for the above. sprintfs into a
	static circular buffer, return value should be used "soon".

	* gdk/win32/gdkwindow-win32.c (gdk_propagate_shapes): Plug memory
	leak, free list after use.

	(gdk_window_gravity_works): Remove, we know that there is no such
	thing on Windows.

	(gdk_window_set_static_bit_gravity,
	gdk_window_set_static_win_gravity): Ditto, remove, they didn't do
	anything anyway.

	(_gdk_windowing_window_init, gdk_window_foreign_new): Call
	_gdk_window_init_position() like in the X11 backend.

	(gdk_window_reparent): Don't call the now nonexistent
	gdk_window_set_static_win_gravity(). No idea what should be done
	instead.

	(gdk_window_get_geometry): The returned x and y should be relative
	to parent. Used to be always zero..

	(gdk_window_set_static_gravities): Return FALSE if trying to set
	static gravity.
	
	* gdk/win32/gdkprivate-win32.h: Drop the clip_region field from
	GdkGCWin32. Only use the HRGN hcliprgn. Declare new
	functions.

	* gdk/win32/*.c: Use new debugging functions.

	* gdk/win32/rc/gdk.rc.in: Update copyright year.

Tue Nov 12 16:51:04 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkinputdialog.c: Make multihead aware (#80283)

Tue Nov 12 15:13:58 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c gtk/gtkwindow.[ch]: Add
	_gtk_window_unset_focus_and_default(), use to clear
	the focus and default out of parts of the widget
	heirarchy that we are hiding.

	* gtk/gtkwidget.c (gtk_widget_propagate_screen_changed_recurse): 
	Fix typo that was resulting in missed screen-change
	notifies.

	* gtk/gtkwindow.c (do_focus_change): Allow for
	widget->window == NULL.

	* gtk/gtklabel.c (gtk_label_screen_changed): Clear the
	layout here not in hierarchy changed to handle the case
	where the toplevel was moved between screens.

Tue Nov 12 14:20:53 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenu.c (gtk_menu_enter_notify): Do not return when
	menu_shell->ignore_enter is TRUE.

2002-11-10  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkstatusbar.c (gtk_statusbar_button_press): Don't start
	a drag on double click.  (#98189)

2002-11-10  Matthias Clasen  <maclas@gmx.de>

	* tests/testgtk.c (grippy_button_press): Also test moving.

Sun Nov 10 22:55:39 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenu.c (gtk_menu_enter_notify): Don't return after
	calling gtk_menu_handle_scrolling() when
	!menu_shell->ignore_enter.

Sun Nov 10 21:29:03 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkcheckbutton.c (gtk_real_check_button_draw_indicator): 
	* gtk/gtkradiobutton.c (gtk_radio_button_draw_indicator)

	Make sure check and option marks are drawn insensitive when the
	widgets are insensitive.

	(#92548, patch from Tim Evans)

Sun Nov 10 21:25:04 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkwidget.h (struct _GtkWidgetClass): Remove _gtk_reserved8
	to restore binary compatibility.

2002-11-10  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkwindow-x11.c (_gdk_moveresize_handle_event): Fix a
	typo which broke moveresize emulation.

Sat Nov  9 14:42:53 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_button_*): Block
	button presses/releases over the scroll arrows
	to avoid popping down the menu. (#73444, Ettore Perazzoli)

	* gtk/gtkmenu.c (gtk_menu_enter_notify): Obey the
	ignore_enter flag for scrolling as well.

	* gtk/gtkmenu.c (gtk_menu_stop_scrolling): Clear
	the upper_arrow_prelight, lower_arrow_prelight 
	flags.

	* gtk/gtkmenu.c: Tweak the scroll speeds,
	timeouts, and fast-scroll area to make things
	zippier. (#73445, Ettore Perazzoli)

2002-11-09  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkwidget.c (gtk_widget_class_init): Use the correct
	struct offset for the screen_changed signal.

Fri Nov  8 19:07:39 2002  Owen Taylor  <otaylor@redhat.com>

	* demos/Makefile.am (test-inline-pixbufs.h): Depend
	on gdk-pixbuf.loaders as well as gdk-pixbuf.csource.
	(#97096, Jeff Waugh)

2002-11-09  Matthias Clasen  <maclas@gmx.de>

	* tests/testgtk.c (create_resize_grips): Draw grips in all edges.

	* gdk/x11/gdkfont-x11.c (gdk_text_extents_wc): 
	(gdk_text_extents): 
	* gdk/gdkfont.c (gdk_string_extents): Reformulate doc comments to
	work around gtk-doc limitations.

Fri Nov  8 18:04:16 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/{linux-fb,win32,11}/Makefile.am: Add in a awful
	hack to force gdkenumtypes.h to be updated before
	building the subdir. (#86587)

Fri Nov  8 17:49:54 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_check_screen): Access
	window->screen through a function so we can provide
	an informative warning window window->screen is NULL.
	(#85703)
	
2002-11-08  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkcheckmenuitem.c
	(gtk_real_check_menu_item_draw_indicator): RTL flipping for check
	menu items.

	* tests/testtext.c (blink_timeout): Put into #ifdef DO_BLINK to
	avoid an unused static function.  (#97965)

	* gtk/gtktextiter.c (backward_line_leaving_caches_unmodified): 
	* gtk/gtkstyle.c (radio_aa_bits):
	(draw_spin_entry_shadow): #if-0-out unused static functions and
	variables.  (#97965) 

	* gtk/gtktextview.c (text_window_get_allocation): 
	* gtk/gtkcolorsel.c (gtk_color_selection_get_palette_size):
	(gtk_color_selection_get_palette_color):
	(gtk_color_selection_unset_palette_color): Remove unused static
	functions.  (#97965)

	* gtk/gtkcolorsel.c
	(gtk_color_selection_set_change_palette_with_screen_hook): Fix doc
	comment. 
	
Fri Nov  8 17:08:54 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (gdk_window_new): Use
	g_get_application_name() instead of g_get_prgname()
	as the default window title when set.
	
	* gdk/x11/gdkwindow-x11.c gdk/x11/gdkdisplay-x11.[ch]:x
	Set g_get_application_name() as the title for the
	leader window the first time we create a window
	pointing to it.

	* tests/testgtk.c (main): Call g_set_application_name();

	* configure.in (GDK_PIXBUF_VERSION): Require GLib-2.1.3

2002-11-08  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkstyle.c (gtk_default_draw_arrow): Improve drawing of RTL
	submenu indicators.

	* gtk/gtkoptionmenu.c (gtk_option_menu_paint): Fix drawing of RTL
	optionmenus by flipping the indicator_spacing.

Fri Nov  8 21:15:25 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* tests/Makefile.am: add testmenus.c, a program to test menus when
	items are dynamically added and removed.

Fri Nov  8 20:14:52 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* docs/reference/gdk/tmpl/dnd.sgml
	docs/reference/gdk/tmpl/drawing.sgml
	docs/reference/gdk/tmpl/gdk-unused.sgml
	docs/reference/gdk/tmpl/gdkdisplay.sgml
	docs/reference/gdk/tmpl/general.sgml
	docs/reference/gdk/tmpl/input_devices.sgml
	docs/reference/gdk/tmpl/selections.sgml
	docs/reference/gtk/tmpl/gtkcellrenderer.sgml
	docs/reference/gtk/tmpl/gtkcurve.sgml
	docs/reference/gtk/tmpl/gtkdnd.sgml
	docs/reference/gtk/tmpl/gtkitemfactory.sgml
	docs/reference/gtk/tmpl/gtkmenu.sgml
	docs/reference/gtk/tmpl/gtkoldeditable.sgml
	docs/reference/gtk/tmpl/gtkoptionmenu.sgml
	docs/reference/gtk/tmpl/gtkpreview.sgml
	docs/reference/gtk/tmpl/gtkselection.sgml
	docs/reference/gtk/tmpl/gtksocket.sgml
	docs/reference/gtk/tmpl/gtkstyle.sgml
	docs/reference/gtk/tmpl/gtktextbuffer.sgml
	docs/reference/gtk/tmpl/gtktreemodel.sgml
	docs/reference/gtk/tmpl/gtkwidget.sgml gdk/gdk.h gdk/gdkdisplay.c
	gdk/gdkdisplay.h gdk/gdkdnd.h gdk/gdkdraw.c gdk/gdkdrawable.h
	gdk/gdkinput.h gdk/gdkselection.h gdk/x11/gdkdisplay-x11.c
	gdk/x11/gdkdnd-x11.c gdk/x11/gdkselection-x11.c gtk/gtkcurve.h
	gtk/gtkdnd.h gtk/gtkitemfactory.c gtk/gtkitemfactory.h
	gtk/gtkmenu.h gtk/gtkoldeditable.c gtk/gtkoldeditable.h
	gtk/gtkoptionmenu.h gtk/gtkplug.c gtk/gtkplug.h gtk/gtkpreview.h
	gtk/gtkrange.h gtk/gtkselection.c gtk/gtkselection.h
	gtk/gtksocket.c gtk/gtksocket.h gtk/gtkstyle.c gtk/gtkstyle.h
	gtk/gtktextlayout.c gtk/gtktextlayout.h gtk/gtktreemodel.c
	gtk/gtktreemodel.h gtk/gtkwidget.h

	Trivial s/foo/foo_/ fixes to make gtk.h includable with -Wshadow
	without warnings. (#91680)
	
Thu Nov  7 16:13:41 2002  Eric Warmenhoven <eric@warmenhoven.org>

	* gdk/linux-fb/gdkscreen-fb.c: fix compilation

	* gdk/linux-fb/gdkmain-fb.c: prevent segfaults on shutdown

Thu Nov  7 18:50:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_get_pango_context): Note
	that get_pango_context() is not "until death does us
	part", but "until the screen changes".

	* gtk/gtkwidget.c (gtk_widget_create_pango_context): Add
	a MULTIHEAD warning.

	* gtk/gtkwidget.c (do_screen_change): Clear pango context
	for widget if set.

Thu Nov  7 18:09:42 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (open_new_dir): Escape invalid
	filename before printing it out, since it isn't
	a valid UTF-8 string. (#94676)

Thu Nov  7 17:18:06 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdrawable-x11.c (gdk_x11_draw_pixbuf): 
	Don't try to use render if we can't get a picture for 
	the drawable. (Fixes #97220, reported by
	Jamie Zawinski)

	* gtk/gtkimage.c: Force requisition calculation
	when we get a expose prior to size_request().
	(#91711, reported by Sven Neumann, debugging
	help from Matthias Clasen, Soeren Sandmann)

Thu Nov  7 16:45:54 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkx.h: Fix misplaced display_grab()/display_ungrab();
	they shouldn't have been deprecated.

2002-11-07  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdk.c (gdk_display_open_default_libgtk_only): Use
	g_return_val_if_fail in this non-void function.
	(gdk_init_check): Remove unused variable.

Thu Nov  7 15:42:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c (gtk_font_selection_get_font_description):
	If called when fontsel->face is NULL, just return
	"Sans 10". (#82745, Vitaly Tishkov)

Thu Nov  7 15:29:43 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimcontextsimple.c (check_hex): Use '_'
	not '-' in signal name to be consistent with
	what we do elsewhere (#97151, TOKUNAGA Hiroyuki)

Thu Nov  7 14:51:31 2002  Owen Taylor  <otaylor@redhat.com>

	* tests/testcalendar.c (calendar_date_to_string): 
	Use g_date_strftime(), fixing #74745. (Alper Ersoy)

2002-11-07  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkhpaned.c: (gtk_hpaned_size_allocate):
	* gtk/gtkvpaned.c: (gtk_vpaned_size_allocate):
	Check for NULL children, #97913.
	
Thu Nov  7 14:24:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkhandlebox.c: Add a snap_edge_set property to
	deal with the fact that we have an unset state for
	the snap_edge property. (Reported by Matthias Clasen
	#97505)
	
Thu Nov  7 12:53:08 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.[ch] gtk/gtkwindow.c gtk/gtkinvisible.c: 
	Add ::screen-changed signal.

	* gtk/gtkfontsel.c gtk/gtktoolbar.c: Use ::screen-changed
	signal to simplify logic.

2002-11-07  Anders Carlsson  <andersca@gnu.org>

	* tests/testgtk.c (create_resize_grips): Add resize grips test.

Sun Nov  3 21:26:20 2002  Kristian Rietveld  <kris@gtk.org>

	Bah, and of course I broke something ...

	* gtk/gtktreeselection.c (gtk_tree_selection_selected_foreach): fix
	up the mess I caused with my commit of Oct 23 fixing #50263, things
	should be fine now.

Sun Nov  3 13:03:29 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c configure.in: Remove check for
	winsock.h since it might show up on Linux+Wine.
	Instead just conditionalize of G_OS_WIN32.
	(#97396, Gaute Lindkvist)

Sun Nov  3 01:39:20 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodel.c (release_row_references): took out the useless
	check for refs->list (#97353, reported by Morten Welinder).

	* gtk/gtkcellrendererpixbuf.c (gtk_cell_renderer_pixbuf_get_size):
	check if width isn't zero instead of calc_width ...

Sat Nov  2 23:48:52 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_set_model): remove
	the second ref command on the child_model, we only have to ref it
	once here. (#96851, reported by Jorn Baayen).

2002-11-02  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkhandlebox.c (effective_handle_position): 
	(gtk_handle_box_size_request): 
	(gtk_handle_box_size_allocate): 
	(gtk_handle_box_draw_ghost): 
	(gtk_handle_box_paint): 
	(gtk_handle_box_button_changed): 
	(gtk_handle_box_motion): 
	Flip handleboxes for RTL locales.  (#96629)

Sat Nov  2 13:47:09 2002  Owen Taylor  <otaylor@redhat.com>
	 
	* === Released 2.1.2 ===

	* NEWS: Update.

Sat Nov  2 00:22:33 2002  Owen Taylor  <otaylor@redhat.com>

	Add startup notification hooks - mostly based on patch
	by Havoc Pennington in #96772.
	
	* gdk/gdk.h gdk/x11/gdkdisplay-x11.c 
	gdk/{win32,linux-fb}/gdkmain-*.c: (gdk_notify_startup_complete):
	new function that indicates an application has finished starting
	up.
	
	* gdk/x11/gdkmain-x11.c gdk/x11/gdkdisplay-x11.c
	(_gdk_windowing_set_default_display): store value of 
	DESKTOP_STARTUP_ID on the default screen, and clear it from the 
	environment.
	
	* gdk/x11/gdkdisplay-x11.c: 
	Set _NET_STARTUP_ID hint on display's group leader window.
	
	* gtk/gtkwindow.c (gtk_window_set_auto_startup_notification):
	function to toggle whether we automatically broadcast that we've
	started up, after mapping the first toplevel window.
	(gtk_window_map): call gdk_screen_notify_startup_complete() by
	default, unless enabled by above.

	* gtk/gtkmain.c gtk/gtkcombo.c gtk/gtktoolbar.c: 
	Couple of warning fixes.

Fri Nov  1 21:03:59 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c: Add a mnemonic to the "selection"
	label. (More of #74267)

	* configure.in: Version 2.1.2

	* NEWS: Updates.

2002-11-02  Matthias Clasen  <maclas@gmx.de>

	* gtk/stock-icons/stock_jump_to_rtl_16.png,
	* gtk/stock-icons/stock_jump_to_rtl_24.png: Mirrored variants
	of stock_jump_to.
	
	* gtk/stock-icons/Makefile.am: 
	* gtk/gtkiconfactory.c (get_default_icons): Flip GTK_STOCK_FIRST,
	GTK_STOCK_LAST and GTK_STOCK_JUMP_TO for RTL locales.  (#96633)

	* gtk/gtkaccellabel.c (gtk_accel_label_expose_event): 
	Flip accel labels for RTL locales.  (#96637)
	
	* gtk/gtktearoffmenuitem.c (gtk_tearoff_menu_item_paint): 
	* gtk/gtkradiomenuitem.c (gtk_radio_menu_item_draw_indicator): 
	* gtk/gtkimagemenuitem.c (gtk_image_menu_item_size_allocate): 
	* gtk/gtkmenuitem.c (gtk_menu_item_init): 
	(gtk_menu_item_size_request): 
	(gtk_menu_item_size_allocate): 
	(gtk_menu_item_paint): 
	(gtk_menu_item_select_timeout): 
	(gtk_menu_item_position_menu): Flip all kinds of menu items for 
	RTL locales.  (#96637)

	* gtk/gtkstyle.c (gtk_default_draw_resize_grip): Support resize
	grips for all edges.  (#52833)

	* gtk/gtkstyle.c (gtk_default_draw_box): 
	* gtk/gtkoptionmenu.c (gtk_option_menu_size_allocate): 
	(gtk_option_menu_paint): Flip option menus for RTL 
	locales.  (#96631)

	* gtk/gtkmenubar.c (gtk_menu_bar_size_allocate): Flip menubars
	for RTL locales.  (#96627)

	* gtk/gtkprogressbar.c (gtk_progress_bar_act_mode_enter): 
	(gtk_progress_bar_paint): Flip progress bars for RTL 
	locales.  (#96634)

	* gtk/gtktoolbar.c (gtk_toolbar_size_allocate): Flip toolbars
	for RTL locales.  (#96626) 

2002-11-01  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkim-x11.c: 
	* gdk/gdkfont.c: 
	* gdk/x11/gdkfont-x11.c: 
	* gdk/gdkdraw.c: Some docs moved inline.

Thu Oct 31 17:41:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.c (gtk_tooltips_update_screen): Fix
	from Nam SungHyun for crashes when tooltips->active_tips_data
	is NULL.

Thu Oct 31 12:40:39 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.[ch] gdk/gdkglobals.c gdk/gdkinternals.h 
	gdk/{x11,win32,linux-fb}/gdkscreen-{x11,win32,linux-fb}.c:
	Add a --screen option for setting the default screen. 
	(Based on a patch from Balamurali Viswanathan, #81145)

	* gdk/gdk.c gdkdisplay.h gtk/gtkmain.c: Add 
	gdk_display_open_default_libgtk_only(), so gtk_init_check()
	and gdk_init_check() can share the same behavior w.r.t.
	--screen.

	* gdk/gdk.[ch]: Make gdk_get_display_arg_name() G_CONST_RETURN.

	* gdk/x11/gdkselection-x11.c (gdk_selection_property_get): 
	Suppress a spurious warning.

	* tests/testgtkrc: Remove someleft-over commented out 
	includes that could be confusing.

2002-10-31  Padraig O'Briain  <padraig.obriain@sun.com>

	* gtk/gtktoolbar.c (gtk_toolbar_insert_stock): Move g_free()
	call to before return.

2002-10-29  Matthias Clasen  <maclas@gmx.de>

	* tests/testgtkrc: Adjust for current gtk-engines.

	* gdk/x11/gdkcolor-x11.c (gdk_colors_free): Use the same parameter
	names in header, docs and implementation.

	* gdk/gdkcolor.c (gdk_colors_store): Doc comment fix.

	* gdk/x11/gdkcursor-x11.c (gdk_cursor_new_from_pixmap): Fix
	example in doc comment.

	* gtk/gtkiconfactory.c (gtk_icon_size_lookup_for_settings): 
	* gtk/gtkfilesel.c (gtk_file_selection_get_selections): Doc
	comment fixes.  (#97136, #97125, Vitaly Tishkov)

	* gtk/gtktreeselection.c (gtk_tree_selection_get_selected_rows): 
	* gtk/gtkwindow.c (gtk_window_set_default_icon_from_file): Doc
	comment fixes.  (#95829, #96818, Vitaly Tishkov)

Tue Oct 29 20:39:16 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenu.c: Change NAVIGATION_REGION_OVERSHOOT back to 50,
	and create stay-up regions by flipping a fourth quadrant triangle
	as appropriate.

2002-10-28  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkwindow-win32.c (gdk_window_set_decorations,
	gdk_window_set_functions): Don't call GetWindowLong for
	GWL_EXSTYLE, the extended window style wasn't used or
	changed. After setting the window style with SetWindowLong, call
	SetWindowPos with the SWP_FRAMECHANGED flag for the window to
	actually be updated, as Platform SDK docs say one should. (#95812,
	huzheng)

2002-10-28  Dmitry G. Mastrukov  <dmitry@taurussoft.org>

	* configure.in: Added Belorusian (be) to ALL_LINGUAS.

Sun Oct 27 15:58:30 2002  Kristian Rietveld  <kris@gtk.org>

	This fixes a scrolling bug. Shouldn't cause problems, but you
	never know ... (#81627, testcase by Timo Sirainen).

	* gtk/gtktreeview.c (validate_visible_area): add a temporary
	implemention for non use_align, always update dy and ->top_row
	if we scroll here,
	(gtk_tree_view_clamp_node_visible): reimplement using
	_scroll_to_cell (#73895).

Sun Oct 27 11:41:37 GMT 2002  Tony Gale <gale@gtk.org>

	* docs/tutorial/gtk-tut.sgml:
	minor cleanups, remove refs to gtk_menu_append

	*docs/faq/gtk-faq.sgml: remove ref to gtk_menu_append

Fri Oct 25 23:36:30 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenu.c: Change NAVIGATION_REGION_OVERSHOOT from 50 to 5.

Fri Oct 25 17:56:24 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_switch_focus_tab): 
	Always switch to the page with the focused tab
	label. (#82108, Matt Wilson.)

Fri Oct 25 17:46:18 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_button_press): 
	Don't handle button 2/3 on the tabs. (#82118,
	Matt Wilson.)

Fri Oct 25 17:32:44 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktoolbar.c: Don't insert mnemonics for stock
	items (#72918, reported by Mikael Hallendal)

Fri Oct 25 14:51:34 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c: Fix sensitivity of file operation
	buttons and buttons inside fileop dialogs to update
	properly based on the contents of the entries.
	(#74267, based on part of a patch from Muktha 
	Narayan)

	* gtk/gtkitemfactory.c (gtk_item_factory_create_item):
	Warn if loading <ImageItem> image fails.

	* tests/testgtk.c: Fix data for "apple" inline pixbuf
	to be valid.

Fri Oct 25 18:17:39 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkpaned.[ch]: New GtkPaned keyboard navigation. (Shift-)F8
	now cycles the available handles instead of toggling focus on and
	off. Fixes #87160, reported by Calum Benson.

2002-10-25  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkcursor-x11.c: Fix doc comment. 

	* gdk/gdkdnd.c: Add missing includes.

2002-10-24  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkdnd.c: 
	* gdk/x11/gdkdnd-x11.c: 
	* gdk/x11/gdkcursor-x11.c: 
	* gdk/gdkcolor.c:
	* gdk/x11/gdkcolor-x11.c: Some docs moved inline.
	
2002-10-23  Matthias Clasen  <maclas@gmx.de>

	* gdk/linux-fb/gdkselection-fb.c (gdk_utf8_to_string_target): 
	(gdk_utf8_to_compound_text_for_display): 
	(gdk_text_property_to_utf8_list_for_display): 
	* gdk/linux-fb/gdkkeyboard-fb.c (gdk_keymap_get_entries_for_keyval): 
	(gdk_keymap_get_entries_for_keycode): 
	(gdk_keymap_lookup_key): 
	(gdk_keymap_translate_keyboard_state): 
	* gdk/win32/gdkselection-win32.c (gdk_text_property_to_utf8_list_for_display): 
	(gdk_utf8_to_string_target): 
	(gdk_utf8_to_compound_text_for_display): 
	* gdk/win32/gdkkeys-win32.c (gdk_keymap_get_entries_for_keyval): 
	(gdk_keymap_get_entries_for_keycode): 
	(gdk_keymap_lookup_key): 
	(gdk_keymap_translate_keyboard_state): 
	* gdk/win32/gdkgeometry-win32.c (gdk_window_scroll): 
	* gdk/win32/gdkfont-win32.c (gdk_font_from_description_for_display): 
	* gdk/win32/gdkevents-win32.c (gdk_keyboard_grab_info_libgtk_only): 
	Remove doc comments for non-backend-specific functions from win32
	and linux-fb backends. These functions should be documented in the
	x11 backend.
	
Wed Oct 23 17:06:02 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodel.c: s/NULL/0/ on the g_signal_emit lines to
	fix up yesterdays commit (reported by Morten Welinder).

Tue Oct 22 20:02:22 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcombo.c: When popping up the list without
	any selected items, hack the focus on the list to
	avoid triggering a bug in GtkList when clicking
	on focused-but-not-selected items (#86700,
	Zimler Attila, Matthias Clasen) and to keep
	GtkWindow from selecting the first item.

	* tests/testgtk.c (create_list): Make the initial
	setting of the selection mode correspond to the option
	menu.

Wed Oct 23 01:03:43 2002  Kristian Rietveld  <kris@gtk.org>

	Another feature to create truly ugly TreeViews!: style properties
	for the even/odd colors used for row hinting. (#71595, reported
	by Owen Taylor).

	* gtk/gtktreeview.c (gtk_tree_view_class_init): add even_row_color
	and odd_row_color style properties.

	* gtk/gtkstyle.c (get_darkened_gc): support darken_count == 0 case,
	(gtk_default_draw_flat_box): rework cell coloring code to support
	user-provided even/odd row colors.

Wed Oct 23 01:01:52 2002  Kristian Rietveld  <kris@gtk.org>

	Cache signal IDs to speed up signal emission. This is a good speedup
	because GtkTreeModel emits a big number of signals.

	* gtk/gtktreemodel.c (gtk_tree_model_base_init): save IDs returned
	by g_signal_new,
	(gtk_tree_model_row_changed): use g_signal_emit instead of
	g_signal_emit_by_name,
	(gtk_tree_model_row_inserted): ditto,
	(gtk_tree_model_row_has_child_toggled): ditto,
	(gtk_tree_model_row_deleted): ditto,
	(gtk_tree_model_rows_reordered): ditto.
	
Wed Oct 23 00:56:15 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeselection.c (model_changed): new function,
	(gtk_tree_selection_selected_foreach): monitor changes in the model,
	bail out if the model has been changed from the foreach func.
	(#50263, reported by Havoc Pennington).

	* gtk/gtktreeselection.c (_gtk_tree_selection_internal_select_node):
	free anchor if applicable (#94868, reported and testcase provided by
	Daniel Elstner).

2002-10-23  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkinvisible.c (gtk_invisible_get_screen): 
	* gtk/gtkcolorsel.c
	(gtk_color_selection_set_change_palette_with_screen_hook): Fix doc comments.

	* gdk/linux-fb/gdkselection-fb.c (gdk_text_property_to_utf8_list_for_display): 
	(gdk_utf8_to_compound_text_for_display): Fix doc comments - why
	do these overwrite the ones from gdk/x11/*.c ?!

	* gdk/gdkdisplaymanager.c
	(gdk_display_manager_get_default_display): 
	Documentation fix.

	* gdk/gdkevents.c (gdk_event_new): 
	* gdk/x11/gdkdnd-x11.c (gdk_drag_find_window_for_screen): 
	* gdk/x11/gdkevents-x11.c (gdk_x11_screen_get_window_manager_name): 
	* gdk/x11/gdkdisplay-x11.c (gdk_x11_display_grab): 
	(gdk_x11_display_ungrab): Add documentation.

	* gdk/x11/gdkimage-x11.c (gdk_x11_image_get_xdisplay): 
	(gdk_x11_image_get_ximage): 
	* gdk/x11/gdkgc-x11.c (gdk_x11_gc_get_xdisplay): 
	(gdk_x11_gc_get_xgc): 
	* gdk/x11/gdkfont-x11.c (gdk_x11_font_get_xdisplay): 
	(gdk_x11_font_get_xfont): 
	* gdk/x11/gdkdrawable-x11.c (gdk_x11_drawable_get_xdisplay): 
	(gdk_x11_drawable_get_xid): 
	* gdk/x11/gdkcursor-x11.c (gdk_x11_cursor_get_xdisplay): 
	(gdk_x11_cursor_get_xcursor): 
	* gdk/x11/gdkcolor-x11.c (gdk_x11_colormap_get_xcolormap): 
	(gdk_x11_colormap_get_xdisplay): 
	* gdk/x11/gdkxid.c (gdk_xid_table_lookup): 
	* gdk/x11/gdkvisual-x11.c (gdkx_visual_get): 
	(gdk_x11_visual_get_xvisual):
	* gdk/x11/gdkmain-x11.c (gdk_x11_grab_server): 
	(gdk_x11_ungrab_server): 
	(gdk_x11_get_default_root_xwindow): 
	(gdk_x11_get_default_xdisplay): 
	Some docs moved inline.
	
Tue Oct 22 16:37:12 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.c: Multihead safety fixes, handle
	displays being closed. (#81651, based on patch
	from Erwann Chenede)

	* gtk/gtktoolbar.c (gtk_toolbar_init): Fix typo
	from the last commit.

Tue Oct 22 15:55:08 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktoolbar.c: Fix handling of getting the 
	default style/icon size from the correct 
	GtkSettings. (#82184, reported by Vitaly Tishkov,
	help from Soeren Sandmann)

Tue Oct 22 15:32:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c: Actively monitor the screen of the
	parent. (#80281)

	* gtk/gtkentry.c: Fix missing prototype from the 
	last commit.

Tue Oct 22 15:46:09 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_unrealize): Reset the 
	layout, since it holds a reference to the font on
	a particular screen.

Tue Oct 22 15:13:59 2002  Owen Taylor  <otaylor@redhat.com>
	
	* gtk/gtkimmulticontext.c: Include config.h
	(#96441, Morten Welinder)

Tue Oct 22 15:03:41 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/fnmatch.h: When compiling our on fnmatch.c, 
	#define fnmatch _gtk_fnmatch (#92890, Jacob Berkman)

Fri Oct 18 16:47:02 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c (translate_key_event): Produce
	C-m, not C-j for return. Handle Escape.

2002-10-22  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkstatusbar.c (gtk_statusbar_get_type): 
	(gtk_statusbar_class_init): It is called GtkStatusbar, not
	GtkStatusBar. This was changed accidentally during deprecation
	cleanup and caused links in the API docs to break.  (#96390)

Mon Oct 21 14:04:39 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_get_public_chars): Return
	"" for entry->invisible_char == 0, otherwise N copies
	of entry->invisible_char. (#95486, Vitaly Tishkov)

	* gtk/gtkentry.c: Fix a bunch of places where entry->text
	instead of layout->text was being used for computation
	of offsets/indices in the layout. Using layout->text
	is necessary because when the entry is invisible, it
	doesn't correspond to entry->text.

Sun Oct 20 23:58:03 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtkmenu.c, gtkmenubar.c, gtkmenuitem.c, gtkmenushell.c,
	gtkmenushell.h, gtkmenushell.h

	- make the delay before submenus appear below menu bars a
	  GtkSetting
	- make the delay before submenus pops up a GtkSetting
	- make the stay up triangle slightly larger
	- don't pop up the first submenu immediately.
	- make the default delay for submenus 225 ms, and 0 for menubars.
	- make the default delay before popping down inside the stay-up 
	  triangle 1000 ms

	Fixes #74950
	
Sun Oct 20 14:58:02 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_class_init):
	Add a scrollbar_spacing style property (#81396, based
	on a patch from Anders Carlsson)

2002-10-19  Jeremy Katz  <katzj@redhat.com>

	* configure.in: make configure checks for Xrandr and Xinerama
	extensions less noisy (#95858)

Fri Oct 18 16:47:02 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c (translate_key_event): Handle
	Return and KP_Enter.

Fri Oct 18 15:38:50 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkprogressbar.c (gtk_progress_bar_set_text): 
	Reset use_text_format to %TRUE for a %NULL text string.
	(#94157, once again).

Thu Oct 17 17:17:05 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcheckbutton.c (gtk_check_button_size_request): 
	Fix use of uninitialized variable.

Thu Oct 17 14:38:37 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccellabel.c (gtk_accel_label_expose_event): 
	Align the baseline of the accelerator label with the 
	first baseline of the main label of the menu item. (#76953)

Wed Oct 16 18:25:24 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c (translate_key_event): 
	Use gdk_keymap_translate_keyboard_state() rather than
	XLookupString() to get the keysymbol, since XLookupString
	can confuse the input method handling. (#93575)

	* gdk/x11/gdkkeys-x11.c: Rewrite the handling of
	key translation for the non-XKB case to properly
	handle Shift_Lock, Caps_Lock, Num_Lock according
	to the Xlib spec. (#67066)

2002-10-17  Havoc Pennington  <hp@redhat.com>

	* gtk/gtkwindow.c (gtk_window_compute_configure_request): fix
	compiler warnings

Thu Oct 17 22:37:57 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkwindow.c (get_center_monitor_of_window): fix typo to make
	it compile
	
2002-10-16  Havoc Pennington  <hp@redhat.com>

	* gdk/x11/gdkscreen-x11.c (gdk_screen_get_monitor_geometry): add
	g_return_if_fail for monitor number <= 0

	* gtk/gtkmenu.c (gtk_menu_position): handle case where pointer 
	is outside the screen.

	* gtk/gtkwindow.c (get_monitor_center): factor out 
	the code to position a window in center
	(gtk_window_compute_configure_request): use here
	(gtk_window_constrain_position): use here, the 
	code here wasn't multihead-aware

	* gdk/x11/gdkevents-x11.c (get_real_window): function to
	return the window the event describes, rather than the window
	that received the event.
	(gdk_event_translate): use result of that function for 
	filling in GdkEvent::window, which only matters for 
	MapNotify/UnmapNotify and ConfigureNotify, in practice.

	Unbreaks various things using SubstructureNotifyMask.

Thu Oct 17 16:13:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcheckbutton.c gtk/gtkradiobutton.c: Make
	the widgets work reasonably when they don't have
	children -- draw the focus around the indicator, 
	and position the indicator symmetrically.
	(#74830, Dave Camp)

	* tests/testgtk.c: Add no-child portions to check and radio 
	button tests.

Thu Oct 17 22:09:05 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenu.c (gtk_menu_scroll_to): Take arrows into
	account when clamping the offset. Fixes #95758.

Wed Oct 16 15:19:44 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkkeys-x11.c: Fix from Phil Blundell for
	compiling without Xkb. (#95909)

Wed Oct 16 14:32:43 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdrawable.h gdk/gdkdraw.c gdk/gdkpixmap.c 
	gdk/gdkwindow.c gdk/x11/gdkdrawable-x11.c
	gdk/win32/gdkdrawable-win32.c gdk/linux-fb/gdkdrawable-fb2.c
	gdk/linux-fb/gdkprivate-fb.h:
	Make 'filled' arguments for draw_arc/polygon/rectangle
	gboolean not gint. (#94976)
	
Wed Oct 16 17:11:46 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtktearoffmenuitem.c (gtk_tearoff_menu_item_paint): Make
	tear-off menuitems obey the "selected_shadow_type" style property.

Tue Oct 15 17:25:47 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/gtkimcontextxim.c (get_im): Don't use 
	connect_swapped() when the function being connected
	has a non-swapped signature.

Tue Oct 15 09:54:54 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/gtkimcontextxim.c (get_im): Initialize
	info->ics to NULL. (Hidetoshi Tajima.)  

	* modules/input/gtkimcontextxim.c (status_window_get): 
	Call set_resizable on the window, not on the structure.

Mon Oct 14 19:17:34 2002  Owen Taylor  <otaylor@redhat.com>

	* === Released 2.1.1 ===

Mon Oct 14 18:50:59 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Version 2.1.1, interface age 0, binary age 101.

	* NEWS: Updates

Tue Oct 15 00:53:14 2002  Kristian Rietveld  <kris@gtk.org>

	Behaviour change, apply changes if the entry of the editable gets
	a focus out event (#82405).

	* gtk/gtkcellrenderertext.c (gtk_cell_renderer_text_focus_out_event):
	new function,
	(gtk_cell_renderer_text_start_editing): stop editing and apply
	changes on focus-out.

Tue Oct 15 00:47:35 2002  Kristian Rietveld  <kris@gtk.org>

	Fixes an *evil* GtkTreeModelSort bug, #93629.

	* gtk/gtktreemodel.c (release_row_references): return if the
	refs->list is NULL.

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_row_changed): if we
	are swapping two rows (re-insertion on row_changed), also *emit*
	a rows_reordered signal. oops.

Tue Oct 15 00:45:03 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkliststore.c (gtk_list_store_remove_silently): free
	the actual link after the node has been removed (#92014).

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_column_finalize):
	free the cell_list and the child if the exists (#92014).

Tue Oct 15 00:40:25 2002  Kristian Rietveld  <kris@gtk.org>

	Don't accept drops if the model has been sorted, #93758)

	* gtk/gtkliststore.c (gtk_list_store_row_drop_possible): return
	FALSE if the list has been sorted.

	* gtk/gtktreestore.c (gtk_tree_store_row_drop_possible): check
	if drag_dest is a TreeStore, return FALSE if the tree has been
	sorted.

Tue Oct 15 00:33:59 2002  Kristian Rietveld  <kris@gtk.org>

	Compiler warning fixage, (#85858, #85859, #85860, #85872)

	* gtk/gtkcellrendererpixbuf (gtk_cell_renderer_pixbuf_render):
	s/guint/GtkCellRendererState/.
	
	* gtk/gtkcellrenderertext.c (gtk_cell_renderer_text_render):
	ditto.

	* gtk/gtkcellrenderertoggle.c (gtk_cell_renderer_toggle_render),
	(gtk_cell_renderer_toggle_activate): ditto.

	* gtk/gtkliststore.c (gtk_list_store_get_flags): a
	s/guint/GtkTreeModelFlags/ on the return type.

Mon Oct 14 15:10:34 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/gtkimcontextxim.c:
 	- Make GtkXIMInfo structures per-screen (they were
 	  a mix between per-display and per-context before)
 	- Make signal connections info->settings one-per-info
         - Handle a GdkDisplay being closed, by destroying
 	  all XIC, calling XCloseIM on the XIM. (#87482)
 
Sun Oct 13 16:55:49 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkdnd.c gtk/gtkradiobutton.[ch]: Deprecation cleanup

	* gtk/Makefile.am: Added disable deprecation flags

	* demos/pixbuf-init.c demos/gtk-demo/changedisplay.c: minor clean up

Sun Oct 13 16:20:41 2002  Manish Singh  <yosh@gimp.org>

	* tests/pixbuf-randomly-modified.c tests/prop-editor.c
	tests/testcalendar.c tests/testdnd.c tests/testgtk.c tests/testinput.c
	tests/testmultidisplay.c tests/testmultiscreen.c tests/testrgb.c
	tests/testselection.c tests/testsocket.c tests/testsocket_common.c
	tests/testtext.c tests/testtextbuffer.c tests/testtreecolumns.c
	tests/testtreeedit.c tests/testtreeflow.c tests/testtreefocus.c
	tests/testtreesort.c tests/testtreeview.c tests/testxinerama.c
	tests/treestoretest.c: Deprecation cleanup

	* tests/Makefile.am: Added disable deprecation flags

Sun Oct 13 13:43:16 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkcurve.[ch] gtk/gtkgamma.[ch] gtk/gtklayout.[ch]
	gtk/gtkwidget.[ch] modules/input/gtkimcontextxim.c
	modules/input/imam-et.c modules/input/imcyrillic-translit.c
	modules/input/imhangul.c modules/input/iminuktitut.c
	modules/input/imipa.c modules/input/imthai-broken.c
	modules/input/imti-er.c modules/input/imti-et.c
	modules/input/imviqr.c: Deprecation cleanup

	* modules/input/Makefile.am: Added disable deprecation flags

Sun Oct 13 12:29:15 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkcolorsel.[ch] gtk/gtkcombo.[ch] gtk/gtkplug.[ch]
	gtk/gtksocket.[ch] gtk/gtktreeview.[ch] gtk/gtktreeviewcolumn.[ch]:
	Deprecation cleanup

	* gtk/gtkcolorseldialog.c: make window not resizable (lost
	accidently in the previous cleanup)

Sun Oct 13 20:20:51 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtktooltips.c (gtk_tooltips_force_window): Make tooltip
	window not resizable. Fixes #95675.

Sun Oct 13 18:50:14 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtkmenu.c, gtkmenu.sgml, gtkitemfactory.c, gdkwindow.c,
	gtkwindow.c, gtkpaned.sgml, gtkdialog.c, gtkbox.h, gtkbutton.sgml,
	gtktreemodel.sgml,gtktable.sgml, gtktable.c:

	Documentation fixes.

	#85719, #90759, #95169, Owen Taylor;
	#89221, Yao Zhang, Matthias Clasen;
	#95592, Joost Faassen;
	#92637, Vitaly Tishkov;
	#94616, Ben Martin;
	#94772, sbaillie@bigpond.net.au;

Sun Oct 13 17:41:53 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkwidget.c (gtk_widget_queue_clear_area): Don't invalidate
	a widget if it or one of its ancestors isn't mapped.

Sun Oct 13 17:21:15 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* tests/testgtk.c (window_controls), tests/testgtk.c
	(create_tooltips): remove references to non-existing properties
	GtkWindow::allow_shrink and GtkWidget::width

Sat Oct 12 15:44:29 2002  Manish Singh  <yosh@gimp.org>

        * gtk/gtkitemfactory.c: use GTK_IS_RADIO_MENU_ITEM instead
        of comparing the type directly. This handles possible subclasses
        too. (Recommended by Tim Janik)

Fri Oct 11 15:56:20 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkaccellabel.[ch] gtk/gtkaccessible.[ch] gtk/gtkbutton.[ch]
	gtk/gtkcheckbutton.[ch] gtk/gtkcolorseldialog.[ch] gtk/gtkdialog.[ch]
	gtk/gtkhandlebox.[ch] gtk/gtkinputdialog.[ch] gtk/gtkmessagedialog.[ch]
	gtk/gtktearoffmenuitem.[ch] gtk/gtktogglebutton.[ch]: Deprecation
	cleanup

2002-10-11  Matthias Clasen  <maclas@gmx.de>

	* examples/gtkdial/gtkdial.c (gtk_dial_destroy): 
	* docs/tutorial/gtk-tut.sgml: Prevent segfault from double destroy.

	* gdk/x11/gdkwindow-x11.c (gdk_window_new): Typo fix.

	* gtk/gtkimagemenuitem.c (gtk_image_menu_item_new_from_stock):
	Clarify the docs.

	* gtk/gtkmenuitem.c (gtk_menu_item_set_accel_path): Mention 
	gtk_menu_set_accel_group in the docs.

	* gdk/x11/gdkwindow-x11.c (gdk_window_set_skip_pager_hint): 
	* gdk/gdkdisplay.c (gdk_display_set_pointer_hooks): Fix
	doc comments.

	* gtk/gtkiconfactory.c (gtk_icon_size_lookup_for_settings): 
	* gtk/gtknotebook.c (gtk_notebook_get_n_pages): 
	* gtk/gtkwindow.c (gtk_window_set_icon_from_file): 
	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_focus_cell): Fix
	doc comments.

	* gtk/gtktreestore.c: 
	* gtk/gtktreestore.h: Consistently name first parameter
	tree_store, and make header and implementation agree on parameter 
	names to silence gtk-doc.

	* gtk/gtkenums.h (enum): Comment typo fix.

Thu Oct 10 15:13:48 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkimcontext.[ch] gtk/gtkimcontextsimple.[ch] gtk/gtkimmodule.c
	gtk/gtkimmulticontext.[ch] gtk/gtktreestore.[ch]: Deprecation
	cleanup

Thu Oct 10 14:58:47 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkaccelgroup.c gtk/gtkarrow.[ch] gtk/gtkeventbox.[ch]
	gtk/gtkiconfactory.c gtk/gtkinvisible.[ch] gtk/gtktextchild.c:
	Deprecation cleanup

Thu Oct 10 14:41:05 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtktextbtree.c gtk/gtktextbuffer.c gtk/gtktextdisplay.c
	gtk/gtktextlayout.c gtk/gtktextmark.c gtk/gtktexttag.[ch]
	gtk/gtktexttagtable.c gtk/gtktextutil.c gtk/gtktextview.[ch]:
	Deprecation cleanup

Thu Oct 10 14:35:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkscrolledwindow.[ch]: Privately export
	_gtk_scrolled_window_get_scrollbar_spacing().

	* gtk/gtkcombo.c: Properly account from scrollbar
	spacing when computing the size of the popup window.
	(#84955, Marco Pesenti Gritti)

Wed Oct  9 17:40:13 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkaccelmap.c gtk/gtkfixed.[ch] gtk/gtkkeyhash.c gtk/gtkmenu.c
	gtk/gtkobject.c gtk/gtkoldeditable.c gtk/gtkrc.c gtk/gtkspinbutton.[ch]
	gtk/gtktable.[ch] gtk/gtkthemes.c: Deprecation cleanup

Wed Oct  9 16:52:53 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkclipboard.[ch] gtk/gtkeditable.[ch] gtk/gtkgc.c
	gtk/gtkoptionmenu.[ch] gtk/gtkselection.c gtk/gtksizegroup.[ch]:
	Deprecation cleanup

Wed Oct  9 15:23:48 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkadjustment.[ch] gtk/gtkalignment.[ch] gtk/gtkentry.[ch]
	gtk/gtkhsv.[ch] gtk/gtktooltips.[ch]: Deprecation cleanup

Wed Oct  9 15:07:08 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkbindings.[ch] gtk/gtkcalendar.[ch] gtk/gtkfilesel.[ch]
	gtk/gtkfontsel.[ch] gtk/gtkitem.[ch] gtk/gtkitemfactory.[ch]:
	Deprecation cleanup

Wed Oct  9 17:06:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkiconfactory.c (add_size_and_dir_with_fallback):
	Add GO_FORWARD and GO_BACK with both left and right
	arrows depending on the direction. (#92211,
	Kenneth Christiansen)

	* tests/testgtk.c (create_flipping): Add forward/back button
	pairs in default, RTL, LTR configurations.

2002-10-09  Stanislav Brabec  <sbrabec@suse.cz>

	* gtk/gtkimcontextsimple.c: Added support for hungarian characters
	(addition to bug #93421). Only via dead keys, because compose key
	combinations in X are erratic.

Tue Oct  8 17:34:26 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkmain.c gtk/gtkscrolledwindow.[ch] gtk/gtksettings.c
	gtk/gtkstatusbar.[ch] gtk/gtkstyle.c gtk/gtktoolbar.[ch]
	gtk/gtkviewport.[ch] gtk/gtkwindow.[ch]: Deprecation cleanup

Tue Oct  8 15:25:53 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkhpaned.[ch] gtk/gtkpaned.[ch] gtk/gtkprogress.[ch]
	gtk/gtkprogressbar.[ch] gtk/gtkvpaned.[ch]: Deprecation cleanup

Tue Oct  8 14:49:56 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtktreemodel.h: restore gtkobject.h #include so we don't
	break backwards compat.

Tue Oct  8 09:41:43 2002  Owen Taylor  <otaylor@redhat.com>

	* Patch from Takuro Ashie to fix updating of open_ims
	list. (#95150)

Mon Oct  7 19:44:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkkeys-x11.c (_gdk_keymap_keys_changed): Move
	out of HAVE_XKB. (#95129, Phil Blundell)

Mon Oct  7 19:14:24 2002  Eric Warmenhoven <eric@warmenhoven.org>

	* gdk/linux-fb/gdkwindow-fb.c: fix compilation

	* gdk/linux-fb/gdkmain-fb.c: better display mode setting

Mon Oct  7 18:50:46 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c (gtk_color_selection_finalize):
	Free the private data. (#84903, Matthias Clasen)

Mon Oct  7 18:21:39 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtk[hv]paned.c gtk/gtkpaned.c: Allow the slider
	to be set all the way to the edge, and if that happens,
	use gtk_widget_set_child_visible() to hide the 
	appropriate child. (#72784, request from Darin Adler)

Mon Oct  7 16:28:11 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c (palette_drag_begin): Use
	a pixbuf to set the drag icon, combine code
	to create drag icons (Fixes #80092, #80093)

	* gtk/gtkcolorsel.c (get_screen_color): Don't warn
	on failure to grab keyboard/mouse. (#80085)

	* gtk/gtkcolorsel.c (palette_press): Return FALSE,
	so DND initiation is possible.

	* gtk/gtkcolorsel.c (palette_release): Set the color
	from the palette on release, not press.

	* gtk/gtkcolorsel.c (gtk_color_selection_show_all):
	Override to simple call show(). (#74173)

	* tests/testgtk.c (create_color_selection): Use 
	gtk_widget_show_all()

Mon Oct  7 15:48:44 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdnd.[ch] gdk/x11/gdkdnd-x11.c: Add 
	gdk_drag_find_window_for_screen(), so that we can
	interpret x_root / y_root relative to the correct screen.
	
	* gdk/gdkdnd.c Makefile.am gdk/x11/gdkdnd-x11.c 
	gdk/fb/gdkdnd-fb.c gdk/win32/gdkdnd-win32.c: New file. 
	Move gdk_drag_find_window(), gdk_drag_get_protocol() here.

	* gtk/gtkdnd.c: Handle drags between screens; use 
	a fallback icon for icons set as windows/pixmaps, 
	move the drag icon between displays for icons set as 
	pixbufs.

	* gdk/x11/gdkkeys-x11.c (update_keymaps): Fix infinite
	loop from last change.

Mon Oct  7 15:10:00 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdisplay.[ch] gdk/gdkinternals.h 
	gdk/gdkwindow.[ch] gdk/linux-fb/gdkwindow-fb.c 
	gdk/win32/gdkwindow-win32.c gdk/x11/gdkwindow-x11.c:

	- Replace GdkPointerHooks with a multihead-safe 
	  GdkDisplayPointerHooks, leave GdkPointerHooks
	  around for singlehead.
	- Add gdk_display_get_pointer() to get the pointer
	  location with the screen it is on.

	* gdk/gdk.def gdk/gdkdisplay.[ch] gdk/gdkscreen.[ch]:
	Change gdk_screen_get_window_at_pointer() to
	gdk_display_get_window_at_pointer().

	* gtk/gtktreeview.c demos/gtk-demo/changedisplay.c
	tests/testgtk.c: Use gdk_display_get_window_at_pointer(), 
	not gdk_screen_get_window_at_pointer().

	* gtk/gtkcolorsel.c: Fix grabbing color to be multihead
	safe.

	* gtk/gtkwidget.c: Allow gtk_widget_push_colormap (NULL).
	since it is useful for writing code that doesn't
	know the dcurrent state but needs a clean colormap.

	* gtk/gtkrc.c: When loading the settings for a particular
	screen, only reset toplevels on that screen.

	* gtk/gtkiconfactory.h: Fix #ifdef GTK_MULTIHEAD_SAFE
	that should have been #ifndef GTK_MULTIHEAD_SAFE.

Mon Oct  7 11:59:33 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkliststore.[ch] gtk/gtktreedatalist.[ch] gtk/gtktreednd.c
	gtk/gtktreemodel.[ch] gtk/gtktreemodelsort.[ch]
	gtk/gtktreeselection.[ch] gtk/gtktreesortable.[ch]
	gtk/gtktreestore.[ch]: Deprecation cleanup

Mon Oct  7 14:51:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkx.h: Fix some prototypes that had
	() instead of (void).

Mon Oct  7 12:40:39 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_move_resize): Clean
	up the handling of clearing transient state 
	settings, fixing bug #95026, reported by Jami
	Pekannen.

Mon Oct  7 11:45:17 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkkeys-x11.c (update_keymaps): If Mode_switch
	is used for a known modifier like Mod1, assume it won't
	be used to switch group. (#94841, problem reported by
	Szekeres Istvan)

Mon Oct 7 16:07:52 2002  Bill Haneman <bill.haneman@sun.com>

	* gdk/x11/gdkimage-x11.c gdk/linux-fb/gdkimage-x11.c 
	gdk/win32/gdkimage-x11.c: (gdk_image_get_pixel): 
	(gdk_image_put_pixel): Fixed sense of bounds checks.

Sun Oct  6 21:23:29 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkcontainer.[ch] gtk/gtkbox.[ch] gtk/gtkhbox.[ch]
	gtk/gtkvbox.[ch]: Deprecation cleanup

Sun Oct  6 18:32:11 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkcelleditable.c gtk/gtkcellrenderer.[ch]
	gtk/gtkcellrendererpixbuf.[ch] gtk/gtkcellrenderertext.[ch]
	gtk/gtkcellrenderertoggle.[ch]: Deprecation cleanup

Sat Oct  5 16:11:22 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkmisc.[ch] gtk/gtklabel.[ch] gtk/gtkimage.[ch]
	gtk/gtkdrawingarea.[ch] gtk/gtknotebook.[ch]: Deprecation cleanup

Sat Oct  5 18:30:50 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/stock-icons/Makefile.am (pixbuf_csource): Use
	$(top_builddir) instead of here-undefined $$topdir.
	(Problem reported by Jacob Berkman)

Sat Oct  5 18:25:11 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_draw_tab): Fix 
	&expose_event vs expose_event problem (#94898,
	reported by Jon-Kare Hellan)

Sat Oct  5 16:47:03 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* docs/reference/gtk/tmpl/gtkfontseldlg.sgml, gdk/gdkwindow.c,
	gdk/x11/gdkwindow-x11.c, gtk/gtkfontsel.h, gtk/gtkimcontext.c,
	gtk/gtktreeview.c, gtk/gtktreeviewcolumn.c

	Documentation fixes:

	#75170, Dan Winship; 
	#73220, Havoc Pennington;
	#70742, Boris Shingarov; 
	#72007, Alexey A. Malyshev

Fri Oct  4 18:40:50 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkcheckmenuitem.[ch] gtk/gtkimagemenuitem.[ch] gtk/gtkmenu.[ch]
	gtk/gtkmenubar.[ch] gtk/gtkmenuitem.[ch] gtk/gtkmenushell.[ch]
	gtk/gtkradiomenuitem.[ch]: Deprecation cleanup

Fri Oct  4 16:48:27 2002  Manish Singh  <yosh@gimp.org>

	* gtkaspectframe.[ch] gtkbin.[ch] gtkframe.[ch] gtkhruler.[ch]
	gtkruler.[ch] gtkvruler.[ch]: Deprecation cleanup

Fri Oct  4 15:47:06 2002  Manish Singh  <yosh@gimp.org>

	* gtkbbox.[ch] gtkhbbox.[ch] gtkhscale.[ch] gtkscale.[ch]
	gtkvscale.[ch] gtkvbbox.[ch]: Deprecation cleanup

Fri Oct  4 15:05:19 2002  HideToshi Tajima  <hidetoshi.tajima@sun.com>

	* modules/input/gtkimcontextxim.c (get_ic_real): Fix memory
	intilization error caused by my previous checkin.
	#94908 a patch from famao@momonga-linux.org (Motonobu Ichimura)
	
Fri Oct  4 17:13:03 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c: Improve checks on public entry points,
	including, among other things checking whether drag
	contexts passed in are source or dest. (Fixes
	#76762, Alexey A. Malyshev)

	* tests/testtext.c tests/testgtk.c tests/testdnd.c:
	Fix uninstalled operation for new pixbuf changes.

	* gtk/stock-icons/Makefile.am (pixbuf_csource): 
	Fix makefile for uninstalled operation.

Fri Oct  4 21:21:47 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkhandlebox.c (gtk_handle_box_paint): remove unused
	codepath.

	* gtk/gtkmenuitem.c (gtk_real_menu_item_{de,}select): call 
	gtk_widget_queue_draw() instead of gtk_widget_draw().

Fri Oct  4 14:49:04 2002  Owen Taylor  <otaylor@redhat.com>

	Patch from Shivram U <shivaram.upadhyayula@wipro.com>
 
  	* gdk/x11/gdkkeys-x11.c (update_keymaps): Increased the keycount to
 	(max_keycode - min_keycode) + 1 from (max_keycode - min_keycode).
 	(update_keymaps), (gdk_keymap_get_entries_for_keyval) looping through
 	less than or equal to max_keycode. (#79184)

2002-10-04  jacob berkman  <jacob@ximian.com>

	* gdk/x11/gdkscreen-x11.c (init_xinerama_support): make legal C

Fri Oct  4 12:05:27 2002  Owen Taylor  <otaylor@redhat.com>

	* demos/Makefile.am (pixbuf_csource): Fix envars
	for uninstalled operation of gdk-pixbuf

	* demos/Makefile.am (test-inline-pixbufs.h): Remove
	output on failure.

Fri Oct  4 12:00:10 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkscreen.c (gdk_screen_class_init): Get the
	name right.

	* gdk/x11/gdkscreen-x11.c (gdk_screen_x11_class_init): 
	Fix function that should have been static.

Fri Oct  4 11:43:47 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Add a check for the Xrandr extension.

	* gdk/gdkscreen.[ch]: Add a size-changed signal.

	* gdk/x11/gdkscreen-x11.[ch]: Patch from Keith packard
	to hook up ConfigureNotify events on the root window
	to the ::size-changed signal. (#94560)

	* gtk/gtkimcontextsimple.c: Warning fixes
	
Fri Oct  4 00:57:53 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkhscrollbar.[ch] gtk/gtkhseparator.[ch] gtk/gtkrange.[ch]
	gtk/gtkscrollbar.[ch] gtk/gtkseparator.[ch] gtk/gtkseparatormenuitem.h
	gtk/gtkvscrollbar.[ch] gtk/gtkvseparator.[ch]: Deprecation cleanup

Thu Oct  3 22:38:12 2002  Manish Singh  <yosh@gimp.org>

	* gdk-pixbuf/queryloaders.c: make it legal C

Thu Oct  3 16:40:18 2002 Eric Warmenhoven <eric@warmenhoven.org>

	* gdk/gdkevents.c, gdk/linux-fb/gdkwindow-fb.c,
	gtk/gtkwindow-decorate.c: implement maximize for linux-fb

	* gdk/linux-fb/gdkkeyboard-fb.c: implement raw keyboard mode

	* gdk/linux-fb/Makefile.am, gdk/linux-fb/gdkdnd-fb.c,
	gdk/linux-fb/gdkmain-fb.c, gdk/linux-fb/gdkselection-fb.c,
	gdk/linux-fb/miarc.c, gdk/linux-fb/mifpolycon.c,
	gdk/linux-fb/miwideline.c, gdk/linux-fb/mizerclip.c,
	gdk/linux-fb/mizerline.c: small cleanups

Thu Oct  3 19:00:55 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkselection-x11.c (gdk_selection_property_get): 
	Fix error in computing length and a memory leak.
	(Fixes #94072, reported by Hema Seetharamaiah)

	* gtk/gtkmenu.c (gtk_menu_motion_notify): Fix &event
	used instead of event.

2002-10-04  Matthias Clasen  <maclas@gmx.de>

	* demos/gtk-demo/main.c (main): 
	* demos/pixbuf-init.c (pixbuf_init): Adjust to gdk-pixbuf changes.

Thu Oct  3 23:53:43 2002  Kristian Rietveld  <kris@gtk.org>

	* gdk/x11/gdkwindow-x11.c (_gdk_windowing_window_destroy): get
	XDisplay from window instead of display, as display has not been
	defined here (fixes the build).

Thu Oct  3 17:09:23 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/{gdkdrawable-x11.[ch],gdkpixmap-x11.c,
	gdkwindow-x11.c}: Restore the pre-Xft2 code to
	render text directly via RENDER, conditionalized
	with !HAVE_XFT2 so that we'll build again on Xft1 
	systems. (#90181)

Thu Oct  3 14:13:33 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.c (gdk_event_new): Add a 'type'
	parameter, make public.

	* gdk/gdkevents.c (gdk_event_copy): Copy the screen.

	* gdk/gdkevents.c gdk/linux-fb/gdkmain-fb.c
	gdk/x11/gdkevents-x11.c	gdk/win32/gdkevents-win32.c:
	_gdk_event_new() => gdk_event_new().
	
	* gdk/win32/gdkevents-win32.c (real_window_procedure): 
	Fix event_private->screen breakage that results from evil 
	encapsulation breakage here.
	
	* gtk/gtkclist.c gtk/gtkcombo.c gtk/gtkcontainer.c
	gtk/gtkdialog.c gtk/gtkdnd.c gtk/gtkdrawingarea.c
	gtk/gtkimcontextsimple.c gtk/gtklist.c gtk/gtkmenu.c
	gtk/gtknotebook.c gtk/gtkplug.c gtk/gtkselection.c
	gtk/gtktext.c gtk/gtktreeitem.c gtk/gtktreeview.c
	gtk/gtkviewport.c gtk/gtkwindow-decorate.c gtk/gtkwindow.c
	tests/testgtk.c: Remove most usage of stack-allocated 
	GdkEvent structures.

	* gtk/gtktreeview.c: Use a cut-and-paste of the full 
	send_focus_event() from gtkwindow.c that does the necessary 
	notification of the ::has-focus property and setting of 
	the HAS_FOCUS flag.x

	* gtk/gtkdnd.c: Clean up some mess/duplicated code; removing
	an extraneous use of a GdkEvent.

Wed Oct  2 17:46:53 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdrawable.h gdk/gdkinternals.h gdk/gdkdraw.c
	gdk/gdkwindow.c gdk/gdkdrawable.c: Export _gdk_draw_pixbuf
	as gdk_draw_pixbuf(), rename the _draw_pixbuf virtual
	function to draw_pixbuf. (#60582)

	* gdk/gdkpixbuf-render.c (gdk_pixbuf_render_to_drawable[_alpha]):
	Note that these functions are obsolete in the docs.

	* gdk/gdkpixbuf-render.c (gdk_pixbuf_render_to_drawable): 
	Remove all the sanity checks now we make it clear
	that it is obsolete name for gdk_draw_pixbuf().

	* gdk/gdkpixmap.c gtk/gtkcellrendererpixbuf.c gtk/gtkimage.c
	  gtk/gtkpixmap.c demos/testpixbuf-scale.c demos/testpixbuf.c
	  tests/testrgb.c: Use gdk_draw_pixbuf() everywhere.

	* gtk/gtklabel.c (gtk_label_set_mnemonic_widget): Fix
	some warnings.

	* gdk/gdkinternals.h (struct _GdkEventPrivate): Fix missed
	bit from last gdk_event_get_screen() change.

	* gdk/gdkevents.c: Couple of small fixes.

Wed Oct  2 17:36:42 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.[ch] gdk/x11/gdkevents-x11.c: Add
	gdk_screen_set_screen()/_get_screen() which (by evil
	hacks) work for for heap allocated events and
	fall back gracefully for stack allocated events.

Wed Oct  2 08:47:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksettings.[ch]: Privately export:
	_gtk_settings_set_property_value_from_rc()
	_gtk_settings_reset_rc_values() so that we can reset
	settings set from RC files when reloading RC files.
	(#94610)

	* gtk/gtkrc.c: Hook up RC file setting resetting.

Tue Oct  1 12:53:44 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkwindow-decorate.c gtk/gtkwindow.[ch]: Deprecation cleanup

2002-10-01  jacob berkman  <jacob@ximian.com>

	* gtk/gtkinvisible.c: 
	* gtk/gtkclipboard.c: declare parent_class static

2002-10-01  Stanislav Brabec  <sbrabec@suse.cz>

	* gtk/gtkimcontextsimple.c: Fixed alphabetical order (bug #93421).

2002-10-01  Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtkmenu.c: Add gtk_menu_focus() so we do not waste time
	trying to focus a menu item. (bug #91258)

2002-09-30  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkpixmap-win32.c (gdk_pixmap_impl_win32_finalize):
	Set image->windowing_data to NULL, unref the image. (Late merge
	from stable.)

Mon Sep 30 15:45:49 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_set_mnemonic_widget): 
	Make the reference to the mnemonic widget weak.
	(#93334, Murray Cumming)

Mon Sep 30 15:38:53 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.h: Remove a duplicate definition
	of gdk_set_sm_client_id().

Mon Sep 30 15:31:57 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdisplay.c gdk/x11/gdkdisplay-x11.c 
	gdk/gdkinternals.h: Set the client ID on all
	displays. (#85713)

	* gdk/gdkdisplay.h gkd/gdkinternals.h
	 gdk/{linux-fb,win32,x11}/gdkmain-{fb,win32,x11}.c
	Privatize gdk_display_set_sm_client_id().

Mon Sep 30 14:46:49 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkbindings.c (gtk_binding_set_new): Initialize
 	->parsed field. (#94536, patch from Sebastian Ritau. Maybe 
 	fixes #87411?)
 
Mon Sep 30 14:28:58 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.[ch]: Add gtk_window_set_icon_from_file(),
	gtk_window_set_default_icon_from_file() convenience
	functions (#75178, suggestion from Havoc Pennington)

2002-09-30  Daniel Elstner  <daniel.elstner@gmx.net>

	* gtk/gtktextbuffer.c: Add construct-only property "tag_table"
	and make use of it in gtk_text_buffer_new().  (#70227)

2002-09-30  Stanislav Brabec  <sbrabec@suse.cz>

	* gtk/gtkimcontextsimple.c: Completed ISO-8859-2 characters
	support (#93421), fixed cacute, umacron, completed dead_key+space
	convention.

Sun Sep 29 23:52:28 2002  Owen Taylor  <otaylor@redhat.com>

	* ===== Released 2.1.0 ======

	* NEWS: Updated

Sun Sep 29 20:20:26 2002  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtktooltips.c (gtk_tooltips_event_handler): Disable
        tooltips for menu items with submenus .. they still
        don't really work properly. (Missed merge from
	stable)

Sun Sep 29 20:15:59 2002  Owen Taylor  <otaylor@redhat.com>

       * gtk/gtkwindow.c (gtk_window_move_resize): Clear
        initial_pos_set even if it only causes a move, not
        a resize as well. (Missed merge from stable,
	may fix #89562)

Sun Sep 29 14:22:47 2002 Manish Singh  <yosh@gimp.org>

	* contrib/gdk-pixbuf-xlib/Makefile.am demos/Makefile.am
	demos/gtk-demo/Makefile.am: add deprecation compile flags

	* demos/testanimation.c demos/testpixbuf-save.c demos/testpixbuf.c
	demos/gtk-demo/*.c gdk-pixbuf/gdk-pixbuf-animation.c
	gdk-pixbuf/gdk-pixbuf.c: minor cleanups, getting rid of
	unnecessary casts

Sun Sep 29 13:11:13 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtktypeutils.h: use #defines instead of enum for
	GtkFundamentalType compat, to prevent 64-bit vs. 32-bit
	confusion (#90400)

2002-09-29  Tor Lillqvist  <tml@iki.fi>

	* configure.in: Instead of forcing -fnative-struct into CFLAGS
	when using gcc for Win32, check for gcc version 3.x which uses
	-mms-bitfields instead. Also check if either of these switches is
	actually available at all, and warn if not. Thanks to Soren
	Andersen for the inspiration. (#93965)

2002-09-01  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkimcontext.c, gtk/gtktreeviewcolumn.c:

	Minor documentation fixes. 
	(#80021, Yao Zhang; #75567, #75279, Vitaly Tishkov)

2002-09-28  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkwindow-x11.c (_gdk_windowing_window_init): Make
	drawing to the root window work.  (#89492)

Fri Sep 27 18:14:00 2002  Owen Taylor  <otaylor@redhat.com>

	(#91249, Thomas Leonard)

	* gtk/gtkselection.c (gtk_selection_convert): Initialize
	idle time to 0.

	* gtk/gtkselection.c: Up idle timeout to 5 minutes
	from 5 seconds.

Fri Sep 27 17:40:47 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/Makefile.am: Patch from J. Ali Harlow
	to avoid generating gtk.immodules when cross-compiling.
        (#87774)
	
Fri Sep 27 14:30:34 2002 Eric Warmenhoven <eric@warmenhoven.org>

	* gdk/Makefile.am gdk/gdkkeynames.c gdk/linux-fb/gdkmain-fb.c
	gdk/win32/gdkkeys-win32.c: Move gdk_keval_name and
	gdk_keyval_from_name to new gdkkeynames.c, share implementation for
	linux-fb and win32 (#94123)

	* gdk/linux-fb/Makefile.am gdk/linux-fb/gdkkeyboard-fb.c
	gdk/linux-fb/gdkmain-fb.c gdk/linux-fb/gdkmouse-fb.c: add
	-DG_DISABLE_DEPRECATED and -DGDK_PIXBUF_DISABLE_DEPRECATED to compile
	flags

	* gdk/linux-fb/gdkdisplay-fb.c: prevent segfault if display can't
	initialize

	* gdk/linux-fb/gdkkeyboard-fb.c: better parsing of keycodes

	* gdk/linux-fb/gdkwindow-fb.c: add stubs for new functions

Fri Sep 27 17:23:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c: Fix some signed/unsigned warnings.
	(#85863, David L. Cooper II)

Fri Sep 27 16:23:49 2002  Owen Taylor  <otaylor@redhat.com>
	 
 	* gtk/gtklabel.c : Replaced instances where strlen (label->label) is
 	used to get a byte code with strlen (label->text) as label->text 
	contains the actual display text, while label->label contains
	markup / mnemonics. (#92683, Patch from Shivram U  
	<shivaram.upadhyayula@wipro.com>, with some additions.)

	* gtk/gtklabel.c (gtk_label_set_uline_text_internal): 
	Fix a leftover, now incorrect comment.
	
Fri Sep 27 16:15:11 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_get_event_window_position):
	Handle the case where the first page isn't visible.
	(#81600, bug tracked down by Chema Celorio)

Fri Sep 27 15:57:15 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstock.c (builtin_items): Change accelerator
	from C_ut to Cu_t. (#82747, Paolo Maggi)

Fri Sep 27 15:27:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimage.c (gtk_image_unrealize): Reset the
	animation iter on unrealize as well as unmap.
	(#94336)

	* gtk/gtkprogressbar.c (gtk_progress_bar_set_text): Don't
	turn a value of "" into NULL. (#94157, Vitaly Tishkov)

Wed Sep 25 18:23:50 2002  HideToshi Tajima  <hidetoshi.tajima@sun.com>

	* modules/input/gtkimcontextxim.c:
	- use gtk_settings_get_for_screen () instead of
	  gtk_settings_get_default () for multihead
	- connect property-notify signal handlers to respond runtime
	  changes of status_style and preedit_style in the settings
	- Some indentation and code cleanup (#59076 - 2nd check-in)
	
2002-09-24  Havoc Pennington  <hp@redhat.com>

	* gtk/gtkwindow.c: fix GtkWindowMnemonic to have a separate
	typedef

	* gdk/x11/gdkevents-x11.c (gdk_check_wm_state_changed): monitor
	FULLSCREEN state

	* tests/testgtk.c (get_state_controls): add
	fullscreen/unfullscreen test

	* gdk/gdkdisplay.c (gdk_display_finalize): fix unused variable

	* gdk/x11/gdkscreen-x11.c (init_xinerama_support): fix unused
	variable

	* gdk/x11/gdkevents-x11.c (gdk_xsettings_watch_cb): mop up unused
	variable

	* gdk/x11/gdkscreen-x11.c
	(_gdk_x11_screen_window_manager_changed): emit
	window_manager_changed signal

	* gdk/x11/gdkscreen-x11.h (struct _GdkScreenX11Class): add
	window_manager_changed signal

	* gdk/x11/gdkevents-x11.c
	(gdk_x11_screen_get_window_manager_name): new function

	* gtk/gtkwindow.c (gtk_window_class_init): add type_hint,
	skip_taskbar_hint, skip_pager_hint properties
	(gtk_window_set_skip_taskbar_hint):
	(gtk_window_get_skip_taskbar_hint):
	(gtk_window_set_skip_pager_hint):
	(gtk_window_get_skip_pager_hint):
	(gtk_window_fullscreen):
	(gtk_window_unfullscreen): new functions

	* gdk/gdkevents.h (GdkWindowState): add FULLSCREEN state

	* gdk/gdkwindow.h (GdkWindowTypeHint): add missing type hint
	values

	* gdk/x11/gdkwindow-x11.c (gdk_window_set_skip_taskbar_hint):
	(gdk_window_set_skip_pager_hint):
	(gdk_window_fullscreen):
	(gdk_window_unfullscreen): new functions
	(set_initial_hints): set fullscreen here if appropriate
	
Wed Sep 25 10:51:24 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkscreen.h gdk/{x11,win32,linux-fb}/gdkscreen-*.c:
	Add gdk_screen_make_display_name(), which returns a
	display name that can be used to open a display with the
	screen as the default (Based on patch from Mark McLoughlin, 
	#86013)

Wed Sep 25 08:50:40 2002  Owen Taylor  <otaylor@redhat.com>

	Patch from Eric Warmenhoven, #94123

        * gdk/gdkmouse-fb.c: Add scrolling support for 
	imps2 mice.

	* gdk/linux-fb/gdkimage-fb.c: Fix compilation error
	in last gdkimage-fb.c commit.

Wed Sep 25 00:16:53 2002  Manish Singh  <yosh@gimp.org>

	* gdk/Makefile.am gdk/x11/Makefile.am: add -DG_DISABLE_DEPRECATED
	and -DGDK_PIXBUF_DISABLE_DEPRECATED to compile flags

	* gdk/gdkcolor.c gdk/gdkdisplay.c gdk/gdkdraw.c gdk/gdkevents.c
	gdk/gdkgc.c gdk/gdkimage.c gdk/gdkpango.c gdk/gdkpixbuf-render.c
	gdk/gdkpixmap.c gdk/gdkrgb.c gdk/gdkwindow.c gdk/linux-fb/gdkdnd-fb.c 
	gdk/linux-fb/gdkfont-fb.c gdk/win32/gdkdnd-win32.c
	gdk/win32/gdkfont-win32.c gdk/x11/gdkdisplay-x11.c gdk/x11/gdkdnd-x11.c
	gdk/x11/gdkdrawable-x11.c gdk/x11/gdkevents-x11.c gdk/x11/gdkfont-x11.c
	gdk/x11/gdkgc-x11.c gdk/x11/gdkgeometry-x11.c gdk/x11/gdkim-x11.c
	gdk/x11/gdkinput-x11.c gdk/x11/gdkkeys-x11.c gdk/x11/gdkscreen-x11.c
	gdk/x11/gdkwindow-x11.c: Deprecation cleanup, mostly changing
	gdk_foo_{ref,unref} to g_object equivalents.

Tue Sep 24 23:54:20 2002  Manish Singh  <yosh@gimp.org>

	* gtk/gtkfilesel.c: check if last_selected is valid before doing
	a strcmp on it, which may happen if selections happen programmatically
	instead of through the UI (#86566)

Tue Sep 24 23:33:48 2002  Manish Singh  <yosh@gimp.org>

        * gtk/gtkfilesel.c: preserve ordering from gtk_tree_selection_foreach
	when returning filenames for gtk_file_selection_get_selections
	(#86567)

	* gtk/gtkclipboard.c: GtkClipboard struct should have a GObject
	in it, not a GObjectClass

Tue Sep 24 18:18:36 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclipboard.[ch]: Make a GObject (#75970, James
	Henstridge)

Tue Sep 24 19:45:55 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (gdk_window_impl_x11_get_colormap): 
	Look up the visual as well as the colormap, since calling
	gdk_drawable_get_visual() causes infinite recursion.

	* gdk/x11/gdkwindow-x11.c (_gdk_windowing_window_init): 
	Set the colormap for the root window.

Tue Sep 24 15:35:42 2002  HideToshi Tajima  <hidetoshi.tajima@sun.com>

	disable/enable preedit/status in GtkIMContextXIM (#59076)
	
	* gtk/gtkenums.h (enum): added preedit/status styles for gtk+
	input method
	* modules/input/gtkimcontextxim.c
	* gdk/x11/gdkevents-x11.c: add gtk-im-preedit-style and
	gtk-im-status-style to GtkSettings.
	* po/POTFILES.in: added modules/input/gtkimcontextxim.c

	With the other patch for gnome-control-center,
	the preedit and status styles of GTK+ input method are
	configurable with associated gconf schemas keys:
	"/desktop/gnome/interface/gtk-im-preedit-style"
	"/desktop/gnome/interface/gtk-im-status-style"

	Both are set to "callback" by default, and platform's 
	packging can have different default by changing
	libgnome's desktop_gnome_interface.schemas.

2002-09-25  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkvisual-x11.c (gdkx_visual_get): Replace leftover 
	gdkx_visual_get_for_screen () by gdk_x11_screen_lookup_visual().

	* gtk/gtkaccelgroup.h: Add a missing ; to make things compile.

	* gdk/x11/gdkwindow-x11.c (gdk_window_impl_x11_get_colormap):
	Replace leftover gdk_colormap_lookup () by
	gdk_x11_colormap_foreign_new () to make the linker happy.

Tue Sep 24 17:49:52 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccelgroup.[ch] (gtk_accel_group_find): 
	Add a GtkAccelGroupFindFunc to clean up the
	prototype. (#76670, Vitaly Tishkov)

	* gdk/x11/gdkvisual-x11.c gdk/x11/gdkx.h: Rename
	gdkx_visual_get_for_screen() to 
	gdk_x11_screen_lookup_visual(). (#85702)

2002-09-25  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkevents-win32.c (gdk_event_translate):
	WM_SYSKEYDOWN, WM_SYSKEYUP: Need to handle F10 specially here in
	order to be able to handle it normally in the application. Set
	ignore_wm_char also always when handling WM_SYSKEY{DOWN,UP}, this
	way we can generate GDK events also for Alt-Fn keys, for instance.

2002-09-24  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkx.h: Add a missing ; to make things compile.

Tue Sep 24 16:40:14 2002  Owen Taylor  <otaylor@redhat.com>

	Make icon sizes configurable (#70648, slightly based
	on a patch from Bill Haneman, Brian Cameron)

	* gtk/gtkiconfactory.[ch]: Add 
	gtk_icon_size_lookup_for_settings().

	* gtk/gtksettings.c: Add gtk-icon-sizes XSETTING

	* gtk/gtkiconfactory.c: Make icon sizes per-GtkSettings.

	* gtk/gtkstyle.c: Use gtk_icon_size_lookup_for_settings()

	* gtk/gtkrc.[ch]: Privately export _gtk_rc_reset_styles()
	to force all the widgets to recompute their appearance.

	* gdk/x11/gdkevents-x11.c: Add gtk-icon-sizes XSETTING

Tue Sep 24 16:24:22 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/win32/gdkimage-win32.c gdk/x11/gdkimage-x11.c 
	* gdk/linux-fb/gdkimage-fb.c (gdk_image_put/get_pixel): 
	Add bounds-checking g_return_if_fail(). (Olexiy Avramchenko)

Tue Sep 24 16:04:44 2002  Owen Taylor  <otaylor@redhat.com>

	* gdkprivate-x11.h gdkcolor-x11.c gdkvisual-x11.c
	gdkwindow-x11.c: Delete unused private gdk_visual_lookup(),
	make gdk_colormap_lookup() private gdkcolor-x11.c.
	make gdk_window_add_colormap_windows private to gdkwindow-x11.c
	(#85674)

	* gdk/x11/gdkx.h gdk/x11/gdkcolor-x11.c 
	gdkscreen-x11.h: Add gdk_x11_colormap_foreign_new(), 
	GDK_ENABLE_BROKEN gdkx_colormap_get(), make the
	colormap hash per-screen. (#85697)

	* gdk/x11/gdkxid.c (gdk_xid_table_lookup_for_display):
	Remove a bit of unecessary code.

Thu Aug  8 16:58:22 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkspinbutton.c (gtk_spin_button_real_change_value): 
 	Remove the check for editable. (Reported by Brent Fox)
 
Tue Sep 24 06:17:37 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkeventbox.c (gtk_event_box_paint): Honor
	GTK_WIDGET_APP_PAINTABLE() (#92305, Jonathan Blandford.)

Tue Sep 24 05:26:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.h gdk/gdkdisplay.c gdk/linux-fb/gdkevents-fb.c 
	gdk/x11/gdkevents-x11.c  gdk/win32/gdkevents-win32.c:
	Change the window parameter for 
	gdk_event_send_client_message[_for_display] from guint32
	to GdkNativeWindow. (#79979)

Tue Sep 24 05:16:25 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk+.spec.in: Fix up a bit to look for the loaders
	in the right place. (#93011, Dennis Dementiev)

Tue Sep 24 05:12:14 2002  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtkimcontextsimple.c: Fixes to GtkIMContextSimple
        compose table for us-intl keyboards (Red Hat bugzilla
        #70995, Alexandre Oliva)

Tue Sep 24 04:50:28 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkspinbutton.c (gtk_spin_button_activate):   
	Chain up so that entry->activates_default is honored.
	(#93865, Pieter Penninckx)

2002-09-23  Jacob Berkman  <jacob@ximian.com>

	* gtk/gtkprogress.c (DEFAULT_FORMAT): cpp macros aren't ``;''
	terminated

Mon Sep 23 19:49:11 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkselection.[ch] gtk/gtkwidget.c gtk/gtkmain.c:
	Privatize gtk_selection_request, gtk_selection_incr_event
	gtk_selection_notify, gtk_selection_property_notify.
	Add doc note about future deprecation of gtk_selection_clear()
	which. (#85683)

	* gtk/gtkoldeditable.c (gtk_old_editable_selection_clear):
	Chain up, rather than calling gtk_selection_clear().

Mon Sep 23 18:53:35 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkprogressbar.c (gtk_progress_bar_set_text): 
	Restore back to the default format instead of an
	empty format. (#82626, Tim Janik)

	* gtk/gtkprogress.c (gtk_progress_set_format_string): 
	Make NULL restore back to the default format.

Mon Sep 23 18:45:46 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenuitem.c (gtk_menu_item_set_accel_path): 
	Allow accel_path == NULL. (#84241, James Henstridge.)

Mon Sep 23 18:01:52 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.[ch]: Add gtk_notebook_get_n_pages
	(#73229, Havoc Pennington)

	* gtk/gtknotebook.c (gtk_notebook_get_nth_page): Handle
	-1 to mean the last page, as we do elsewhere. (#73229)

Mon Sep 23 17:50:23 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.[ch] gtk/gtkentry.c gtk/gtkmenubar.c
	gtk/gtkmenuitem.c gtk/gtktextview.c: Make
	gtk_menu_shell_select_first() public. (#70373)

Mon Sep 23 16:48:46 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkkeys.[ch] gdk/x11/gdkkeys-x11.c gdk/x11/gdkevents-x11.c:
	Add a keys_changed signal emitted when the keymap changes.
	(#72148)
	
	* gtk/gtkkeyhash.c (_gtk_key_hash_remove_entry): 
	Hook up code to handle keymap changes, change to keep
	a linked list of keymap entries so that we can reinsert
	them in the same order on a keymap change.

Mon Sep 23 14:58:04 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkhandlebox.h gtk/gtktextbtree.[ch]:
 	Use 'signed int' not 'gint' for signed bitfields.
 	(#93020, Vitaly Tishkov)
 
 	* gtk/gtktextlayout.h gtk/gtktextbtree.[ch]: 
 	Fix some 'gint' bitfields that should have been
 	unsigned.
	
Mon Sep 23 12:24:14 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/gtkimcontextxim.c (status_window_get): 
	Fix incorrect usage of gdk_get_default_root_window ()).
	(#92767)

Mon Sep 23 12:12:48 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkspinbutton.c: Patch from Joshua N Pritikin to
	fix problem where signal connection wasn't removed
	from adjustment on finalize. (#93962)

Sun Sep 22 18:22:37 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/linux-fb/{gdkinput.c,gdkkeyboard-fb.c,gdk/linux-fb/gdkmain-fb.c,
	gdk/linux-fb/gdkprivate-fb.h, gdk/linux-fb/gdkwindow-fb.c}:
	Patch from Eric Warmenhoven to with miscellaneous linux-fb
	fixes, including a fix for a crash in 
	gdk_keymap_get_entries_for_keycode (#87420)

2002-09-22  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkdraw.c (gdk_drawable_get_type): 
	* gdk/gdkgc.c (gdk_gc_get_type): 
	* gtk/gtkmenushell.c (gtk_menu_shell_get_type): 
	* gtk/gtkimcontext.c (gtk_im_context_get_type): 
	* gtk/gtkprogress.c (gtk_progress_get_type): 
	* gtk/gtkoldeditable.c (gtk_old_editable_get_type): 
	* gtk/gtkcellrenderer.c (gtk_cell_renderer_get_type): 
	* gtk/gtkwidget.c (gtk_widget_get_type): 
	* gtk/gtkseparator.c (gtk_separator_get_type): 
	* gtk/gtkscrollbar.c (gtk_scrollbar_get_type): 
	* gtk/gtkscale.c (gtk_scale_get_type): 
	* gtk/gtkrange.c (gtk_range_get_type): 
	* gtk/gtkpaned.c (gtk_paned_get_type): 
	* gtk/gtkmisc.c (gtk_misc_get_type): 
	* gtk/gtkitem.c (gtk_item_get_type): 
	* gtk/gtkcontainer.c (gtk_container_get_type): 
	* gtk/gtkbbox.c (gtk_button_box_get_type): 
	* gtk/gtkbox.c (gtk_box_get_type): 
	* gtk/gtkbin.c (gtk_bin_get_type): 
	* gtk/gtkobject.c (gtk_object_get_type): Mark abstract types as
	G_TYPE_FLAG_ABSTRACT.  (#72383)

2002-09-21  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkselection-win32.c (sanitize_utf8): Copy from X11
	backend. The old version mishandled consecutive newlines.

	* tests/testgtkrc: Remove obsolete mention of gtk-engines and
	Pixmap theme engine on Win32.

Fri Sep 20 18:01:26 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkentry.c (gtk_entry_unrealize): Set the IM
 	context client 	window to NULL, not to the window that 
 	is about to be destroyed. (#88231)
 
Fri Sep 20 16:56:54 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_reparse_all_for_settings):
	Return TRUE if force_load was specified. (#93738,
	Vitaly Tishkov.)

2002-09-20  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkmain.c (gtk_get_default_language): On Win32, look
	explicitly for LANG, LC_ALL and LC_CTYPE, and if not found, use
	g_win32_getlocale(). The setlocale() in msvcrt.dll would return a
	locale name in the form Swedish_Finland for sv_FI.

	* gdk/gdkfont.h: Delete leftover declarations of the obsolete
	Win32-only functions gdk_font_full_name_get() and
	gdk_font_full_name_free().

	* gdk/gdk.def: Delete from here, too.

	* gdk/win32/gdkfont-win32.c (logfont_to_xlfd,
	gdk_font_full_name_get, gdk_font_full_name_free): Delete
	implementation, and helper functions.

	(pattern_match, InnerEnumFontFamExProc, EnumFontFamExProc,
	gdk_font_list_new, gdk_font_list_free): Delete unused functions.

	(gdk_text_width, gdk_text_width_wc) Instead of code duplication,
	let gdk_text_extents() and gdk_text_extents_wc() do the job.
	
	* gdk/win32/gdkgc-win32.c (gdk_win32_gc_values_to_win32values):
	Don't use the above removed functions in debugging output.

	* gdk/win32/gdkdisplay-win32.c
	* gdk/win32/gdkmain-win32.c
	* gdk/win32/gdkprivate-win32.h
	* gdk/win32/gdkselection-win32.c
	* gdk/win32/gdkinput-win32.h
	* gdk/win32/gdkinput.c: Make it compile again, pass a GdkDisplay in
	a couple of places.

Thu Sep 19 16:39:29 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksettings.h (GTK_SETTINGS_GET_CLASS): Fix 
	usage of compat GTK_TYPE_ macros without including
	gtkobject.h.

	* gdk/x11/gdkevents-x11.[ch]: Set a flag when initializing
	to avoid having extra settings-notify events sent
	when not needed.

2002-09-17  Matthias Clasen  <maclas@gmx.de>

	* gtk/stock-icons/stock_color_picker_25.png:
	* gtk/stock-icons/Makefile.am (VARIABLES1): 
	* gtk/gtkstock.h (GTK_STOCK_COLOR_PICKER): 
	* gtk/gtkiconfactory.c (get_default_icons):  
	* gtk/gtkcolorsel.c (gtk_color_selection_init): Stockify color
	picker icon.   (#89880)

2002-09-14  Sven Neumann  <sven@gimp.org>

	* gdk/gdkpixbuf-drawable.c: fixed my latest change.

2002-09-13  Sven Neumann  <sven@gimp.org>

	* gdk/gdkpixbuf-drawable.c: use the most significant bits of the
	GdkColor components (#89703).

2002-09-12  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkinput-win32.c (gdk_input_wintab_init): Use correct
	function name in warning messages.

	Merge from gtk-2-0:

	* gdk/win32/gdkdrawable-win32.c
	* gdk/win32/gdkevents-win32.c: Some spacing and indentation cleanup.
	
	* gdk/win32/gdkdrawable-win32.c (render_line_horizontal,
	render_line_vertical): Return TRUE.
	
	* gdk/win32/gdkevents-win32.c (_gdk_events_init): Search if the
	system has some input locale identifier that uses a Latin
	keyboard. This is needed to be able to get the virtual-key code
	for the latin characters corresponding to ASCII control
	characters. If no such keyboard is present, try to load one
	then. Will this upset users with no wish to ever use a Latin-based
	keyboard layout?

	(vk_from_char): Convert all ASCII control chars to the
	corresponding uppercase char before calling VkKeyScanEx(). Idea by
	Florent Duguet. Makes Control-C work again. To make it hopefully
	work like I think it should on non-Latin keyboards, too, use
	latin_locale when looking for the corresponding keycode.

	* gdk/win32/gdkgeometry-win32.c: Add GDK_NOTE debugging output
	to some functions, related to moving and resizing and expose
	and antiexpose queue processing. Use %p to output HWNDs.

	* gdk/win32/gdkkeys-win32.c (print_keysym_tab): Factor out
	debugging output to new function.

	Fix for #81831 by Tim Evans:
	
	* gdk/win32/gdkevents-win32.c (gdk_event_translate): Don't call
	_gdk_event_button_generate() here, it would append the double- or
	triple-click events too early, before the single-click event.

	(real_window_procedure): If we got a single-click event, call
	_gdk_event_button_generate() to perhaps append the double- or
	triple-click event after that.

	Tentative fix for #79720 based on code by Florent Duguet:
		
	* gdk/win32/gdkgeometry-win32 (gdk_window_queue_append): New
	static function. Checks length of translate_queue, calls
	_gdk_window_process_expose() if length is >= 128. Then appends
	to translate_queue.
	(gdk_window_queue_translation,_gdk_windowing_window_queue_antiexpose):
	Call gdk_window_queue_append().

	Merge from gtk-1-3-win32-production and gtk-2-0:

	* gdk/win32/gdkevents-win32.c (propagate): Check for parent being
	NULL before trying to propagate to it, and return FALSE in that
	case. (If parent is NULL, we are handling gdk_parent_root, and
	probably should have noticed that and bailed out earlier. But
	better late than never.)

	* gdk/win32/gdkinput-win32.c (gdk_input_init): Use
	GetSystemMetrics (SM_C[XY]SCREEN) instead of
	gdk_screen_{width,height}().

	* gdk/win32/gdkselection-win32.c (gdk_selection_convert): Don't
	use return value from GlobalSize() as length of string when
	calling MultiByteToWideChar(). Pass -1 instead (zero-terminated
	string). Thanks to Iwasa Kazmi.

Wed Sep 11 15:48:38 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodel.c (gtk_tree_row_reference_get_type): Make
	GtkTreeRowReference a boxed type.

	* gtk/gtkliststore.c (gtk_list_store_finalize): free the root
	list.

	* gtk/gtktreestore.c (gtk_tree_store_finalize): free the root
	nodes.

Wed Sep 11 12:33:34 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkstyle.c: Draw radio buttons more symmetric. Draw shadow
	out bevels slightly different. Fix drawing of top right corner of
	etched in shadows.

Tue Sep 10 09:47:52 2002  HideToshi Tajima  <hidetoshi.tajima@sun.com>

	* modules/input/gtkimcontextxim.c
	(get_im): modify a warning when XSetLocaleModifiers() fails, and
	add a warning when XOpenIM() fails
	(gtk_im_context_xim_filter_keypress): use XLookupString when xic
	is not available. (#90661)
	(gtk_im_context_xim_get_ic, gtk_im_with_preedit,
	gtk_im_without_preeedit): filter key release events only when
	input methods ask for (#81759)

Tue Sep 10 11:11:09 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/linux-fb/*: Patch from Eric Warmenhoven to
	get linux-fb compiling with multihead changes.

Tue Sep 10 09:29:00 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c (gdk_event_translate): Take
	focus mode into account when tracking FocusIn/Out events,
	so we don't get confused by focus changes while a 
	keyboard grab is in effect. (Probably fixes #90563)

Mon Sep  9 16:16:25 2002  Shivram U  <shivaram.upadhyayula@wipro.com>

	* gtk/gtktextview.c (gtk_text_view_drag_motion): If the end iter
	is also a part of the selection, then we are in the selection.
	(#92768)

2002-09-08  Tor Lillqvist  <tml@iki.fi>

	* configure.in: Add AM_CONDITIONAL calls also in the non-x11
	branch. Otherwise we get "conditional \"$1\" was never defined.
	Usually this means the macro was only invoked conditionally."
	errors when running configure if using automake 1.6a. Yeah, I know
	that autogen.sh says to use automake 1.4, but on Win32 I more or
	less have to use the bleeding edge. I think.

Sat Sep  7 21:24:55 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtktoolbar.c (get_button_relief): call
	gtk_widget_ensure_style() before reading "button_relief". Fixes
	(#92741).

2002-09-06  Matthias Clasen  <maclas@gmx.de>

	* configure.in: Add ani to all_loaders.

Fri Sep  6 15:59:54 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdisplay.h: Remove unused prototype for 
	gdk_set_default_display 
	(=> gdk_display_manager_set_default_display)
	(#90616, Matthias Clasen)

Fri Sep  6 15:35:01 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkgc.c (gdk_gc_new_with_values): Only set
	gc->colormap if it isn't already set. (Alex Larsson,
	#90632)

Fri Sep  6 12:41:16 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/gtkimcontextxim.c: Pass the actual input
	keycode to XIM, rather than the result of backconverting
	the keysym. Fixes the <> input problem! (#74922)

	* gtk/gtkimmodule.c: Fix bug where GTK_IM_MODULE environment
	variable couldn't be used to force the input method to
	the default input method.

2002-09-05  jacob berkman  <jacob@ximian.com>

	* configure.in: fix non-solaris xinerama checks (bug #89732)

	* autogen.sh: get automake-1.4 changes from -2-0 branch

2002-09-05  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkproperty-win32.c (gdk_property_change): Fix braino,
	actually do check each char, not just the first one, when looping
	through the text looking to insert CR in front of each LF. Bug
	noticed and fix provided by Florent Duguet.

	* gdk/win32/gdkwindow-win32.c (gdk_window_set_transient_for): 
	Use HWND_NOTOPMOST instead of HWND_TOPMOST. Suggested by Florent
	Duguet.

2002-09-04  Matthias Clasen  <maclas@gmx.de>

	* demos/testanimation.c (do_image): 
	(do_nonprogressive): Quit on destroy.

	* demos/testpixbuf.c (main): test load-at-size.
	(expose_func): draw transparent pixbufs against a checkerboard 
	pattern. (#91829)

2002-09-01  Soeren Sandmann  <sandmann@daimi.au.dk>

	* docs/reference/gtk/tmpl/gtkdialog.sgml
	docs/reference/gtk/tmpl/gtkhbbox.sgml
	docs/reference/gtk/tmpl/gtkvbbox.sgml
	docs/reference/gtk/tmpl/gtktogglebutton.sgml
	docs/reference/gtk/tmpl/gtktreeselection.sgml
	gtk/gtktextbuffer.c
	gtk/gtktogglebutton.c
	gtk/gtktreesortable.c

	Minor documentation fixes:
	
	#79107, #82854, #76398, Vitaly Tishkov; 
	#88627, Brian Tarricone;
	#81046, Owen Taylor

2002-08-31  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkevents-win32.c (_gdk_events_init): On Cygwin, open
	/dev/windows instead of using the magic G_WIN32_MSG_HANDLE fd that
	is implemented (in GLib) only on native Win32. (#91683, Masahiro
	Sakai)

	* gtk/gtkfilesel.c: Include <sys/cygwin.h on Cygwin, for
	cygwin_conv_to_posix_path().
	(translate_win32_path, get_real_filename): Use
	cygwin_conv_to_posix_path().
	(gtk_file_selection_dir_activate): Call get_real_filename() here,
	too. (#91843, Masahiro Sakai)

2002-08-26  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkwindow-win32.c (RegisterGdkClass): Use MAX_PATH
	(from windef.h) insted of _MAX_PATH (from stdlib.h in mingw and
	MSVC, but not there in Cygwin) (#91681, Masahiro Sakai).

Mon Aug 26 12:21:16 BST 2002  Tony Gale <gale@gtk.org>

	* docs/tutorial/package-db-tutorial.sh: cleanups

	* docs/tutorial/gtk-tut.sgml: new content for the
	ItemFactory section. Originally from Robert Cleaver Ancell.

2002-08-25  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkfilesel.c: Don't include <winsock.h> on Cygwin (#91654,
	Masahiro Sakai).

	* gtk/gtkmain.c: Compile gtk_init_abi_check and
	gtk_init_check_abi_check when on G_PLATFORM_WIN32, not just on
	G_OS_WIN32, to match gtkmain.h (#91649, Masahiro Sakai).
	(check_sizeof_GtkWindow, check_sizeof_GtkBox): Mention the
	-mms-bitfields swicth in addition to -fnative-struct.

Sun Aug 25 11:58:27 BST 2002  Tony Gale <gale@gtk.org>

	* docs/tutorial/package-db-tutorial.sh:
	update packaging script for current tutorial

	* docs/tutorial/images/*.eps: New Files
	EPS versions of the tutorial images

2002-08-25  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkmain.h: Include gtkbox.h and gtkwindow.h on Win32, as the
	defines for struct packing checks use sizeof() on stuff from
	these. (#84211, Andreas Holzmann)

	* gtk/Makefile.am (libgtk_win32_2_0_la_DEPENDENCIES): Add
	gtk_win32res_lo. (#87101, J. Ali Harlow)

	* gdk/gdkevents.c
	* gdk/gdkinternals.h
	* gdk/x11/gdkevents-x11.c
	* gdk/win32/gdkevents-win32.c: Move the GdkEventPrivate and
	GdkEventFlags definitions from gdkevents.c to
	gdkinternals.h. Remove the duplicated definitions in
	gdkevents-x11.c and gdkevents-win32.c. (#89771)

2002-08-24  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkevents-win32.c (gdk_event_translate): Let the
	system handle Alt-Space, too. Thanks to Tim Evans (#91477).

Sat Aug 24 12:46:37 BST 2002  Tony Gale <gale@gtk.org>

	* docs/tutorial/gtk-tut.sgml, examples/*:
	update g_connect_signal usage

	* docs/faq/gtk-faq.html: spelling/grammar fixes

2002-08-21  Tor Lillqvist  <tml@iki.fi>

	* gdk/Makefile.am: Move GDK_DEP_LIBS from LDFLAGS to each of the
	libgdk_*_LIBADD, to fix problems when cross-compiling, as
	suggested by J. Ali Harlow in #87103.

2002-08-19  Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtkentry.c (gtk_entry_real_delete_text): Use 
	gtk_entry_set_positions() to update current_pos and selection_bound
	so notifications are emitted (#90548)

2002-08-16  jacob berkman  <jacob@ximian.com>

	* gtk/gtkdialog.h (struct _GtkDialog): switch vbox and action_area
	back to the order that 2.0 has

Thu Aug 15 22:46:02 BST 2002  Tony Gale <gale@gtk.org>

	* docs/tutorial/gtk-tut.sgml, examples/menu/menu.c:
	  minor menu example comment fix
	  (feeling my way back in after a long absence)

Wed Aug 14 08:07:53 2002  HideToshi Tajima  <hidetoshi.tajima@sun.com>

	* gtk/gtkselection.c (gtk_selection_init): initialize
	gtk_selection_atoms only once at the 1st call.
	* gdk/x11/gdkselection-x11.c (gdk_selection_property_get): 
	set length of selection data from number of read bytes (#90595)

2002-08-14 Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtktextview.c (gtk_text_view_focus): Move focus to
	children, if they exist, after GtkTextView is focused. (#63844)

2002-08-12  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkdisplaymanager.c: 
	* gdk/gdkdisplay.c (gdk_pointer_ungrab): Fix doc comments.

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_get_screen): 
	* gdk/x11/gdkimage-x11.c (gdk_image_new_bitmap): Make parameter 
	names match those in the header file, to silence gtk-doc.

Sat Aug 10 22:18:05 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkpixbuf-render.c 
	(gdk_pixbuf_render_pixmap_and_mask[_for_colormap]): Mention
	in the docs that @pixmap_return and @mask_return can
	be %NULL.

2002-08-10  Soren Sandmann  <sandmann@daimi.au.dk>

	* docs/reference/gtk/tree_widget.sgml,
	docs/reference/gtk/tmpl/gtkdialog.sgml,
	docs/reference/gtk/tmpl/gtkentry.sgml,
	docs/reference/gtk/tmpl/gtkfilesel.sgml,
	docs/reference/gtk/tmpl/gtkfontsel.sgml,
	docs/reference/gtk/tmpl/gtkfontseldlg.sgml,
	docs/reference/gtk/tmpl/gtktreemodel.sgml,
	docs/reference/gtk/tmpl/gtkwidget.sgml, gdk/x11/gdkdisplay-x11.c,
	gtk/gtkbbox.c, gtk/gtkbox.c, gtk/gtkbutton.c, gtk/gtkcellrenderer.c,
	gtk/gtkcellrendererpixbuf.c, gtk/gtkcellrenderertext.c,
	gtk/gtkcheckmenuitem.c, gtk/gtkcontainer.c, gtk/gtkcurve.c,
	gtk/gtkdialog.h, gtk/gtkentry.c, gtk/gtkfilesel.c, gtk/gtkfontsel.c,
	gtk/gtkframe.c, gtk/gtkhandlebox.c, gtk/gtkiconfactory.c,
	gtk/gtkimage.c, gtk/gtkinvisible.c, gtk/gtkitemfactory.c,
	gtk/gtklabel.c, gtk/gtklayout.c, gtk/gtkmenu.c, gtk/gtkprogress.c,
	gtk/gtkprogressbar.c, gtk/gtkscrolledwindow.c, gtk/gtksizegroup.c,
	gtk/gtktable.c, gtk/gtktextiter.c, gtk/gtktexttag.c, 
	gtk/gtktexttag.h, gtk/gtktextview.c, gtk/gtktogglebutton.c, 
	gtk/gtktoolbar.c, gtk/gtktreemodel.c, gtk/gtktreeselection.c, 
	gtk/gtktreestore.c, gtk/gtktreeview.c, gtk/gtktreeviewcolumn.c, 
	gtk/gtkviewport.c, gtk/gtkwidget.c, gtk/gtkwidget.h,
	gtk/gtkwindow.c: 

	Minor documentation fixes

	(#89254, patch from Brett Nash; 
	 #85809, patch from daten@dnetc.org;
	 #76391, patch from Ross Burton; 
	 #74559, Manuel Clos; 
	 #73569, #72005, Alexey A. Malyshev; 
	 #70061, patch from Dennis Bj"orklund;
	 #64566, #63388, #58328, #57499, #81007, #77349, Vitaly Tishkov; 
	 #78932, Vitaly Tishkov, patch from Ross Burton;
	 #73306)

2002-08-10  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkrgb.c (gdk_rgb_try_colormap): 
	(gdk_rgb_create_info): 
	(gdk_rgb_select_conv): 
	(gdk_draw_gray_image): 
	(gdk_rgb_cmap_get_info): Changes to support depth 8 StaticColor
	visuals.  (#81631)
	(gdk_rgb_cmap_free): Don't loop forever.

Fri Aug  9 08:04:47 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdisplay.h (struct _GdkDisplayClass): Fix 
	weird usage of 'class' for GdkDisplay * argumnent name.
	(#9031, Laszlo Peter)

Thu Aug  8 23:26:05 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkmain-x11.c gdk/x11/gdkscreen-x11.c: Remove
	explicit calls to pango_x/xft_shutdown_display() since
	Pango now does it by itself on XCloseDisplay().

Thu Aug  8 21:53:16 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Consistently order pangoxft / pangox
	in pkg-config calls in hopes of reducing problems
	(Eric Mader.)

2002-08-07  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkmain.c (gtk_init): Fix doc comment.

	* gtk/gtktreemodel.c (gtk_tree_path_new_from_indices): Make the
	doc comment gtk-doc-grokkable.

2002-08-06  jacob berkman  <jacob@ximian.com>

	* configure.in: link gdk-pixbuf-xlib against x libs (bug #83442)

Mon Aug  5 17:20:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c: Patch from Soeren Sandmann
	to improve GtkLabel behavior when it gets
	a too small allocation. (Always display the
	initial portion.) (#71742)

Mon Aug  5 17:01:30 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/Makefile.am (LDFLAGS): When overriding LDFLAGS,
	include @LDFLAGS@, otherwise LDFLAGS the users passes
	to configure don't get used. (#89946, Noah Levitt, 
	Albert Chin)

	* gdk/linux-fb/Makefile.am: Remove LDFLAGS setting.

Mon Aug  5 15:25:40 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkpixbuf-render.c (gdk_pixbuf_render_pixmap_and_mask_for_colormap): 
	Fix problem with wrong depth being used. (#89941, Jacob
	Berkman.) Remove an unneeded 'screen' variable.

Mon Aug  5 15:04:59 2002  Owen Taylor  <otaylor@redhat.com>

	More fixes for warnings reported by David L. Cooper II

	* gtk/gtkaccelmap.c (accel_map_parse_accel_path): Use
	GdkModifierType for accel_mods. (#85856)

	* gdk/gdkdisplay.h (struct _GdkDisplay): Make button_number
	signed, since we use -1 as an 'unset' value. (#85854)

	* gdk/x11/xsettings-client.c (parse_settings): Suppress
	a warning (#85853)

	* gdk/x11/gdkfont-x11.c (gdk_font_charset_for_locale): Fix
	accidental trailing ';'. (#85846)

Mon Aug  5 14:50:13 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkitemfactory.h: Add a note that yes, we do know
	what () means and we can't change it.

	Fixes for warnings reported by David L. Cooper II

	* tests/testtext.c: Warning fixes. Fix order of arguments
	to gtk_message_dialog_new(). (#85891)

	* gtk/gtktreeitem.c (gtk_tree_item_paint): Fix incorrect
	use GTK_STATE_INSENSITIVE for a shadow type. (Not clear
	what the drawing intent was, but it's ENABLE_BROKEN
	anyways.) (#85880)

	* gtk/gtktexttypes.c: Use character literals
	instead of direct constants to avoid warning. (#85878)

	* gtk/theme-bits/decompose-bits.c gtk/gtkstyle.c:
	Fix some signed/unsigned problems (#85876)

	* gtk/gtksignal.c (gtk_signal_newv): Add an explicit
	cast from GtkSignalRunType to GSignalFlags. (#85875)

	* gtk/gtkitemfactory.c (gtk_item_factory_add_item): Fix
	use of guint instead of GdkModifierType (#85871)

	* gtk/gtkimmulticontext.c (gtk_im_multicontext_append_menuitems): 
	Fix signed/unsigned problem (#85870)

	* gtk/gtkimcontext.c (gtk_im_context_class_init): Get
	rid of GtkType/Signal*. (Fixes #85869 as a side effect)

	* gtk/gtkdnd.c (gtk_drag_get_cursor): Fix some 
	signed/unsigned warnings (#85865)

2002-08-04  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkmain.c (gtk_check_version): Fix for binary compatibility
	across 2.x.y.

Fri Aug  2 18:00:46 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c: Fix menus resizing dynamically while
	they are popped up or torn off. (#78949)

Fri Aug  2 16:38:34 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkregion-generic.c: Comprehensively add
	g_return_[val]if_fail() statements. (#89491, Robin Lu)

Fri Aug  2 16:24:32 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkmain-x11.c: Remove references to 
	gdk_initialized (#81060, Jacob Berkman)
	
	* gdk/gdk.c (gdk_exit): Remove gdk_exit_func().

Fri Aug  2 15:56:47 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkscreen-x11.c (gdk_screen_x11_dispose): Fix
	args to pango_x_shutdown_display().

	* gdk/linux-fb/gdkinput.c gdk/linux-fb/gdkinputprivate.h
	gdk/win32/gdkinput-win32.[ch] gdk/win32/gdkinput.c
	gdk/win32/gdkwindow-win32.c gdk/x11/gdkinput-x11.c
	gdk/x11/gdkinput-xfree.c gdk/x11/gdkinput.c
	gdk/x11/gdkinputprivate.h gdk/x11/gdkwindow-x11.c: Move
	a bunch of functions gdk_input => _gdk_input. Clean
	up some header file cruft. (#79971)

Fri Aug  2 12:21:41 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkscreen-x11.c (gdk_screen_x11_dispose):
	Call pango_x[ft]_shutdown_display().

2002-08-02  jacob berkman  <jacob@ximian.com>

	* gdk/x11/gdkscreen-x11.c (check_xfree_xinerama): declare
	screen_x11 variable to fix build w/ xinerama

Fri Aug  2 00:43:15 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdrawable-x11.[ch] gdk/x11/gdkgc-x11.c
	gdk/x11/gdkpango-x11.c gdk/x11/gdkpixmap-x11.c 
	gdk/x11/gdkprivate-x11.h gdk/x11/gdkwindow-x11.c:
	Switch back to using XftDraw so that we take 
	advantage of the draw-to-non-RENDER capabilities
	of Xft2.

	* demos/gtk-demo/changedisplay.c (query_for_toplevel): 
	Fix the case where the user clicks on the "click on
	a window popup".

Thu Aug  1 19:09:39 2002  Owen Taylor  <otaylor@redhat.com>

	* demos/gtk-demo/changedisplay.c: New demo for
	window migration between different displays and screens.

	* gtk/gtkrc.c gtkstyle.[ch]: Add
	_gtk_style_init_for_settings(), so that gtkrc.c
	can initialize the styles it creates for the 
	right display.

	* gdk/gdkdisplaymanager.c (gdk_screen_get_default)
	* gtk/gtksettings.c (gtk_settings_get_default)
	* gtk/gtkstyle.c (gtk_style_init): Handle absence of
	a default screen.

	* gdk/x11/gdkmain-x11.c (_gdk_windowing_set_default_display):
	Handle display == NULL.x

	* gdk/gdkdisplay.c (gdk_display_dispose): Free the
	event queue.

	* gdk/x11/gdkevents-x11.c gdk/x11/gdkdisplay-x11.c:
	Remove the event source when closing a display.

	* gdk/gdkdisplay.[ch]: Add a ::closed signal, dispose()
	isn't convenient enough by itself.

	* gdk/x11/gdkevents-x11.c (gdk_xsettings_watch_cb):
	Create foreign windows for watch windows if there isn't
	an existing window, instead of installing a global filter.
	
	* gdk/x11/gdkscreen-x11.c gdk/x11/gdkprivate-x11.h
	gdk/x11/gdkevents-x11.c (_gdk_x11_events_uninit_screen):
	Clean up the xsettings_client when we are done with
	it.

	* gdk/x11/gdkevents-x11.c (_gdk_events_init): Remove
	excess call to _gdk_x11_events_init_screen()

2002-08-01  Sven Neumann  <sven@gimp.org>

	Merge from stable:

	* gdk/gdkrgb.c: trivial changes to some debug code so it compiles
	with VERBOSE being defined.

Thu Aug  1 11:26:03 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdisplay.[ch] gdk/gdkscreen.[ch] gdkinternals.h:
	Start implementing display/screen closing scheme; keep a
	flag for whether displays and screens are closed,
	call g_object_run_dispose(). Remove public gdk_screen_close().

	* gdk/x11/gdkdisplay-x11.c gdk/x11/gdkscreen-x11.c: Add 
	dispose() methods; move appropriate parts of the finalize
	there.

	* gdk/x11/gdkcolor-x11.c gdk/x11/gdkimage-x11.c
	gdk/x11/gdkmain-x11.c gdk/x11/gdkpango-x11.c 
	gdk/x11/gdkpixmap-x11.c gdk/x11/gdkproperty-x11.c
	gdk/x11/gdkselection-x11.c gdk/x11/gdkwindow-x11.c:
	Start of making everything correctly ignore operations
	when a display has been closed.

	* gdk/x11/gdkwindow-x11.c (gdk_window_get_decorations):
	Handle decorations == NULL.

	* gdk/x11/gdkcolor-x11.c (gdk_colormap_remove): 
	Remove unnecessary hash table creation.

	* gdk/x11/gdkinput.c gdk/x11/gdkinput-x11.c gdk/win32/gdkinput.c
	Fix up gdk_device_get_history - handle events, n_events == NULL,
	etc.

	* gdk/x11/gdkproperty-x11.c (gdk_property_get):
	Handle failure better.
	
	* gdk/x11/gdkselection-x11.c (gdk_selection_property_get):
	Handle failure better, handle data == NULL, move docs
	here, remove an excess round trip by asking for
	all selection data at once.
	
	* gdk/gdkselection.c gdk/win32/{x11,win32}/gdkselection-{x11,win32}.c
	  gdk/{x11,win32}/gdkmain-{x11,win32}.c	gdk/gdkdisplay.c: Move
	gdk_text_property_to_text_list(), gdk_string_to_compound_text(),
	gdk_display_set_sm_client_id() to display-independent part of GDK.

	* gdk/Makefile.am (gdk_c_sources): Sort gdkdisplay/screen.[ch]
	into the right place.

2002-07-31  jacob berkman  <jacob@ximian.com>

	* gtk/queryimmodules.c (print_escaped): escape_string() only takes
	one arg

Wed Jul 31 12:50:51 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/queryimmodules.c: Avoid using g_strescape(),
	since it mangles UTF-8, (#89479, Yao Zhang.)

Tue Jul 30 19:09:46 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c (gtk_range_scroll_event): Handle 
	inverted ranges correctly (#85436, fix from 
	Norihiro UMEDA)

Tue Jul 30 16:36:53 2002  Owen Taylor  <otaylor@redhat.com>

	* tests/testgtk.c: Fix bug in the selection mode option
	menus which were setting the wrong values. 
	(#85763, Manuel Op de Coul)

Tue Jul 30 15:39:06 2002  Owen Taylor  <otaylor@redhat.com>

	* demos/Makefile.am: Honor GDK_PIXBUF_CSOURCE from
	configure.in when cross-compiling. (#87099,
	J. Ali Harlow)

Mon Jul 29 16:42:30 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimcontext.c (gtk_im_context_real_get_surrounding):
	Unset gtk-im-surrounding-info object data again.
	(Fix from Yao Zhang, #86811)

Fri Jul 26 17:59:06 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* configure.in: Replace uses of grep \(A\|B\) ... with
 	egrep (A|B). (#84872, Arnaud Charlet)
 
Fri Jul 26 22:53:37 2002  Kristian Rietveld  <kris@gtk.org>

	API additions: _move, _reorder and _swap for stores, path
	constructor.

	* gtk/gtktreemodel.[ch] (gtk_tree_path_new_from_indices): new function.

	* gtk/gtkliststore.[ch]: added gtk_list_store_reorder_func (private),
	gtk_list_store_reorder, gtk_list_store_swap, gtk_list_store_move.

	* gtk/gtktreestore.[ch]: added gtk_tree_store_reorder_func (private),
	gtk_tree_store_reorder, gtk_tree_store_swap, gtk_tree_store_move.

Fri Jul 26 22:32:57 2002  Kristian Rietveld  <kris@gtk.org>

	Merge from stable:

	* gtk/gtktreestore.c (node_free): return FALSE,
        (gtk_tree_store_finalize): use g_node_traverse instead of
        g_node_children_foreach, so the whole tree will be freed (#88854,
        patch from Emmanuel Briot).

Fri Jul 26 22:32:24 2002  Kristian Rietveld  <kris@gtk.org>

	Merge from stable:

        * gtk/gtktreeview.c (gtk_tree_view_button_press): fix some memleaks,
        (#84426, patch from Matthias Clasen).

Fri Jul 26 22:31:25 2002  Kristian Rietveld  <kris@gtk.org>

	Merge from stable:

        * gtk/gtktreeview.c (gtk_tree_view_unref_tree_helper): _iter_children
        check shouldn't be in g_return_return_val_if_fail (pointed out by
        Josh Green, #88997),
        (gtk_tree_view_set_model): call _gtk_tree_view_column_unset_model
        for each column when we unset the model (part of #82484),
        (gtk_tree_view_get_cell_area): return if we ran out of tree or
        if we got an invalid path (#82376).

        * gtk/gtktreeprivate.h: add _gtk_tree_view_column_unset_model.

        * gtk/gtktreeviewcolumn.c: implement _gtk_tree_view_column_unset_model
        which disconnects the sort_column_changed_signal (part of #82484).

        * gtk/gtkliststore.c (gtk_list_store_insert): append row if the
        given postion is off the end of the tree (#85813).

        * gtk/gtkentry.c (gtk_cell_editable_key_press_event): let's use
        2-space indent, commit changes if up/down keys has been pressed,
        this overrides the focus key foo so the user won't be surprised
        (#84665).

Fri Jul 26 16:34:34 2002  Shivram U  <shivaram.upadhyayula@wipro.com>

	* gdk/gdkpixbuf-drawable.c (gdk_pixbuf_get_from_drawable),
	(gdk_pixbuf_get_from_image), (rgbconvert), (convert_real_slow):
	Check if depth of the source is not equal to the depth of the colormap
	passed. (#75597)

2002-07-25  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkrgb.c (gdk_rgb_select_conv): Use gdk_rgb_convert_4,
	not gdk_rgb_convert_8 for depth 4, bpp 8, PseudoColor visuals.
	(#88697)
	
Thu Jul 25 14:14:46 2002  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtkmenushell.c: When a menubar is up, use F10 to cycle
	menubars, not Control-Tab (#87159, Calum Benson. Patch from
	Padraig O'Briain.)
	
	* gtk/gtkmenubar.c: When cycling menu bars, cancel
	after the last instead of wrapping around.

Thu Jul 25 11:57:57 2002  Owen Taylor  <otaylor@redhat.com>

	[ Patch from Padraig O'Briain, #87904 ]

	* gtk/gtkwidget.c (gtk_widget_class_init): Cleanup -
	use G_SIGNAL_RUN_LAST not GTK_RUN_LAST when using
	g_signal new.

	* gtk/gtktogglebutton.c (gtk_toggle_button_mnemonic_activate): 
	Always focus the widget, even when we are activating
	as well.

2002-07-24  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c: Apply patch from Gustavo
	Giraldez for bug #78513

Wed Jul 24 16:43:49 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkrc.c docs/references/tmpl/gtkrc.sgml: Don't use
 	GTK_RC_FILES, since it causes problems with what KDE (etc.)
 	does to customize GTK+ themes, use GTK2_RC_FILES instead. (#88987)
 
2002-07-16  Federico Mena Quintero  <federico@ximian.com>

	* gdk/gdkpixbuf-drawable.c (rgb565lsb): Fixed the LSB -> MSB case.
	Fixes #79463.

2002-07-16  Sven Neumann  <sven@gimp.org>

	* gdk/gdk.c
	* gdk/gdkinternals.h
	* gdk/win32/gdkmain-win32.c
	* gdk/x11/gdkmain-x11.c: pass argc and argv to the GDK backend in
	_gdk_windowing_init() so that the backend has a chance to process
	the command-line arguments (GTK+-DirectFB needs this).

2002-07-10  jacob berkman  <jacob@ximian.com>

	* gtk/gtkoptionmenu.c (gtk_option_menu_scroll_event): activate the
	menu item so old apps work properly

Wed Jul 10 14:27:14 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/gtkimcontextxim.c gtk/gtkcolorsel.c 
	gtk/gtkdialog.c gtk/gtktextbtree.c: Fix some cases
	where signal connection IDs where being assigned to 
	guint rather than gulong. (part of #87281, Shivram U)

Fri Jul  5 20:18:23 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.[ch] gtk/gtkmenubar.c gtk/gtkmenuitem.c
	gtk/gtkentry.c gtk/gtktextview.c: Add an extra parameter
	to _gtk_menu_item_select_first() to allow us to choose
	whether we want to select the first item predictably
	or to select the first sensitive item. Fixes problem
	with insensitive menu items and keynav. (#85796,
	reported by Bill Haneman and others.)

Fri Jul  5 02:50:24 2002  Jonathan Blandford  <jrb@gnome.org>

	* gtk/gtktreeview.c (gtk_tree_view_collapse_all): fix warning.
	(gtk_tree_view_search_iter): fix warning, #85884

	* gtk/gtktreestore.c (gtk_tree_store_get_flags): change return
	value to GtkTreeModelFlags to fix compiler warning, #85883

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_get_flags): change
	return value to GtkTreeModelFlags to fix compiler warning, #85882

	* gtk/gtktreemodel.c (gtk_tree_path_prepend_index): fix compiler
	warning, #85881

Fri Jul  5 12:51:39 2002  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtkliststore.c (gtk_list_store_sort): also update ->tail after	
	sorting.

2002-07-02 Padraig O'Briain <padraig.obriain@sun.com>

	* gtk/gtksocket.c (gtk_socket_hierarchy_changed):
	Use hyphen instead of underscore in signal names in calls to
	g_signal_connect_swapped (Fixes bug #86339)

Tue Jul  2 00:33:26 2002  Jonathan Blandford  <jrb@gnome.org>

    * gtk/gtktreeview.c (validate_visible_area): only validate the
      visible area if we've ever been requisitioned.

Mon Jul  1 17:04:09 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkliststore.c (gtk_list_store_real_set_value): sync up
	white space/variable names to match tree_store equiv.

	* gtk/gtktreestore.c (gtk_tree_store_real_set_value): sort if we
	set the value.

Mon Jul 01 17:19:00 2002  Bill Haneman <bill.haneman@sun.com>

	* contrib/gdk-pixbuf-xlib/gdk-pixbuf-xlib-drawable.c
	(xlib_window_is_viewable):
	Fixed failure of assertion when drawable is root window.

Thu Jun 20 19:41:09 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdisplay.h gdk/gdkscreen.h gdk/*.c gtk/*.c
	tests/*.c: Renames:

	 gdk_get_default_display => gdk_display_get_default
	 gdk_get_default_screen  => gdk_screen_get_default
	 gdk_open_display        => gdk_display_open

Thu Jun 20 16:49:00 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdisplaymanager.[ch] gdk/gdk.[ch] gdk/gdkdisplay.c 
	gdk/gdkinternals.h gdk/x11/gdkdisplay-x11.c 
	gdk/win32/gdkdisplay-win32.c: Add a singleton object that
	we can use to get notification when displays 
	appear / disappear or the default display changes.

	gdk_set_default_display() => gdk_display_manager_set_default_display()
	gdk_list_displays() => gdk_display_manager_list_displays().
	(#85696)

	* gdk/Makefile.am gdk/gdkmarshalers.list: Add marshaler
	generation.

	* gdk/gdkintl.h: Add this.

	* gtk/gtkmain.c: Add gtk_parse_args() that initializes
	GTK+ without opening a display.

	* gtk/gtkmain.c: Set things up so if a module
	exports gtk_module_init() and gtk_module_display_init(), 
	then we treat it as multihead aware, otherwise, 
	we only initialize it after the default display is set.

Thu Jun 20 15:53:21 2002  Owen Taylor  <otaylor@redhat.com>

	Patch from Erwann Chenede.

	* gdk/x11/gdkdisplay-x11.[ch] gdk/x11/gdkprivate-x11.h:
	Introduce a yes/no/unknown GdkTristate, use it
	in a couple of places. (#79962)

	* gdk/x11/gdkwindow-x11.c gdk/x11/gdkdisplay-x11.h: Make 
	gravity_works per-display. (#79963)

Thu Jun 20 15:36:40 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkselection.c (gtk_selection_owner_set): Get
	the owner from the display if !NULL. Otherwise, warn for
	multihead. (#85680)

Thu Jun 20 15:17:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.[ch]: Get rid of gtk_style_get_font_for_display(),
	make gtk_style_get_font() warn for multihead if called
	on an unattached style. (#80277)

	* gtk/gtktext.c: Remove use of gtk_style_get_font_for_display();
	this makes gtktext not multihead safe, but it doesn't matter;
	it's ENABLE_BROKEN anyways.

	* gtk/gtkmain.c gtk/gtkdebug.h: Add GTK_NOTE(MULTIHEAD,[])

Thu Jun 20 14:51:30 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksettings.c (gtk_settings_notify): Only
	change the double click time if the screen for
	the notification is screen 0 of the display.
	(#77978)

	* gdk/gdkevents.c (gdk_display_set_double_click_time): Fix 
	half-done rename.

Thu Jun 20 12:16:00 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkinvisible.c (gtk_invisible_set_screen): Add
	notification for screen property. (#80280)

Wed Jun 19 19:30:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c: Keep a global list of strings and
	RC files to reparse, make gtk_rc_parse_string(),
	gtk_rc_parse() add to the list, and parse the
	string or file in _all_ contexts.

	* gtk/gtkrc.c (gtk_rc_reparse_all): Reparse all
	contexts, not just the default context.

Tue Jun 18 19:38:08 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkinput.c (_gdk_init_input_core): Set the
	display.

	* gdk/x11/gdkwindow-x11.c (_gdk_moveresize_handle_event): Fix
	missing check for mv_resize == NULL.

Tue Jun 18 19:30:25 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktreeview.c: Typo fix.

Tue Jun 18 19:11:51 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdisplay.[ch] gdk/gdkevents.c gdk/gdkinput.h 
	gdk/gdkinternals.h gdk/win32/gdkevents-win32.c
	gdk/win32/gdkinput-win32.[ch] gdk/x11/gdkevents-x11.c
	gdk/x11/gdkinput{,-none,-x11}.c gdk/x11/gdkinputprivate.h:
	Make the core pointer object per-display. (#85698)

	* gtk/gtkdnd.c gtk/gtktreeview.c: Adapt to above change.

2002-06-18  Yanko Kaneti <yaneti@declera.com>

	* configure.in: (ALL_LINGUAS) Added Bulgarian (bg).

Tue Jun 18 14:41:48 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkcursor.[ch] gdk/x11/gdkcursor-x11.c
	gdk/x11/gdkprivate-x11.h gdk/win32/gdkcursor-win32.c: Replace
	gdk_cursor_new_for_screen() with gdk_cursor_new_for_display().
	(#85671)

	* gtk/gtkclist.c gtk/gtkcombo.c gtk/gtkcurve.c gtk/gtkdnd.c
	gtk/gtkentry.c gtk/gtkhandlebox.c gtk/gtkhsv.c gtk/gtklabel.c 
	gtk/gtkpaned.c gtk/gtktext.c gtk/gtktextview.c 
	gtk/gtktipsquery.c gtk/gtktreeviewcolumn.c: 
	Adapt to above change.

Tue Jun 18 12:04:10 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c (gdk_init_check): Change handling 
	of gdk_intialized(), so that gdk_parse_args(),
	gdk_init_check() sequence works.

Tue Jun 18 11:46:33 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (get_move_resize_data): Add
	a gboolean create argument, so we don't create the
	structure unless we actually emulate move-resize
	drags.

Sat Jun 15 23:53:03 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (gtk_file_selection_set_filename): 
	Actually use the UTF-8 filename, so we actually
	fix #77948.

	* tests/testgtk.c: Remember the directory as a
	test of gtk_file_selection_set_filename().

Sat Jun 15 23:05:19 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkfilesel.c (gtk_file_selection_set_filename):
 	Fix backwards asssertion. (#85434)
 
Sat Jun 15 16:10:00 2002  James M. Cape <jcape@ignore-your.tv>

	* gtk/gtktexttag.c (gtk_text_tag_set_property):
	Notify about "background-full-height-set", not
	"bg_full_height_set". (#83336)
			
Fri Jun 14 15:41:50 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c: Fix bug #84268, where validate_rows sometimes
	didn't remove itself correctly.  Thanks to Dave Camp for the fix.

Fri Jun 14 15:09:11 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreeview.c (gtk_tree_view_set_adjustments):
	disconnect_by_func instead of disconnect_by_data.  Someone else
	could use the same data as us.

	* gtk/gtktreeview.c (do_validate_rows): update the adjustment
	immediately after we update the size.  Fixes some scroll_to bugs.
	(validate_visible_area): ditto

Fri Jun 14 10:31:59 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c (gdk_check_wm_state_changed): 
	Ignore state change events for windows that aren't
	our toplevels. (#84482, Thomas Leonard)

Fri Jun 14 10:00:29 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_update_idle): Add
	missing GDK_THREADS_ENTER()/GDK_THREADS_LEAVE().
	(Report of non-thread-safety from Nicholas Allen)

	* gtk/gtkmain.c (rewrite_events_translate): Fix sign
	problem with coordinate translation. (Fix from
	Robin Lu, #85229)

Thu Jun 13 19:41:56 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkiconfactory.c gtk/gtkselection.c gtk/gtkstyle.c
	gtk/gtktextiter.c gtk/gtktexttag.c gtk/gtktreemodel.c
	gtk/gtkwidget.c: Fix type names for GtkIconSet,
	GtkIconSource, GtkSelectionData, GtkBorder, GtkTextIter,
	GtkTextAttributes, GtkTreePath, GtkTreeIter, 
	GtkRequisition, which were all registered as GtkType*.
	(#84634, James Henstridge; patch from Jonathan Blandford.)
	
Thu Jun 13 18:48:14 2002  Owen Taylor  <otaylor@redhat.com>

 	* gdk/x11/gdkcolor-x11.c: Make work
	gdk_colormap_sync() work for DirectColor visuals 
	as well. Fill in the ->colors array in
	gdk_screen_get_system_colormap () for DirectColor visuals.
	(#81954, Based on a patch from shivaram.upadhyayula@wipro.com)
 
Thu Jun 13 17:50:36 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextview.c gtk/gtkentry.c: Add the obsolete
	CUA cut/copy/paste bindings. (#79078)

	* gtk/gtktextview.c gtk/gtkentry.c: Make <Shift>BackSpace
	a synonym for for Backspace. (#80302, Jeff Waugh)

Thu Jun 13 15:02:49 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdnd-x11.c: Ignore all client events that
	were sent to a window that we don't know about or
	to a foreign window. (#81543, Young-Ho, Cha)

Thu Jun 13 12:24:09 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (gtk_file_selection_set_filename):
	Fix so that the encoding of the filename is handled
	properly in the case of non-UTF-8 filesystems;
	document the encoding. (#77948, Sebastian Ritau)

	* gtk/gtkfilesel.c (filenames_drag_get): Remove
	debug printf. Fix UTF-8 / filename encoding 
	confusion.

2002-06-13  Christian Rose  <menthos@menthos.com>

	* Makefile.am (EXTRA_DIST): Remove po/README.tools, po/desk.pl
	and po/update.pl.

Thu Jun 13 12:01:36 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_drag_motion): Don't return
	a positive status unless there is a text target in
	the drag. (#83386, Thomas Leonard.)

Thu Jun 13 11:36:37 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkdnd.c (_gtk_drag_source_handle_event): Save
 	the initial grab time, use that when changing the
 	pointer. (#83052, help from Dave Camp tracking it down.)
 
Thu Jun 13 16:42:40 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreestore.c (gtk_tree_store_finalize): traverse all nodes,
	not just the leafs (pointed out by Josh Parsons)

2002-06-12  Havoc Pennington  <hp@redhat.com>
 
 	* configure.in: check that pango has Xft2 support, instead of
 	checking whether Xft2 exists.

Wed Jun 12 17:46:53 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (blink_cb): Add an informative 
	g_warning() when the entry has lost a focus-out-event.
	(#78305, Michel Selten)

Wed Jun 12 17:31:15 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.c (gtk_menu_shell_real_select_item): 
	Check to see if the menu item is selectable before
	setting menu_shell->active_menu_item. This hopefully
	will keep gail from getting confused.
	(#84115, Remus Draica)

Wed Jun 12 17:13:13 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_move_resize): Fix bug
	where if CENTER_ON_PARENT was set, but there was
	no parent, GDK_HINT_POS would be set, resulting
	in a dialog at 0,0. (#83479, Havoc Pennington)

Wed Jun 12 16:34:13 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenubar.c: When fetching the menubars for
	the window for F10 handling, only add viewable menu
	bars. (Apparently, people sometimes put menu bars
	in notebook pages!) (Tim Janik, #82627)

Wed Jun 12 16:21:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcheckbutton.c (gtk_check_button_size_allocate): 
	Clamp size of child to at least 1x1. (#82431, 
	Boris Shingarov.)

Wed Jun 12 15:43:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkspinbutton.c (gtk_spin_button_snap): Handle
	0 increment, to fix division-by-zero problem.
	(#82816, George Lebl.)

Wed Jun 12 15:38:01 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimmulticontext.c (gtk_im_multicontext_append_menuitems):
	Fix memory leak. (Patch from Matthias Clasen, #84926)

	* gtk/gtkrange.c (gtk_range_init): Initialize
	mouse_x, mouse_y to -1,-1. (#84871, Garrett Lesage)

Wed Jun 12 15:08:37 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_get_style_by_paths): Allow 
	NULL for widget path or class path as documented.
	(#83150, Sergey Kuzminov)

Wed Jun 12 15:02:30 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextutil.c: Fix ZWJ => ZWN typo.
	(#83092, Tino Meinen)

Wed Jun 12 14:41:43 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Fix some problems with case statements
	for checking for omitted deps. (#84202, Jacob Berkman.)

	* configure.in: Remove USE_X11R6_XIM checks since we 
	no longer use them.

Wed Jun 12 14:18:45 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkimcontextsimple.c: Add compose sequences
 	of dead_acute + c/C => C WITH CEDDILLA.
 	(Nano Golveia, #83492)
 
2002-06-10  Hans Breuer  <hans@breuer.org>

	* gdk/makefile.msc : added gdkdisplay and gdkscreen

	* gdk/win32/gdkdisplay-win32.c (gdk_open_display) : 
	need to gdk_screen_set_default_colormap(). Also un-static
	some exported gdk_display_*() functions

	* gdk/win32/gdkdrawable-win32.c : added "gdkscreen.h"

	* gdk/win32/gdkscreen-win32.c : implement
	gdk_screen_get_number, fixed typo, added rewuired headers

	[merge from 2.0.x branch, should we really manifest 
	 GtkPlug as being an X11 only thing this way? See #58541]
	* gtk/gtkwindow.c (gtk_window_show): Conditionalize
	GTK_IS_PLUG() check on GDK_WINDOWING_X11. (Problem
	reported by Sven Neumann)

2002-06-10  Tor Lillqvist  <tml@iki.fi>

	[ merge from stable ]

	* gdk/win32/gdkmain-win32.c (gdk_screen_get_width_mm,
	gdk_screen_get_height_mm): Use the "logical dpi" to calculate
	(pseudo) physical sizes. Similar to the use of "logical dpi" in
	Pango as suggested by Joaquin Cuenca Abela.

	Two fixes by Florent Duguet:

	* gdk/win32/gdkwindow-win32.c (gdk_window_set_cursor): Correct
	semantics for setting cursor to NULL (should use cursor of parent
	window).

	* gdk/win32/gdkgc-win32.c (gdk_win32_hdc_get): Plug memory
	leak.

2002-06-10  Naba Kumar <kh_naba@users.sourceforge.net>

	* configure.in: Added hi in ALL_LINGUAS

2002-06-09  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextbtree.c (_gtk_text_btree_unref): Don't leak
	child_anchor_table.  (#84425)

	* gtk/gtktextlayout.c (gtk_text_layout_finalize): Don't leak
	one_display_cache.  (#84424)

Fri Jun  7 23:11:42 2002  Jonathan Blandford  <jrb@gnome.org>

	* gtk/gtktreeview.c (gtk_tree_view_real_expand_row): Fix sizing
	bug.

	* docs/reference/gtk/tmpl/gtkbutton.sgml: Remove ^M's.

2002-06-07  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktreeviewcolumn.c
	(gtk_tree_view_column_clear_attributes_by_info): New function,
	split off from gtk_tree_view_column_clear_attributes.
	(gtk_tree_view_column_clear_attributes):
	(gtk_tree_view_column_finalize):  Call the new function, avoid
	recalculating the info from the renderer.  (#84413) 
	
	* gtk/gtktextview.c (text_view_child_new_anchored): Initialize
	vc->type in order to avoid a later UMR.  (#84415)

2002-06-07  Mark McLoughlin  <mark@skynet.ie>

	* gtk/gtkwindow.c: (gtk_window_compute_configure_request): use
	the RootWindow of this screen for gdk_window_get_pointer.

2002-06-06  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkevents-x11.c (gdk_event_translate): Set
	hardware_keycode for KeyRelease events.  (#84305)

Thu May 23 15:44:30 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextview.c (changed_handler): Don't redraw
	when the area is completely above the visible area.

Fri May 17 17:27:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c gtk/gtkwidget.c: Add a "is_focus"
	property indicating whether a widget is the focus
	widget within the toplevel.

	* gtk/gtkwindow.[ch]: Add "is_active" "has_toplevel_focus"
	properties to indicate (separately) the idea of
	being the part of the toplevel with the input focus
	and being the active widget. (Needed for full XEMBED
	compliance.)

	* gtk/gtkplug.c gtk/gtksocket.c: Update to work
	in terms of is_active/has_toplevel_focus, and thus
	handle the active/focused XEMBED distinction
	correctly.

	* gtk/gtkplug.c (gtk_plug_realize): Remove
	FOCUS_CHANGE_MASK, since we don't need it.

Fri May 17 18:07:34 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.c (gtk_socket_add_window): Send
	XEMBED_EMBEDDED_NOTIFY.

	* gtk/gtksocket.c: Assume windows without _XEMBED_INFO 
	property want to be mapped, for better 
	current-Qt compatibility.

Thu Jun  6 17:27:01 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkrbtree.c (_gtk_rbtree_reorder): don't leak the GArray
	(figured out by Matthias Clasen, fixes #82026).

Wed Jun  5 18:34:47 2002  Owen Taylor  <otaylor@redhat.com>

	Changes multihead reorganizing code for win32 support,
	mostly from a patch by Hans Breuer.

	* gdk/gdkcolor.c gdk/x11/gdkcolor-x11.c gdk/gdkcursor.c
	  gdk/x11/gdkcursor-x11.c gdk/gdkevents.c gdk/x11/gdkevents-x11.c
	  gdk/gdkfont.c gdk/x11/gdkfont-x11.c gdk/gdkkeys.c
	  gdk/x11/gdkkeys-x11.c gdk/gdkimage.c gdk/x11/gdkimage-x11.c
	  gdk/gdkscreen.c gdk/x11/gdkmain-x11.c
	  gdk/gdkdisplay.c gdk/gdkevents-x11.c gdk/gdkpango.c
	  gdk/x11/gdkpango-x11.c gdk/gdkselection.c
	  gdk/x11/gdkselection-x11.c gdk/gdkwindow.c
	  gdk/x11/gdkwindow-x11.c gdk/gdkvisual.c gdk/x11/gdkvisual-x11.c:
	  Move port-independent singlehead wrapper functions into
	  port-independent part of GDK. (#80009)

	* gdk/win32/gdkcolor-win32.c gdk/win32/gdkcursor-win32.c
	  gdk/win32/gdkevents-win32.c gdk/win32/gdkfont-win32.c
	  gdk/win32/gdkimage-win32.c gdk/win32/gdkkeys-win32.c
	  gdk/win32/gdkmain-win32.c gdk/win32/gdkproperty-win32.c
	  gdk/win32/gdkselection-win32.c gdk/win32/gkwindow-win32.c: 
	Turn singlehead functions into "multihead" functions that ignore 
	their GdkDisplay or GdkScreen arguments.

	* gdk/win32/gdkdrawable-win32.c gdk/win32/gdkevents-win32.c
	gdk/win32/gdkinput-win32.c gdk/win32/gdkprivate-win32.h: 
	Misc multihead-compatibility changes.

	* gtk/gtk.def gdk/gdk.def: Update for multihead functions.

	* gdk/gdkcolormap.h gdk/gdkvisual.h gdk/x11/gdkcolormap-x11.c 
	gdk/x11/gdkvisual-x11.c: Remove the screen fields
	from the public parts of the colormap/visual structures, add accessors
	instead.

	* gdk/gdkpixbuf-render.c gdk/gdkpixmap.c gdk/gdkrgb.c
	  gdk/x11/gdkcolormap-x11.c gdk/x11/gdkimage-x11.c
	  gdk/x11/gdkimage-x11.c gdk/x11/gdkprivate-x11.h gtk/gtkgc.c
	  gtk/gtkstyle.c gtk/gtkwidget.c: Use accessors to get the screen
	for colormaps, visuals; move the fields into the private
	structures for the x11 backend.

	* gdk/gdkdisplay.[ch] gdk/x11/gdkdisplay-x11.[ch]
	  gdk/gdkscreen.[ch] gdk/x11/gdkscreen-x11.c: 
	Remove virtualization of screen and display functions.
	(#79990, patch from Erwann Chenede)

	* gdk/win32/gdkdisplay-x11.c gdk/win32/gdkscreen-win32.c
	gdk/win32/{Makefile.am, makefile.msc, makefile.mingw}:
	New files containing stub implementations of Display,
	Screen functions.

	* gdk/x11/gdkscreen-x11.[ch] gdk/x11/gdkdisplay-x11.[ch]
	gdk/x11/gdkx.h: Clean up function exports and what 
	headers they are in. (#79954)

	* gdk/x11/gdkx.h: Fix macro that was referring to a non-existant
	screen->screen_num. (In the patch for #79972, Erwann Chenede)

	* gdk/gdkscreen.c gdk/gdkwindow.c gdk/x11/gdkinternals.h
	 gdk/x11/gdkscreen-x11.c: Fix gdk_screen_get_window_at_pointer()
	to use window hooks. (#79972, patch partly from Erwann Chenede)

	* gdk/x11/gdkdisplay-x11.c gdk/x11/gdkevents-x11.c: Fix
	some warnings.

Wed Jun  5 23:29:41 2002  Kristian Rietveld  <kris@gtk.org>

	Related bugs: #76252, #76396, #80866.

	* gtk/gtktreeselection.[ch]: added
	gtk_tree_selection_get_selected_rows(),
	added gtk_tree_selection_count_selected_rows(),
	renamed gtk_tree_selection_real_select_range() to
	gtk_tree_selection_real_modify_range(), and added mode parameter,
	added gtk_tree_selection_unselect_range().
	
Tue Jun  4 17:39:34 2002  Owen Taylor  <otaylor@redhat.com>

 	* configure.in: If we have xft .pc file, use that
 	when checking for Xft/Xrender. (Still need to separate
 	out HAVE_XFT, HAVE_RENDER)
 
 	* configure.in: Make sure Xft cflags come before X cflags.
 
Tue Jun  4 21:13:57 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.[ch]: added gtk_tree_view_expand_to_path.

Tue Jun  4 19:24:41 2002  Kristian Rietveld  <kris@gtk.org>

	Discussed in #76249.

	* gtk/gtkliststore.[ch]: made gtk_list_store_remove return a gboolean,
	added gtk_list_store_iter_is_valid.

	* gtk/gtktreestore.[ch]: made gtk_tree_store_remove return a gboolean,
	added gtk_tree_store_iter_is_valid.

	* gtk/gtktreemodelsort.[ch]: added VALID_ITER macro as in liststore
	and treestore sources, added gtk_tree_model_sort_iter_is_valid.
	
Tue Jun  4 19:18:20 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodel.[ch]: add gtk_tree_model_get_string_from_iter
	(#74667).

2002-06-04  Daniel Elstner  <daniel.elstner@gmx.net>

	[ merge from stable ]

	* gtk/gtkcellrenderertoggle.c (gtk_cell_renderer_toggle_render):
	Really fix #83796: Revert jrb's last patch, and move the second
	if-clause into the fist one's else-branch.  This is also what
	the other cell renderers do.

2002-06-03  Federico Mena Quintero  <federico@ximian.com>

	* gdk/gdkpixbuf-drawable.c (rgb565msb): Fix the MSB -> MSB case.
	Fixes #79190.

Sat Jun  1 10:43:28 2002  Jonathan Blandford  <jrb@gnome.org>

	* gtk/gtkcellrenderertoggle.c (gtk_cell_renderer_toggle_render): 
	add missing flag, #83796

2002-05-30  Michael Meeks  <michael@ximian.com>

	* gtk/gtkmenu.c (gtk_menu_popup): destroy the transfer
	window if the grab fails so we don't get events on this
	window after the menu is finalized with a duff GtkWidget
	pointer: #82366

Mon May 28 13:28:10  Shivram U  <shivaram.upadhyayula@wipro.com>

	* gtk/gtktextbuffer.c (selection_data_get_buffer): Check if the owner
	got is of type GDK_WINDOW_FOREIGN. If so the owner is not in-process,
	and so return NULL.

2002-05-24  Michael Meeks  <michael@ximian.com>

	* gtk/gtkmain.c (_gtk_find_module): don't leak the paths.

Thu May 30 07:59:38 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenu.c (gtk_menu_style_set): add
	gtk_menu_style_set(). fixes #79345

2002-05-29  Dave Camp  <dave@ximian.com>

	* gtk/gtkdnd.c (gtk_drag_end): Disconnect from keypress events.

2002-05-28  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkwindow.c (gtk_window_move): Markup fixes

	* gtk/gtkrc.c (gtk_rc_get_module_dir): Markup fixes.
	
	* gdk/x11/gdkcursor-x11.c (gdk_cursor_new_for_screen): Update docs
	for Docbook XML.

2002-05-27  Daniel Elstner  <daniel.elstner@gmx.net>

	[ merge from stable ]

	Fixes for #83190

	* gtk/gtktreedatalist.h (_GtkTreeDataList::data): Add missing
	fields to anonymous union: glong, gulong, gint64 and guint64.
	This is an internal header file, so it should not affect ABI
	or API compatibility.

	* gtk/gtktreedatalist.c (_gtk_tree_data_list_node_to_value):
	Implement missing support for glong, gulong, gint64 and guint64
	fundamental types.  Use data.v_uint instead of data.v_int for
	G_TYPE_FLAGS, as GValue does.
	(_gtk_tree_data_list_value_to_node): ditto
	(_gtk_tree_data_list_node_copy): Add case labels for missing
	fundamental types, and reorder them to match the other functions.
	(gtk_tree_data_list_compare_func): Implement comparison for
	glong, gulong, gint64 and guint64.  Use g_value_get_enum()
	for G_TYPE_ENUM and g_value_get_flags() for G_TYPE_FLAGS, rather
	than accessing them as gint/guint.  The G_VALUE_HOLDS() check
	probably won't like this.

2002-05-24  Dave Camp  <dave@ximian.com>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_row_inserted): 
	Built an iter directly instead of using
	gtk_tree_model_sort_elt_get_path(), since that returns a path for
	the child model.

2002-05-24  Dave Camp  <dave@ximian.com>

	* gtk/gtktreemodelsort.c: Use indices[i] >= level->array->len
	rather than level->array->len > indices[i] in the bounds check.

2002-05-23  Tor Lillqvist  <tml@iki.fi>

	* gtk-zip.sh.in: Use correct path to the loaders and immodules
	directories (GTK_BINARY_VERSION, not GTK_VERSION).

Wed May 22 16:12:38 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Require autoconf-2.52 explicitely,
	since otherwise Debian will process it with 2.13 (ugh!).

Wed May 22 12:29:20 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_init): remove
	GTK_RESIZE_QUEUE setting.

Tue May 21 16:46:15 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gdk/x11/gdkdisplay-x11.c (gdk_internal_connection_watch): 
 	Fix missing dereference. (HideToshi Tajima)
 
Mon May 20 15:02:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdisplay-x11.c: Patch from HideToshi Tajima
	to handle Xlib internal connections. (#76681)

Mon May 20 12:59:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.c: Set the private LEAVE_PENDING
	flag to fix problem where with menu items with
	submenus, tooltips were getting stuck. (Effectively
	disables tooltips for menu items with submenus.)
	(Bug #75961, Soeren Sandmann)

	* tests/testgtk.c: Set a tooltip on a menu item
	with a submenu.

Mon May 20 11:47:59 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkplug.c: Undo an accidental revert of
 	fixes of May 16. (Caught by Padraig O'Briain)
 
	* gtk/gtkctree.c (cell_size_request): Fix bug where
	size request for text cells was being overwritten.
	(#82264, Graham Swallow.)

2002-05-18  Matthias Clasen  <maclas@gmx.de>

	* configure.in: Check for endianness. Sorry about REBUILD_PNGS...

Fri May 17 16:05:34 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in (REBUILD_PNGS): Re-add REBUILD_PNGS
	definition that got accidentally removed.

Fri May 17 14:40:24 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimmulticontext.c (gtk_im_multicontext_set_slave): 
	Protect against reentrancy problems by emitting 
	::preedit_changed at the end, fixing input context
	leak. (Yao Zhang)

	* modules/input/gtkimcontextxim.c (status_window_free): 
	Patch from Federico Mena Quintero to fix problem where
	references to IMContextXIM were kept around after
	module was unloaded. (#77008)

	* gtk/gtkdnd.c (gtk_drag_dest_set): NULL initialize
	proxy window.

Fri May 17 13:56:23 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkplug.c (gtk_plug_filter_func): Fix a missing
 	unref in the local/passive case. (#82067, Michael
 	Meeks)
 
 	* gtk/gtkplug.c (_gtk_plug_remove_from_socket): Fix
 	reference leak on the plug window.
 
 	* tests/testsocket.c (add_child): Fix memory leak.
 
 	* gtk/gtkdnd.c (gtk_drag_dest_site_destroy): Unref
 	the proxy window.
 
Thu May 16 19:49:24 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkwindow.c (gtk_window_configure_event): Only 
 	optimize out the full configure handling if we got
 	a gratuitous configure event(configure_request_count == 0)
 	and the size didn't change.
 
 	* gtk/gtkwindow.c (gtk_window_move_resize): Use 
 	g_message(), not g_print() for debug spew.b
 
 	* gtk/gtkwindow.c (gtk_window_real_set_focus): Ref
 	the old and new focus widgets for the scope of
 	the function.
 
 	* gtk/gtksocket.c gtkplug.c: Remove various #if 0'd
 	bits of old code.
 
 Thu May 16 18:47:29 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gtk/gtkwindow.c (gtk_window_show): Disable the
 	focus-some-widget code for GtkPlug descendants.
 
 	* gtk/gtkplug.c (gtk_plug_focus_event): Eat 
 	focus-in/out events since they can be generated
 	by keyboard grabs, but are spurious for an embeddded
 	widget. (#79196, Padraig O'Briain)
 
 	* gtk/gtksocket.c (gtk_socket_size_request): Only
 	pay attention to the minimum size hints, and changes
 	to that ... ignore the default size.
 
 	* gtk/gtksocket.c (gtk_socket_send_configure_event):
 	Pass in root-window relative coordinates as per
 	the ICCCM.
 
 	* gtk/gtksocket.c (gtk_socket_size_allocate): Send
 	as many synthetic configures as necessary to make
	up for ConfigureRequest events we got. (#78799,
	Dave Camp.)

Thu May 16 23:59:56 2002  Kristian Rietveld  <kris@gtk.org>

	Merged from gtk-2-0.

	* gtk/gtktreestore.c (gtk_tree_store_sort_iter_changed): set the prev
	of the next node correctly, so we don't corrupt the list and cause
	bad things. (fixes #71374)
 
Thu May 16 17:29:08 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkrbtree.c (_gtk_rbtree_remove): include missing #ifdef G_ENABLE_DEBUG

Thu May 16 15:44:15 2002  Owen Taylor  <otaylor@redhat.com>

        * demos/gtk-demo/editable_cells.c (cell_edited): Fix
	typo in earlier patch.

Tue May  7 15:50:51 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkimcontextsimple.c (gtk_im_context_simple_filter_keypress):
	Don't filter control-shift+[non-hex]. 
	(#80252, reported by Nalin Dahyabhai)

Thu May 16 14:51:14 2002  Owen Taylor  <otaylor@redhat.com>

	Fixes for #78258

	* gtk/gtkrbtree.c demos/gtk-demo/editable-cells.c:
	Fix some 64-bit warning problems. (Patch from Matthias
	Clasen.)
	
	* gtk/gtkrbtree.c (_gtk_rbtree_debug_spew_helper): Surround
	a bunch of debug code with G_ENABLE_DEBUG.

	* configure.in demos/gtk-demo/main.c: Replace
	#ifndef G_OS_WIN32 with proper #ifdef HAVE_FLOCKFILE.

Thu May 16 12:56:38 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c (gtk_range_calc_layout): Fix a missed
	check for division by zero. (#77820, Gareth Pearce)

Thu May 16 12:50:13 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c (gdk_xsettings_notify_cb):
	gdk_event_put() copies the event and setting name,
	so we don't have to strdup() it here. (Fix from
	Michael Meeks, #81953)

2002-05-16  Ettore Perazzoli  <ettore@ximian.com>

	* gtk/gtkmenu.c (gtk_menu_paint): If the menu is scrolled down or
	up, and some of the widget area is empty, don't fill it in with
	GTK_SHADOW_IN rectangles that make it looks strange.  Fixes
	#72695.

Wed May 15 18:15:45 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (_gtk_drag_source_handle_event): Don't
	call gdk_pointer_grab() to change the cursor if we've
	already ungrabbed on button release / escape.
	(#80420, Dave Camp)

Wed May 15 17:12:50 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.c: Special case menu items to
	pop down on motion. (#75961)

	* tests/testgtk.c (create_item_factory): Add tooltips
	to the File menu.

	* gtk/gtkentry.c (update_im_cursor_location): Fix 
	cursor locations passed to the IM context.
	(#80027, Yao Zhang)

Wed May 15 16:52:57 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c: Update from contents of size entry
	on focus out. (#76493, Lauris Kaplinski)

	* gtk/gtkclipboard.c (selection_get_cb): Fix backwads
	info/time arguments. (#80226)

Wed May 15 11:13:19 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in gtk/stock-icons/Makefile.am: If not
	building libpng, don't rebuild gtkstockpixbufs.h
	(#81819, Bill Janssen)

2002-05-15  jacob berkman  <jacob@ximian.com>

	* demos/gtk-demo/Makefile.am (demos.h): just run perl on the
	geninclude script manually

Tue May 14 19:53:15 2002  Owen Taylor  <otaylor@redhat.com>

	* demos/gtk-demo/geninclude.pl.in configure.in:
	Subsitute in @PERL@ instead of hardcoded 
	/usr/bin/perl. (#78355, Gareth Pearce. Fix based
	on patch from Matthias Clasen)

	* gdk/Makefile.am: Patch from Daniel Elstner to use glib-mkenums
	instead of makeenums.pl.

	* gdk/{x11,linux-fb,win32}/Makefile.am: Hack to
	get gdkenumtypes.h built first.

Tue May 14 18:41:58 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/stock-icons/Makefile.am (gtkstockpixbufs.h): 
	Remove the result file on error. (#79929, David
	Highley)

	* gtk/gtkoptionmenu.c (gtk_option_menu_remove_menu):
	If the menu is currently active, cancel it before
	setting the new menu. (#79162, Jonathan Blandford.)

Tue May 14 18:13:10 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdnd-x11.c (gdk_window_cache_filter): Fix
	prepending at the start of the list. (#56349,
	Thomas Leonard.)

	* gtk/gtksignal.h (gtk_signal_disconnect_by_func): Add
	explicit casts to GSignalMatchType for C++ compatibility.
	(#77601)

Tue May 14 18:02:37 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_realize): Fix
	frame_right/frame_top screwup. (Detlef Reichl,
	#78111)

	* gtk/Makefile.am (install-data-local): Use
	$(INSTALL_DATA) not $(INSTALL) when installing
	theme files. (#77094, Ben Liblit)

Tue May 14 17:30:57 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkctree.c gtk/gtkclist.c: Fix format of 
	selection data to be 8 rather than GTK_TYPE_POINTER.
	(#79751, James Henstridge)
	
	* gtk/gtkmenu.c (gtk_menu_key_press): Call 
	gtk_accelerator_valid() with cleaned up
	accel_key/accel_mods, not the raw values from
	the event. (#80513, Havoc Pennington.)

	* gtk/gtkmenu.c (gtk_menu_set_tearoff_state): Remove
	some dead code that set the tearoff window not 
	resizable and removed decorations. (#80235)

Tue May 14 16:44:09 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_ensure_layout): Set
	the width of the layout to the actual wrap width 
	(our requisition) not the width we set when calculating
	the width. This results in the lines being justified
	within the correct area. (#79157, Anders Carlsson)

	* gtk/gtkaccelgroup.c gtk/gtkmarshelers.list: Corrected 
	registered parameter types of "accel_activate" and 
	"accel_changed" signals. (Patch from Murray Cumming, #78798)
	
	* gtk/gtkrc.c (gtk_rc_make_default_dir): Switch
	binary-version and type to correspond to the 
	current ordering in _gtk_get_module_path.
	(#78746, Sergey Kuzminov) 

	* gtk/gtkrc.c (gtk_rc_get_module_dir): Add docs
	pointing to the GTK_PATH documentation.

	* gtk/Makefile.am (uninstall-local): Delete 
	key themes as well. (#81286, Kristian Rietveld.)

Tue May 14 15:40:49 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-{linux-fb,win32,x11.c} (gdk_window_set_back_pixmap):
	Add a sanity g_return_if_fail() check for the depths
	for the window and pixmap. (#79191, Shivaram Upadhyayula)

Tue May 14 15:09:33 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkkeys-x11.c: Try adding a #ifndef/#define
	for XkbKeySymEntry to make up for OSF broken 
	XKB extension. (#77819, Gareth Pearce)

	* gtk/gtklayout.c: Clamp the upper values in response
	to ::size-allocate if necessary. (#81290, Christophe Saout)
	
	* gtk/gtkcombo.c (gtk_combo_entry_focus_out): Handle
	combo being destroyed before idle fires.
	(#81396, Timo Sirainen)

Tue May 14 11:21:19 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gdk/x11/gdkevents-x11.c (gdk_event_translate): 
 	Discard configure events from SubstructureNotify.
 	(#81760, Rich Burridge)
 
 	* gtk/gtkfontsel.c (cmp_families): Use g_utf8_strcoll(), not
 	strcmp().
 
 	* gtk/gtkmenuitem.c (gtk_menu_item_size_allocate): Clamp 
 	width of child allocation to >= 1. (Fixes warnings from
 	#77639, Martin Schulze)
 	
2002-05-14  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkcontainer.c (gtk_container_class_install_child_property): 
	(gtk_container_class_find_child_property): 
	(gtk_container_class_list_child_properties): 
	* gtk/gtkwidget.c (gtk_widget_class_find_style_property): 
	(gtk_widget_class_list_style_properties): Change parameter names
	to match the header file and the documentation.

2002-05-13 Vitaly Tishkov <tvv@sparc.spb.su>

        * gtk/gtkfilesel.c
        * gtk/gtkplug.c 
        * gtk/gtkwidget.c
        * gtk/gtkwindow.c
        a few typos in docs were fixed

2002-05-10  Daniel Elstner  <daniel.elstner@gmx.net>

	[ merge from stable ]

	* gtk/gtktreemodel.c: #define INITIALIZE_TREE_ITER(),
	which zeroes out all GtkTreeIter fields. (#81380)
	(gtk_tree_model_get_iter): Use it.
	(gtk_tree_model_iter_children): ditto
	(gtk_tree_model_iter_nth_child): ditto
	(gtk_tree_model_iter_parent): ditto

2002-05-08  Michael Natterer  <mitch@gimp.org>

	* configure.in: fixed yesterdays fix for cross compiling: simply
	check the variable "cross_compiling" which gets set by autoconf.

Wed May  8 16:14:49 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtktreeview.c 
	(gtk_tree_view_init): set_redraw_on_allocate (FALSE);
	(gtk_tree_view_size_allocate): invalidate last column if width
	changed.
	(gtk_tree_view_bin_expose): skip over cells that aren't in
	event->region

Tue May  7 18:36:03 2002  Owen Taylor  <otaylor@redhat.com>
 
 	* gdk/x11/xsettings-client.c (xsettings_client_process_event): 
 	Check for selection_atom, not property name atom.
 
2002-05-07  Michael Natterer  <mitch@gimp.org>

	* configure.in: added a new conditional CROSS_COMPILING which
	indicates ($build != $host). If it is set, look for
	gdk-pixbuf-csource in PATH. Error out if it was not found.

	* gtk/stock-icons/Makefile.am: use the gdk-pixbuf-csource found at
	configure time if CROSS_COMPILING is set, use the one which was
	just built otherwise.

2002-05-07  Anders Carlsson  <andersca@gnu.org>

	* gdk/x11/xsettings-client.c (xsettings_client_process_event): 
	Only process manager events with the correct atom.

2002-05-07  Matthias Clasen  <maclas@gmx.de>

	Fix for #79248:
	
	* gdk/x11/gdkwindow-x11.c (gdk_window_new): 
	(gdk_window_set_events): Always select for property notify for
	maintaining window state.

	* gdk/x11/gdkevents-x11.c (gdk_event_translate): Only propagate
	property notifys if they were selected by gdk_window_set_events.

Mon May  6 23:48:14 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_map_expanded_rows_helper): call
	func on current node before the child nodes.

Mon May  6 23:17:42 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_motion_draw_column_motion_arrow):
	unset user_data before destroying the window. (fixes #80065).

Mon May  6 12:17:14 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Fix versioning to avoid changing the
	soname!

	[ merge from stable ]

	* Makefile.am (EXTRA_DIST): Add ChangeLog.pre-2-0 (#78641)

	* m4macros/gtk-2.0.m4: save CFLAGS/LIBS properly when
	compiling "what went wrong" test case. (#79329)

	* m4macros/gtk-2.0.m4: Remove reference to editing
	pkg-config script. (From Jim Gettys)

02-05-05  Matthias Clasen  <maclas@gmx.de>

	* configure.in: Bump version to 2.1.0, binary, interface age 0.

	* gtk/gtkcontainer.c (gtk_container_class_list_child_properties): 
	(gtk_container_class_find_child_property): Document.

	* gtk/gtkwidget.c: 
	* gtk/gtkwidget.h: New functions gtk_widget_class_list_child_properties
	and gtk_widget_class_find_child_property.  (#80652)
	
Sun May  5 15:56:50 2002  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Fix problem with == in test argument.
	(#80732, Hidetoshi Tajima)

Sun May  5 16:42:32 2002  Kristian Rietveld  <kris@gtk.org>

	The "big treeview focus patch". Fixes several issues and adds some
	goodies. Related bugs: #73676, #73734, #78660.

	* gtk/gtktreeview.h: add gtk_tree_view_set_cursor_on_cell

	* gtk/gtktreeview.c (gtk_tree_view_button_press): focus on a cell
	if applicable,
	(gtk_tree_view_bin_expose): set_cell_data before iterating columns,
	add support for row-spanning focus rectangles,
	(gtk_tree_view_has_special_cell): new function,
	(gtk_tree_view_move_cursor_left_right): add support for multiple
	focusable cells in one column,
	(gtk_tree_view_set_cursor): call _set_cursor_on_cell now,
	(gtk_tree_view_set_cursor_on_cell): copy of _set_cursor, extended
	with focus_cell parameter,
	(gtk_tree_view_search_iter): removed unused column variable,
	(gtk_tree_view_start_editing): add neighbor size code to allow
	for multiple editable cells in one column.

	* gtk/gtktreeviewcolumn.c (_GtkTreeViewColumnCellInfo): add
	in_editing_mode field,
	(gtk_tree_view_column_get_edited_cell): new function, removed
	_get_editable_cell,
	(_gtk_tree_view_column_get_cell_at_pos): new function,
	(gtk_tree_view_column_pack_end): s/g_new/g_new0/ ...,
	(gtk_tree_view_column_cell_process_action): loads of changes to get
	it right and to allow for multiple special cells, etc,
	(gtk_tree_view_column_cell_first): new function,
	(gtk_tree_view_column_cell_last): ditto,
	(gtk_tree_view_column_cell_next): ditto,
	(gtk_tree_view_column_cell_prev): ditto,
	(gtk_tree_view_column_cell_focus): add left and right parameters,	
	allow for multiple special cells,
	(gtk_tree_view_column_cell_is_visible): add assertion,
	(gtk_tree_view_column_focus_cell): new function,
	(gtk_tree_view_column_stop_editing): unset in_editing_mode flag,
	(_gtk_tree_view_column_get_neighbor_sizes): iterate through cells
	correctly

	* gtk/gtktreeviewcolumn.h: add gtk_tree_view_column_focus_cell

	* gtk/gtktreeprivate.h: s/_get_editable_cell/_get_edited_cell/, add
	_gtk_tree_view_column_get_cell_at_pos, add new parameters to
	_gtk_tree_view_column_cell_focus.

	* tests/testtreeedit.c: add some cells in order to test new code.

Sun May  5 02:22:59 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* tests/test-images/*: image files for testing pixbuf loaders
	* tests/pixbuf-*.c: the old test-loaders.c split into four 
	different programs
	* tests/Makefile.am: add new pixbuf tests

2002-05-03 Erwann Chenede - <erwann.chenede@sun.com>

	* gdk/x11/gdkvisual-x11.c:
	* gdk/x11/gdkwindow-x11.c:
	* gdk/x11/gdkdisplay-x11.[hc] (gdk_open_display) :
	Rationalized the screen initialization process,
	changed the GdkDisplayX11 screen list to an array.
	
	* gdk/x11/gdkscreen-x11.[hc] (_gdk_x11_screen_new) :
	Moved the xinerama init functions to gdkdisplay-x11.c to
	this file, create a single function to fully initialize
	a GdkScreen. #79981
	
2002-05-03 Erwann Chenede - <erwann.chenede@sun.com>
  
        * gtk/gtkplug.[hc] (gtk_plug_construct_for_display):
	changed the order of the arguments. #80278

2002-05-02  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkscreen.c (gdk_screen_get_monitor_at_window): Fix doc comment.

	* gdk/x11/gdkdisplay-x11.c (gdk_open_display): 
	* gdk/x11/gdkkeys-x11.c (gdk_keymap_get_default): 
	* gdk/x11/gdkfont-x11.c (gdk_fontset_load_for_display): 
	* gdk/x11/gdkfont-x11.c (gdk_font_from_description_for_display): 
	* gdk/x11/gdkfont-x11.c (gdk_font_load_for_display): 
	* gdk/x11/gdkscreen-x11.c (gdk_x11_screen_get_xscreen):
	* gdk/x11/gdkscreen-x11.c (gdk_x11_screen_get_screen_number): 
	* gdk/x11/gdkdisplay-x11.c (gdk_x11_display_get_xdisplay): 
	* gdk/x11/gdkdnd-x11.c (gdk_drag_get_protocol_for_display): Document.

	* gtk/gtknotebook.c (gtk_notebook_set_show_border): Typo fix.

	* gtk/gtkwidget.c (gtk_widget_class_init): Correct the
	composite_child blurb.   

	* gtk/gtknotebook.c (gtk_notebook_set_show_border): Clarify docs.  (#73093)

2002-05-02 Erwann Chenede - <erwann.chenede@sun.com>
        
	* gdk/gdkscreen.c (gdk_screen_get_monitor_at_point):
	* gdk/gdkscreen.h :
	* gdk/x11/gdkscreen-x11.c :
	make gdk_screen_get_monitor_at_point cross platform instead
	of backend dependant. #80480
	* tests/testxinerama.c (main):
	changed the warning message.
	
2002-05-02 Erwann Chenede - <erwann.chenede@sun.com>

	* gdk/x11/gdkscreen-x11.c (gdk_screen_x11_get_root_window):
	removed unneeded ref. #79977
	* gdk/x11/gdkscreen-x11.[hc] (gdk_screen_use_virtual_screen):
	* gdk/x11/gdkdisplay-x11.c (check_*_xinerama):
	removed gdk_screen_use_virtual_screen function and 
	use_virtual_screen member variable from GdkScreenX11. #79957
	
2002-05-02  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktable.c (gtk_table_class_init): 
	* gtk/gtknotebook.c (gtk_notebook_class_init): 
	* gtk/gtkbox.c (gtk_box_class_init): Add nicks and blurbs for
	child properties.  (#57143)

2002-05-01 Erwann Chenede - <erwann.chenede@sun.com>
  	
	* gdk/gdkpixmap.[hc] (gdk_pixmap_get_screen):
	* x11/gdkpixmap-x11.c:
	removed that function as gdk_drawable_get_screen
	does the job. #79964

2002-05-01 Erwann Chenede - <erwann.chenede@sun.com>

	* gdk/gdkscreen.[hc] (gdk_screen_x11_get_monitor_at_window):
	remove virtualization and made it cross platform. #79961
	* gdk/x11/gdkdisplay-x11.c (check_solaris_xinerama):
	fixed initialization bugs.
	* gdk/x11/gdkscreen-x11.[hc] (gdk_screen_get_monitor_geometry):
	* tests/testxinerama.c:
	* gtk/gtkwindow.c (gtk_window_compute_configure_request):
	* gtk/gtkmenu.c (gtk_menu_position):
	take a GdkRectangle argument instead of returning 
	a GdkRectangle * and propagated the changes. #79974
	
2002-05-01  Anders Carlsson  <andersca@gnu.org>

	* gdk/x11/gdkevents-x11.c 
	(gdk_x11_screen_supports_net_wm_hint): Use the same
	key when setting and getting NetWmSupportedAtoms.

Tue Apr 30 18:42:25 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_set_screen): Make it
	work, even if the window is already realized or
	mapped.

	* tests/testgtk.c: Erwann's multihead changes, slightly
	dumbed down. (Removed logic for pulling windows onto
	the current screen, people can click twice on the demo
	to destroy and create again.)

	* tests/prop-editor.c: Set the screen on the property
	editor if the edited object is a widget.

2002-05-01  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkcontainer.c (gtk_container_class_install_child_property):
	Improve a warning.

	* gdk/linux-fb/gdkinput.c (gdk_device_get_axis): Remove a broken
	and redundant doc comment.

2002-04-30  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkprogress.c (gtk_progress_class_init): 
	* gtk/gtkprogressbar.c (gtk_progress_bar_class_init): 
	* gtk/gtktexttag.c (gtk_text_tag_class_init): 
	* gtk/gtknotebook.c (gtk_notebook_class_init): Better blurbs,
	incorporating stuff from the doc templates.

	* gtk/gtkplug.c (gtk_plug_construct): Fix docs.

Tue Apr 30 15:59:53 2002  Owen Taylor  <otaylor@redhat.com>

	* tests/testmultiscreen.c: Multi-screen test case
	form multihead branch with a few cleanups. (Get rid
	of use of g_object_connect())

	* tests/testmultidisplay.c: Multi-display test case
	from multihead branch with a few improvements.
	(Allow the other display name to be passed on
	the command line, use a GtkDialog to get more attractive
	spacing.)

Tue Apr 30 14:23:43 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdisplay-x11.c (gdk_open_display): fix
	problem with finalizing non-initialized fully display
	when failing to open display.

	* tests/testxinerama.c: Xinerama test case from
	multihead branch, with some cleanups. (Start even
	if there is only one monitor, for one.)

Tue Apr 30 14:15:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c gtk/gtkselection.c: Doc fixes.

2002-04-30  Erwann Chenede - <erwann.chenede@sun.com>

        * gdk/x11/gdkimage-x11.c : rationalized multihead code
        in _gdk_x11_copy_to_image. fixes #80256 and ungrab problems.

2002-04-30  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextlayout.c (gtk_text_layout_real_free_line_data): use
	gtk_text_layout_invalidate_cache instead of cut-and-paste
	(gtk_text_layout_real_invalidate): always invalidate cache, even
	if the line has no stored line data. #78573

	* gtk/gtktextview.c (gtk_text_view_get_iter_location): add call to
	gtk_text_view_ensure_layout, #77388
	(gtk_text_view_get_iter_at_location): ditto
	(gtk_text_view_get_line_yrange): ditto
	(gtk_text_view_get_line_at_y): ditto

2002-04-30  Havoc Pennington  <hp@redhat.com>

	* gtk/gtktextbtree.c (gtk_text_btree_remove_tag_info): assign
	something to "prev" so that removing tag info succeeds.
	Part of #77301

	* gtk/gtktextbtree.c (_gtk_text_btree_unref): reorder so that it
	unrefs the tag table first, so that the btree is in a consistent
	state when we're removing tags from it.	

Tue Apr 30 12:28:27 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdisplay.c gdk/gdkpango.c gdk/gdkpixmap.c
	gdk/x11/gdkdisplay-x11.c gdk/x11/gdkevents-x11.c
	gdk/x11/gdkpixmap-x11.c gdk/x11/gdkx.h: Doc fixes.

Tue Apr 30 11:37:09 2002  Owen Taylor  <otaylor@redhat.com>

	* modules/input/gtkimcontextxim.c: Make multihead-safe;
	use a different IM context per display.

	* configure.in acconfig.h: Add Xinerama checks from
	multihead branch, changing HAS_XINERAMA => HAVE_XINERAMA.

	* gdk/x11/gdkdisplay-x11.c: HAS_XINERAMA => HAVE_XINERAMA.

2002-04-29  Alex Larsson  <alexl@redhat.com>

	* gdk/gdkpango.c (gdk_draw_layout_line_with_colors):
	Use tmp also if foreground is set.

Mon Apr 29 18:28:00 2002  Owen Taylor  <otaylor@redhat.com>

	Integrate Erwann Chenede's multihead changes for the gtk/ directory.

	* gtk/gtkclipboard.[ch]: Add gtk_clipboard_get_for_display(),
	make internals multihead aware.

	* gtk/gtkcolorsel.[ch]: Add
	gtk_color_selection_set_change_palette_with_screen_hook () [ugh!]
	make up for non-multihead safety of
	gtk_color_selection_set_change_palette_hook()

	* gtk/gtkinvisible.[ch] gtk/gtkmenu.[ch] gtkwindow.[ch]: Add
	gtk_{invisible,menu,window}_set_screen(); add "screen" properties
	for GtkWindow and GtkMenu.

	* gtk/gtkplug.[ch]: Add gtk_plug_construct_for_display(),
	gtk_plug_new_for_display(). Multihead fixes.

	* gtk/gtkselection.[ch]: Add gtk_selection_owner_set_for_display(),
	make internals multihead aware.

	* gtk/gtksettings.[ch]: Add gtk_settings_get_for_screen(), get
	rid of now-useless gtk_settings_constructor().

	* gtk/gtkstyle.[ch]: Add gtk_style_get_font_for_display(), fix
	check/radio button indicators bitmap handling to be multihead
	safe.

	* gtk/gtkwidget.[ch]: Add gtk_widget_get_screen(), gtk_widget_has_screen(),
	gtk_widget_get_display(), gtk_widget_get_clipboard(),
	gtk_widget_get_root_window().
	
	* gtk/gtkbindings.c gtk/gtkbutton.c gtk/gtkclist.c gtk/gtkcombo.c
	gtk/gtkctree.c gtk/gtkdnd.c gtk/gtkfilesel.c gtk/gtkgamma.c
	gtk/gtkhandlebox.c gtk/gtkhsv.c gtk/gtkimcontext.c gtk/gtklabel.c
	gtk/gtklist.c gtk/gtkmain.c gtk/gtkmenuitem.c gtk/gtkmenushell.c
	gtk/gtknotebook.c gtk/gtkoldeditable.c gtk/gtkoptionmenu.c
	gtk/gtkpaned.c gtk/gtkpreview.c gtk/gtksocket.c gtk/gtktext.c
	gtk/gtktextbuffer.c gtk/gtktextview.c gtk/gtktipsquery.c
	gtk/gtktooltips.c gtk/gtktreeview.c gtk/gtktreeviewcolumn.c:
	misc mechanical multihead-safety fixes.
	
	* gtk/gtkclipboard.c: Use a GtkImage rather than a pixmap for
	the dropper, look up the color palette only at realization time,
	other multihead fixes.

	* gtk/gtkcombo.c (gtk_combo_unrealize): Popdown the list when 
	unrealizing.

	* gtk/gtkentry.c: Only claim ownership of the primary selection 
	when realized, misc multihead fixes.

	* gtk/gtkfontsel.c: Only fill in fonts when attached to a screen,
	fix gtk_font_selection_get_font() for multihead.

	* gtk/gtkgc.c: make the depth => drawable hash per-screen.

	* gtk/gtkinvisible.c: Add a constructor that realizes the
	widget, so we get a realized widget with g_object_new() as
	well gtk_invisible_new() as before.

	* gtk/gtkmain.c: Get rid of unused gtk_visual/gtk_colormap
	variables.

	* gtk/gtktextdisplay.c: Add warnings if stipple bitmaps
	are used on the wrong screen.

	* gtk/gtktoolbar.c: Make handling of GtkSettings-based layout
	read properties and connect to settings when the screen is changed,
	rather than on init/finalize.

	* gtk/gtkwindow.c: Fix icon handing to be multihead safe ...
	default icon pixmaps/mask are only shared between windows on the 
	same screen. Misc multihead fixes.

Sat Apr 27 13:49:53 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclipboard.c (gtk_clipboard_get_for_display):
	Update docs to reference GDK_SELECTION_CLIPBOARD rather GDK_NONE.

2002-04-29  Alex Larsson  <alexl@redhat.com>

	* gdk/linux-fb/gdkproperty-fb.c (gdk_property_get):
	Fix silly bug, noticed by Sven Neumann.

Sun Apr 28 22:43:55 2002  Jonathan Blandford  <jrb@gnome.org>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_set_sort_func): Fix
	so that you can set a new sort func.

2002-04-27  Anders Carlsson  <andersca@gnu.org>

	* gdk/x11/gdkpixmap-x11.c (gdk_pixmap_foreign_new_for_display): 
	Use GDK_DISPLAY_XDISPLAY instead of GDK_SCREEN_XDISPLAY since
	we pass in a GdkDisplay * in the macro.

2002-04-26  Anders Carlsson  <andersca@gnu.org>

	* gdk/gdkdisplay.c: (gdk_set_default_display):
	Call _gdk_windowing_set_default_display.
	
	* gdk/gdkinternals.h:
	* gdk/x11/gdkmain-x11.c: (_gdk_windowing_set_default_display):
	New function that sets gdk_display to the default display.
	Fixes #79965
	
Fri Apr 26 21:58:16 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodel.c (gtk_tree_row_ref_deleted_callback): if the
	deleted node was "below" this path, then do not unref all nodes
	between the deleted parent and the node this rowref is pointing too
	(see added comment in gtk_tree_row_ref_deleted_callback),
	(fixes #77977)

2002-04-26  Sven Neumann  <sven@gimp.org>
 
        * tests/testtreecolumns.c
        * tests/testtreeview.c: quit the main loop when the window is
        destroyed. Removed compiler warnings about wrong format in printf().
 
Fri Apr 26 21:46:42 2002  Kristian Rietveld  <kris@gtk.org>

	This commit fixes binary compatibility, which I broke with my
	recent cell renderer commits :/.

	* gtk/gtkcellrenderer.h: move cell_background out of _GtkCellRenderer

	* gtk/gtkcellrenderer.c: create GtkCellRendererInfo, with the
	cell_background field and use this as object data. This way we keep
	the field private and dont break ABI.

	* gtk/gtkcellrendererpixbuf.h: remove stock_id, stock_size and
	stock_detail from _GtkCellRendererPixbuf

	* gtk/gtkcellrendererpixbuf.c: create a GtkCellRendererPixbufInfo
	with above mentioned fields. And update everything.

Fri Apr 26 21:42:02 2002  Kristian Rietveld  <kris@gtk.org>

	* gdk/x11/gdkdrawable-x11.h: include X11/Xlib.h, fixes the build

Fri Apr 26 10:34:15 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/Makefile.am (libgdk_x11_la_SOURCES): Add
	missing gdkscreen/display-x11.h files.

Thu Apr 25 16:51:40 2002  Owen Taylor  <otaylor@redhat.com>

	Start of integration of Erwann Chenede's multihead work
	from the gtk-multihead branch.

	* gdk/gdkdisplay.[ch] gdk/gdkscreen.[ch]
	gdk/x11/gdkdisplay-x11.[ch] gdk/x11/gdkscreen-x11.[ch]
	New classes representing a set of screens with attached
	input devices and a single contiguous area, respectively.

	* gdk/gdk.[ch] gdk/gdkinternals.h gdk/x11/gdkmain-x11.c:
	gdk/x11/gdkprivate-x11.h: Make the initialization interface
	simple _gdk_windowing_init() and do the rest in
	gdk_open_display() calls.

	* gdk/gdk.[ch]: Add gdk_parse_args() which can be used
	to do the display-independent part of initialization
	instead of gdk_init_[check].

	* gdk/gdkcursor.h gdk/gdkfont.h gdk/gdkkeys.h gdk/gdkpixmap.h
	gdk/gdkproperty.h gdk/gdkselection.h gdk/gdkwindow.h:
	Add multihead variants (_for_display(), for_screen()) of functions
	getting information specific to a particular screen screen or
	display.

	* gdk/gdkscreen.[ch]: Add gdk_screen__* variants of functions
	like gdk_rgb_get_colormap() that used to get/list global
	objects.

	* gdk/x11/gdkx.h: Add functions for converting GdkScreen
	and GdkDisplay into the X equivalents.

	* gdk/x11/gdkwindow-x11.c: Removed gdk_window_xid_at_coords() 
	not in the headers and unused.

	* configure.in gdk/x11/{gxid.c,gxid_lib.[ch],gdkinput-gxi.c}:
	Remove gxid support ... has not been tested for a long time...
	"xfree" support is more	portable to non XFree86.

	* gdk/**.h: Add a GDK_MULTIHEAD_SAFE define that can be
	used to turn off functions that are inherently non-multihead
	safe.

	* gdk/**.c: add GDK_NOTE(multihead, ...) calls when functions
	are used in non-multihead-safe ways.

	* gdk/*.c gdk/x11/*.c: Changes to make the internals of GDK
	multihead safe.

Thu Apr 25 23:49:01 2002  Kristian Rietveld  <kris@gtk.org>

	Fixes #74206.

	* gtk/gtktreeprivate.h: add _gtk_tree_view_column_count_special_cells

	* gtk/gtktreeviewcolumn.c (_gtk_tree_view_column_has_editable_cell),
	(_gtk_tree_view_column_get_editable_cell): remove a space which made
	the code look ugly
	(_gtk_tree_view_column_count_special_cells): new function,
	(gtk_tree_view_column_cell_process_action): if there's only one
	activatable cell, the whole column will activate that renderer.

Thu Apr 25 23:36:55 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_search_iter): make the search
	dialog not scroll horizontally (prolly fixes #74806).

2002-04-25  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkrange.c (gtk_range_calc_layout): Avoid a possible
	division by zero.  (#77820)

Thu Apr 25 20:24:37 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenuitem.c (gtk_menu_item_size_allocate): use the child's
	requisition.height, not allocation.height, as width of submenu
	indicator. (#75948)

Thu Apr 25 00:26:34 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_reset_default_sort_func):
	resort if we're already in 'unsorted' state, and update the docs

2002-04-24  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktreeview.c (gtk_tree_view_stop_editing): Remove doc
	comment markers on freeform comments.

Wed Apr 24 17:34:16 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_stop_editing): temporarily set
	->priv->edited_column to NULL. Pleas read the comment in this
	function for an explanation (fixes #79632).

2002-04-23  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextview.c (gtk_text_view_buffer_to_window_coords): 
	(gtk_text_view_window_to_buffer_coords): Improve docs.  (#62359)

Tue Apr 23 18:35:34 2002  Kristian Rietveld  <kris@gtk.org>

	This commit adds a cell_background property for cell renderers. With
	this property you can make your TreeView look incredibly ugly.

	* gtk/gtkcellrenderer.c: add cell_background, cell_background_gdk and
	cell_background_set properties,
	(set_cell_bg_color): new function,
	(gtk_cell_renderer_get_property), (gtk_cell_renderer_set_property):
	support for new properties,
	(gtk_cell_renderer_render): render a background when set.

	* gtk/gtkcellrenderer.h: add cell_background_set and cell_background
	fields.

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_cell_process_action):
	when rendering, pass in just the background_area of the cell and not
	the background_area of the entire column.

2002-04-22  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkentry.c (gtk_entry_drag_data_get): Use 
	gtk_entry_get_public_chars. 
	Fixes #79532 (Reported by Ovidiu Gheorghioiu).

Mon Apr 22 19:24:29 2002  Kristian Rietveld  <kris@gtk.org>

	This commit adds stock icon functionality to GtkCellRendererPixbuf
	which is totally cool.

	* gtk/gtkcellrendererpixbuf.h: add some fields

	* gtk/gtkcellrendererpixbuf.c: add finalize method, add some
	properties, add some stock icon rendering code.

	* demos/gtk-demo/stock_browser.c: modified to use the stock
	icon stuff in the cellrendererpixbuf instead of its own stock icon
	rendering code.

2002-04-21  Alexander Larsson  <alla@lysator.liu.se>

	* gdk/x11/gdkwindow-x11.c (gdk_window_reparent):
	Save x and y in window_private.

	* gtk/gtkplug.c (_gtk_plug_add_to_socket):
	Move plug window outside the visible area to avoid flashing until
	the first size_allocate.

2002-04-21  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextiter.c (gtk_text_iter_forward_search): More verbose
	description of match_start and match_end return values.  (#57929)

	* gtk/gtktreeselection.c (_gtk_tree_selection_internal_select_node):
	* gtk/gtktreeview.c (_gtk_tree_view_column_autosize): Remove doc
	comment markers on freeform comments.

	* gtk/gtktreemodelsort.c
	(gtk_tree_model_sort_convert_path_to_child_path): Doc fixes. (#68404)

Sat Apr 20 21:15:11 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenuitem.c: add "selected_shadow_type" style property

Sat Apr 20 12:07:14 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_modify_color_component): Accept
	NULL for color to mean "unmodify"

	* gtk/gtkwidget.c (gtk_widget_modify_font): Accept NULL for
	font_desc to mean "unmodify".

Sat Apr 20 16:49:26 2002  Kristian Rietveld  <kris@gtk.org>

	* gdk/x11/gdkpixmap-x11.c (gdk_pixmap_new): replace GDK_IS_WINDOW
	with GDK_IS_DRAWABLE in the assert, only check GDK_WINDOW_DESTROYED
	if window is a GdkWindow,
	(gdk_bitmap_create_from_data): ditto,
	(gdk_pixmap_create_from_data): ditto

Fri Apr 19 23:38:16 2002  Kristian Rietveld  <kris@gtk.org>

	Fixes #50310.

	* gtk/gtktreeprivate.h: add _gtk_tree_view_column_autosize

	* gtk/gtktreeview.c: privately export _gtk_tree_view_column_autosize,
	and add a small note about that function,
	(gtk_tree_view_button_press): check for double click and
	"not having an autosize" column before autosizing the column,
	
	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_set_min_width):
	call _gtk_tree_view_column_autosize to update autosized column width
	(gtk_tree_view_column_set_max_width): ditto

2002-04-20  Matthias Clasen  <maclas@gmx.de>

	* TODO, TODO.xml, README.nanox, docs/Changes-1.2.txt,
	docs/Changes-2.0.txt, docs/gtk-config.txt, docs/debugging.txt,
	gdk/TODO: Remove some files whose content is either obsolete or
	has been moved elsewhere.

	* Makefile.am, gtk+.spec.in, docs/Makefile.am: Remove references
	to these files.
	
Fri Apr 19 21:31:04 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_row_changed): cancel editing
	if tree_view->priv->edited_column != NULL (fixes #76066)

Fri Apr 19 21:06:39 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_size_allocate): subtract
	TREE_VIEW_HEADER_HEIGHT from allocation->height to get the real
	size for the tree (fixes #72729),
	(gtk_tree_view_real_start_editing): correct cell_area->y for
	scrolling due to gtk_tree_view_real_set_cursor (fixes #75687)

Fri Apr 19 16:30:09 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeprivate.h, gtk/gtktreeview.c: rename
	last_single_clicked{,_2} to last_button_press{,_2}, as the latter
	is a more sane name.

	* gtk/gtktreeview.c (gtk_tree_view_button_press): use ->priv->anchor
	instead of ->priv->cursor, check for the anchor at another place, as
	you can go in edit mode without	having an anchor.

2002-04-18  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkitemfactory.c:
	* gtk/gtkiconfactory.c:
	* gtk/gtkwidget.c:
	* gtk/gtkstyle.c:
	* gtk/gtkrc.c:
	* gtk/gtktreeviewcolumn.c:
	* gtk/gtkdialog.c:
	* gtk/gtktreemodel.c: s/<!>/<!-- -->/g throughout the
	documentation to bring the produced Docbook closer to XML.

2002-04-18  Tor Lillqvist  <tml@iki.fi>

	* gdk-pixbuf/Makefile.am (uninstall-libtool-import-lib)
	* gdk/Makefile.am (uninstall-libtool-import-lib): Fix typo,
	thanks to David Sterba for noticing.

	* gtk/gtkmain.h
	* gtk/gtkmain.c (gtk_init_abi_check, gtk_init_check_abi_check): In
	GTK+ 2.0 the GtkWindow struct actually is the same size in gcc on
	Win32 whether compiled with -fnative-struct or not. Unfortunately
	this wan't noticed until now. So, from now on, check some other
	struct, too, for which the use of -fnative-struct still
	matters. GtkBox is one such.

Thu Apr 18 00:23:31 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c
	(gtk_tree_model_sort_convert_path_to_child_path): so this function
	was completely broken. Fix it and improve readability.

2002-04-17  Anders Carlsson  <andersca@gnu.org>

	* tests/testtreeedit.c (button_press_event): Add a small
	test case.

Wed Apr 17 00:21:36 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreestore.c (gtk_tree_store_insert_before): fix docs

Tue Apr 16 17:28:21 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_real_collapse_row): check
	->priv->cursor and ->priv->anchor rowrefs before removing
	node->children from the rbtree. Also check the
	->priv->last_single_clicked and ->priv->last_single_clicked_2 rowrefs
	(I think I really need to rename those two someday).

Tue Apr 16 07:53:49 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkmenu.c (gtk_menu_key_press): don't install/change accelerators
	from locked accel groups.

	* gtk/gtkwidget.c (_gtk_widget_get_accel_path): export whether the
	accel path is from a locked accel group.

Mon Apr 15 15:41:56 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkcontainer.c (gtk_container_focus): include internal
	children when doing focus.
	(gtk_container_get_all_children): new static function to include
	internal children when making a list of them.

Sun Apr 14 16:56:59 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeprivate.h: add _gtk_tree_view_column_get_editable_cell and
	_gtk_tree_view_column_get_neighbor_sizes

	* gtk/gtktreeviewcolumn.c (struct _GtkTreeViewColumnCellInfo): add
	real_width field,
	(_gtk_tree_view_column_get_editable_cell): implement,
	(gtk_tree_view_column_cell_process_action): fill info->real_width
	(_gtk_tree_view_column_get_neighbor_sizes): implement

	* gtk/gtktreeview.c (gtk_tree_view_button_press): make the "editable
	widget" show up with the same size as the actual cell, so it doesnt
	cover the complete column if there are any other cells in that column.

2002-04-14  Abigail Brady  <morwen@evilmagic.org>

	* gtk/gtkfilesel.c: Fix typo in message.

2002-04-13  Havoc Pennington  <hp@pobox.com>

	* gdk/gdkpixbuf-drawable.c (gdk_pixbuf_get_from_drawable): create
	the target pixbuf AFTER filling in width/height, so that 
	passing in -1 for width/height will work.
	
Sat Apr 13 22:49:45 2002  Kristian Rietveld  <kris@gtk.org>

	Fixes #75510

	* gtk/gtktreeselection.c (gtk_tree_selection_get_selected): make this
	function work correctly and more sane

	* gtk/gtktreeview.c (gtk_tree_view_real_collapse_row): remove
	node->children from rbtree before emitting GtkTreeSelection::changed

Sat Apr 13 17:15:12 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkcellrenderertext.c (gtk_cell_renderer_text_init): dont set
	the mode to GTK_CELL_RENDERER_MODE_EDITABLE by default,
	(gtk_cell_renderer_text_class_init): for some reason our default for
	editable was TRUE, of course this is FALSE.
	(gtk_cell_renderer_text_set_property): update mode when editable
	has been changed.

2002-04-12  jacob berkman  <jacob@ximian.com>

	* gdk/x11/xsettings-client.c (fetch_card8): fix cut-n-paste bug
	which breaks big-endian machines (fixes #73585)

2002-04-12  Havoc Pennington  <hp@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_real_remove): relocate the
	remove_weak_pointer to just before we free the page, to be sure 
	it doesn't get re-added. #75282

Fri Apr 12 18:32:46 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_real_set_cursor): add
	clamp_node argument
	(toplevel): update usages of gtk_tree_view_real_set_cursor,
	(gtk_tree_view_focus_to_cursor): don't let
	gtk_tree_view_real_set_cursor clamp the node, so you won't get
	unexpected scrolling

2002-04-11  Michael Meeks  <michael@ximian.com>

	* gtk/gtklabel.c
	(gtk_label_parse_uline, gtk_label_set_text),
	(gtk_label_set_text_with_mnemonic): add freeze / thaws
	to stop deluge of 'notify' signals.

Sat Apr  6 06:57:00 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.[ch] gtk/gtkmenuitem.c: Export
	private _gtk_menu_shell_activate() to encapsulate
	cut-and-paste code.

	* gtk/gtkmenubar.c: Select the first item on the menu bar
	for F10	rather than acting as if the user pressed <Alt>F
	to select the file manager.

Tue Apr  9 19:01:28 2002  Owen Taylor  <otaylor@redhat.com>

        Fix problems with HandleBox and focusing - #78232

	* gtk/gtkwidget.c (gtk_widget_translate_coordinates): Handle
	GtkHandleBox / GnomeDock style window heirarchy / widget
	heirarchy disconnects. :-(. 

	* gtk/gtkcontainer.c: Handle failures from
	gtk_widget_translate_coordinates (Focusing is not right, but at
	least it doesn't go into infinite loops.)

Tue Apr  9 18:34:58 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcontainer.c (_gtk_container_queue_resize): Always
	set the ALLOC_NEEDED and REQUEST_NEEDED flags up the hierarchy,
	even if we aren't currently in a resize container... we need
	this to properly handle size changes to widgets that are
	being moved from one heirarchy to another. (#78226)

Tue Apr  9 21:41:24 2002  Kristian Rietveld  <kris@gtk.org>

	Fixes #78110

	* gtk/gtktreeselection.c (_gtk_tree_selection_internal_select_node):
	add override_browse_mode argument and implement,
	(gtk_tree_selection_unselect_path): always unselect the path,
	(toplevel): update uses of _gtk_tree_selection_internal_select_node

	* gtk/gtktreeview.c: update uses of
	_gtk_tree_selection_internal_select_node

	* gtk/gtktreeprivate.h (_gtk_tree_selection_internal_select_node):
	update prototype

Tue Apr  9 21:39:44 2002  Kristian Rietveld  <kris@gtk.org>

	Fixes #77862

	* gtk/gtktreeprivate.h: add _gtk_tree_view_column_has_editable_cell

	* gtk/gtktreeviewcolumn.c (_gtk_tree_view_column_has_editable_cell):
	new function

	* gtk/gtktreeview.c (gtk_tree_view_button_press): send cell event
	on first click when cell isn't editable

Tue Apr  9 21:37:31 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreedatalist.c (_gtk_tree_data_list_check_type): add some
	types which were missing and useful to use (fixes #77870)

2002-04-09  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtkfilesel.c (open_new_dir): Initialize error to NULL.

2002-04-08  Manish Singh  <yosh@gimp.org>

	* tests/testgtk.c: really revert testgtk.c

Mon Apr  8 20:28:54 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeselection.c (gtk_tree_selection_select_path),
	(gtk_tree_selection_unselect_path),
	(gtk_tree_selection_path_is_selected): check the return value of
	_gtk_tree_view_find_node and return if it's TRUE. This makes those
	functions work somewhat saner on non-expanded trees.

Fri Apr  5 18:28:56 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeselection.c (gtk_tree_selection_set_mode): free
	anchor row reference after unselecting the selection (fixes #76272)

Fri Apr  5 18:27:48 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_real_expand_row): only return
	when we don't have to open all children (fixes #75736)

Fri Apr  5 18:24:24 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_clear): unref
	cellrenderer after clearing the attributes of the renderer (fixes
	#75592)

Fri Apr  5 05:55:14 2002  Jonathan Blandford  <jrb@gnome.org>

	* gtk/gtktreeview.c (gtk_tree_view_grab_focus): implement.
	  (gtk_tree_view_move_cursor_up_down): check for focus
	  (gtk_tree_view_move_cursor_page_up_down): ditto
	  (gtk_tree_view_move_cursor_left_right): ditto
	  (gtk_tree_view_move_cursor_start_end): ditto
	  (gtk_tree_view_real_select_all): ditto
	  (gtk_tree_view_real_unselect_all): ditto
	  (gtk_tree_view_real_select_cursor_row): ditto	
	  (gtk_tree_view_real_toggle_cursor_row): ditto
	  (gtk_tree_view_real_expand_collapse_cursor_row): ditto
	  (gtk_tree_view_real_select_cursor_parent): ditto
	  (gtk_tree_view_real_start_interactive_search): ditto

	* gtk/gtktreeviewcolumn.c: grab focus

2002-04-05  Alex Larsson  <alexl@redhat.com>

	* gdk/linux-fb/gdkkeyboard-fb.c (write_string):
	Fix undefined variable typo.
	Patch from Simon Floery <simon.floery@gmx.at>

Fri Apr  5 01:06:15 2002  Tim Janik  <timj@gtk.org>

	* gdk/x11/gdkwindow-x11.c (set_text_property): fix segfault
	upon NULL return from gdk_utf8_to_string_target().

	* gdk/x11/gdkselection-x11.c (gdk_utf8_to_string_target): fix
	return value comment to mention NULL returns upon EMFILE.

Thu Apr  4 22:35:42 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* tests/testgtk.c (menu_items): revert accidentally commited
	change to testgtk.c

Thu Apr  4 22:28:08 2002  Soeren Sandmann  <sandmann@daimi.au.dk>

	* gtk/gtkmenuitem.c (gtk_menu_item_paint): Fix problem with menu
	titles being clipped (#75948)
	
2002-04-04  Tor Lillqvist  <tml@iki.fi>

	* gdk/gdkrgb.c: Fix some bugs, and introduce a minor feature.

	(gdk_rgb_convert_4_pack): New function, for 16-color (4 bits per
	pixel) static visuals (fixes #858).

	(gdk_rgb_convert_gray4_pack, gdk_rgb_convert_gray4_d_pack): Fix
	same bugs in both functions: Odd start coordinate (partial byte)
	was not handled correctly. Also a partial final byte was not
	handled correctly.

	(gdk_rgb_do_colormaps): Use G_N_ELEMENTS.
	(gdk_rgb_create_info): For pseudocolor visuals, use the 2x2x2
	colorcube only for depths 3 and 4. For static color, use it for
	depths 3..7 like before. (Depth 5..7 pseudocolor probably never
	occurs on X11. It doesn't normally occur on Win32 either, but
	there is experimental code in gdkvisual-win32.c to let the user
	restrict the size of palette used.)
	(gdk_rgb_init): Set gdk_rgb_verbose if the GDK_DEBUG_GDKRGB flag
	is set.
	(gdk_rgb_select_conv): Use gdk_rgb_convert_8 also for depths 5, 6
	and 7 (see above). Use gdk_rgb_convert_4_pack for 4 bits per pixel
	static color.

Tue Apr  2 11:10:13 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkliststore.c (gtk_list_store_set_sort_func): set the
	sort_func correctly, 77030

Tue Apr  2 13:44:27 2002  Tim Janik  <timj@gtk.org>

	* configure.in: update version to 2.0.2, binary age 2, interface
	age 2.

	* NEWS: updates for 2.0.2.

Mon Apr  1 22:20:24 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_move_cursor_page_up_down): add
	check for y > tree_view->priv->height (fixes #76974)

Mon Apr  1 22:19:39 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_sort_level): get
	the stamp changes right this time

Mon Apr  1 22:13:24 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodel.c (gtk_tree_row_reference_free): only
	disconnect the ref callbacks when model == proxy (Thanks go to
	Manuel Clos Crespo for the remote debugging)

Sat Mar 30 15:19:24 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c: revert the latest stamp increment changes,
	as it broke stuff for trees

Fri Mar 29 18:15:12 2002  Owen Taylor  <otaylor@redhat.com>

	* ===== Released 2.0.1 ======

Fri Mar 29 18:09:18 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccelgroup.c (gtk_accel_group_query): Call 
	gdk_keyval_to_lower() on the key passed in, since we
	lowercase all other key vals passed in, so querying
	keyvals will otherwise fail if the caller used
	an uppercase accelerators (#76899, Vitaly Tishkov)

Fri Mar 29 17:41:21 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (load_modules): Fix screwup in handling
	of module path that was resulting in freed memory being
	accessed when both GTK_MODULES and a theme were set.
	(#76902, Johan Dahlin)

Fri Mar 29 17:57:36 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkiconfactory.c (get_default_icons): Fix wrong
	stock id's for ADD/REMOVE. (#76915, Vitaly Tishkov)

2002-03-29  Hans Breuer  <hans@breuer.org>

	* gtk/gtkmain.h : fix typo in gtk_init_check macro, which
	caused crashes if argc != 0

	* gtk/stock-icons/makefile.msc : added new icons

Fri Mar 29 20:17:35 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreemodelsort.c (gtk_tree_model_sort_rows_reordered):
	remove call to gtk_tree_model_sort_increment_stamp
	(gtk_tree_model_sort_sort_level): always increment the stamp

Fri Mar 29 00:19:41 2002  Owen Taylor  <otaylor@redhat.com>

	* NEWS: Updates

	* configure.in: Version 2.0.1, binary, interface age 1.

	* configure.in (GDK_PIXBUF_VERSION): Up required versions
	of dependencies.

	* gtk/gtkiconfactory.c gtk/stock-icons/Makefile.am:
	Add stock_add/remove_16.

Thu Mar 28 18:38:30 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtk[hv]paned.c (gtk_[hv]paned_size_allocate): 
	Don't show the window unless the widget is mapped.
	(#76742, Dennis Björklund, Soeren Sandmann)

2002-03-29  Hans Breuer  <hans@breuer.org>

	Fixed dashed line issues (#74441) to an IMO reasonable extend. 
	That is: use PS_USERSTYLE on WinNT (the next GDI limit appears
	to be with lines width > 50); Render horizontal and vertical
	dashed lines on Win9x 'by hand'. Dotted selection rectangles 
	and Dia look nice ...

	* gdk/win32/gdkprivate-win32.h : add pen_dashes pointer and
	num_pen_dashes to _GdkGCWin32
	* gdk/win32/gdkgc-win32.c : initialize pen_dashes and remove
	the guesses from dashes to windoze line styles.
	(predraw_set_forground) : always ExtCreatePen (PS_SOLID) on
	Win9x, which does not support PS_USERSTYLE.
	* gdk/win32/gdkdrawable-win32.c : new functions render_line_
	<horizontal|vertical>. Use them if not running on NT in
	gdk_win32_draw_<rectangle|segments|lines> ()

	* gdk/win32/gdkkeys-win32.c (gdk_keyval_name) : return NULL
	for keyval == 0 to avoid to have zeros in all menu entries 
	without accelerator.

2002-03-29  Jakub Steiner <jimmac@ximian.com>

	* gtk/stock-icons/stock_add_24.png:
	* gtk/stock-icons/stock_add_16.png:
	* gtk/stock-icons/stock_remove_24.png:
	* gtk/stock-icons/stock_remove_16.png: use a simple '+' and '-',
	  works better. the old box was too clumsy

Thu Mar 28 21:11:04 2002  Tim Janik  <timj@gtk.org>

	* gtk/gtkfilesel.c (open_new_dir): when encountering non-UTF-8 file
	names, alert the user with g_message() instead of g_warning() and
	put out the actual conversion error.

2002-03-28  Dave Camp  <dave@ximian.com>

	* gtk/gtktreeview.c (install_scroll_sync_handler): Don't install
	the handler if the widget isn't realized.

2002-03-28  Jakub Steiner <jimmac@ximian.com>

	* gtk/stock-icons/stock_font*:
	* gtk/stock-icons/stock_align*:
	* gtk/stock-icons/stock_text*: better solution to the dark theme
	  problem. Also looks more pretty IMHO

2002-03-27  Matthias Clasen  <maclas@gmx.de>

	* configure.in: Try to find libpng via pkg-config first,
	since libpng-1.2.2 will come with a .pc file.

Wed Mar 27 11:10:39 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_real_remove): Set
	page->last_focus_child to NULL as well as removing the
	weak reference, to deal with reentrancy in set_focus_child().
	(#76634, Dennis Björklund)

2002-03-27  Murray Cumming  <murrayc@usa.net>
 
 	* gtk/gtktreeview.c: Corrected registered return type of
	"move-cursor" signal. Had to add a marshaller to 
 	gtk/gtkmarshalers.list.
	
Tue Mar 26 14:46:50 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_popup): Shuffle the ordering around
	some more (position before realizing) fixing problems with 
	arrows popping up at the wrong time (#73386), hopefully not
	introducing other problems. (Reported by Ettore Perrazoli, others)

2002-03-26  Dave Camp  <dave@ximian.com>

	* gtk/gtktreeview.c (gtk_tree_view_button_press): Free the path
	after calling gtk_tree_view_row_activated() rather than before.

2002-03-25  Sven Neumann  <sven@gimp.org>

	* gtk/gtkrc.c (gtk_rc_parse_font_name): free the style's
	font_description before assigning a new one.
	(gtk_rc_parse_stock): always unref the created icon_set. #76289
	
2002-03-25  Mark McLoughlin  <mark@skynet.ie>

	* gtk/gtkbindings.c: (gtk_binding_entry_add_signal),
	kill code duplicated in gtk_binding_entry_add_signall.

Sun Mar 24 10:32:38 2002  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtktreemodel.c (gtk_tree_path_copy): Make path arg const, #75653

	* gtk/gtkfontsel.c (gtk_font_selection_show_available_styles): fix
	a warning

	* gtk/gtktreeview.c (gtk_tree_view_button_press): remove the grab
	when we emit row_activated so that listeners of this signal can
	grab the mouse, #75629

2002-03-23  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextlayout.c (gtk_text_layout_real_invalidate):
	invalidate the line containing start, even if the [start,end)
	range is empty (just invalidate [start,end], essentially).
	Partially fixes #72374

2002-03-23  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (gtk_text_view_do_popup): end any selection in
	progress, patch from db@zigo.dhs.org, #74620

2002-03-23  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (gtk_text_view_move_cursor_internal): extend
	selection for pageup/pagedown and ctrl+pageup/pagedown if 
	shift is held. more of #53934

2002-03-23  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (gtk_text_view_destroy_layout): disconnect 
	layout handlers earlier in the function, to avoid possible
	reentrancy screwups
	(gtk_text_view_invalidate): Don't install idle handlers if 
	layout == NULL, otherwise we get problems during finalization 
	since clearing the buffer invalidates and puts the idle handlers
	back after we destroy the layout. #74660
	(gtk_text_view_ensure_layout): Install the validation handlers
	right after creating the layout.

	* gtk/gtktexttagtable.c (foreach_unref): call
	_gtk_text_buffer_notify_will_remove_tag(), #75126

2002-03-22  Havoc Pennington  <hp@pobox.com>

	* gdk/x11/gdkfont-x11.c (gdk_fontset_load): add more explanatory
	text to the error message about missing charsets, and use
	g_printerr() not g_warning() since this is typically not a
	programming error (we do not export any API to ask whether 
	a font set will have missing charsets so apps realistically can't 
	do anything other than try the gdk_fontset_load())

	* gtk/gtktextview.c (gtk_text_view_key_press_event): return FALSE
	if the text view isn't editable and the user presses Return, 
	so default buttons and such can be activated, #74937

	* gtk/gtktextbuffer.c (paste_from_buffer): don't insert 
	if the insertion point is not editable and the paste 
	is interactive, #74125

	* gtk/gtkwindow.c (gtk_window_move_resize): enhance the #if 0
	debug spew

	* gtk/gtktextbuffer.c (cut_or_copy): only remove the previous 
	cut/copied data right before replacing it, when we know we are
	going to replace it. Fixes #74049

2002-03-22  Richard Hult  <rhult@codefactory.se>

	* gdk/gdkevents.c (gdk_event_get_root_coords): Fix typo, where x
	value was assigned to both x and y.

Fri Mar 22 11:29:11 2002  Owen Taylor  <otaylor@redhat.com>

	Partial fix for problem where keypad keys acted
	as shift-arrows in an entry rather than arrows (#74327)

	* gtk/gtkkeyhash.c (_gtk_key_hash_lookup): Sort lookup
	results by number of modifiers in the entry. Fixes
	problem where if a key matched both modified and unmodified
	key bindings ... e.g., the distinguishing key binding
	was consumed, then it was random which was used. 

	* gtk/gtkbindings.c (gtk_binding_entries_sort_patterns): 
	Catch the case where there are multiple entries from the
	same bindingset (with different modifiers), and use only
	the first entry, which, with the change in _gtk_key_hash_lookup()
	will be the preferred value.

Fri Mar 22 10:56:19 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccelmap.c (gtk_accel_map_save_fd): Fix memory
	leak. (#74400, Morten Welinder.)

	* gtk/gtkaccelmap.c: Properly handle short returns from
	write() calls. (Handling EINTR isn't enough... that only
	handles the case where you were interrupted before you
	wrote a single byte.)
	
	* gdk/linux-fb/gdkmouse-fb.c gdk/linux-fb/gdkkeyboard-fb.c:
	Robustify against short returns from write() calls.

Fri Mar 22 10:12:10 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextview.c (gtk_text_view_paint): Change
	G_BREAKPOINT() to g_assert_not_reached ().
	(#75865, Ashok Venkiteswaran)
	
2002-03-22  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkgc-win32.c (gdk_win32_gc_set_dashes): Don't clear
	all of the pen_style, just the PS_STYLE_MASK. Seems to fix #74441,
	but that is just the special case of one-pixel wide one-pixel
	on-off dotted lines. To fully implement generic X11 style dashed
	lines a major rewrite would be needed.

2002-03-21  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkaccelgroup.c (gtk_accelerator_valid): Trivial typo
	fix. (Vitaly Tishkov, #75726)

Thu Mar 21 10:04:05 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_real_get_depth): Remove
	some left over debugging code with a G_BREAKPOINT()
	in it.

Wed Mar 20 19:33:31 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcalendar.c (gtk_calendar_main_button): When
	changing months when the user clicks on a prev-month
	or next-month day, focus and select the new day.
	Ignore double clicks on prev-month, next-month days.
	(Based on suggestions from Andras Salamon, #74173)

	* gtk/gtkcalendar.c: Implement the focused/unfocused
	selected color change.

2002-03-20  Alex Larsson  <alexl@redhat.com>

	Patches from Carlo E. Prelz <fluido@fluido.as>
	Now gtkfb at least compiles and mostly works. The keyboard
	stuff needs more loving.
	
	* gdk/linux-fb/gdkkeyboard-fb.c (xlate_get_for_keyval,
	xlate_get_for_keycode, raw_get_for_keyval, raw_get_for_keycode):
	At least set the out parameters for these calls.

	* gdk/linux-fb/gdkmain-fb.c:
	(gdk_pointer_grab_info_libgtk_only, gdk_keyboard_grab_info_libgtk_only):
	Implement new functions.
	
Wed Mar 20 19:00:03 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_set_text): Short-circuit
	the text to the exact same thing, so we don't 
	unexpectedly change the selection or cursor position.
	(#74290, John Ellis.)

Thu Mar 21 00:05:14 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtktreeview.c (gtk_tree_view_get_background_area),
	(gtk_tree_view_get_cell_area): fix logic (fixes #74235, #73593)

Wed Mar 20 17:11:51 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c: Patch from Richard Hestilow to fix
	gtk-font-name changes for widgets that get the actual
	default style. (#73709)

Wed Mar 20 22:59:23 2002  Kristian Rietveld  <kris@gtk.org>

	* gtk/gtkrbtree.[ch]: add _gtk_rbtree_set_fixed_height()

	* gtk/gtktreeprivate.h: add fixed_height_check field

	* gtk/gtktreeview.c (gtk_tree_view_init): initialize
	scroll_sync_timer and fixed_height_check
	(do_validate_rows): add fixed_height_check. If all validated rows
	in the first cycle have the same height, then we set that height for
	the entire tree. This is some sort of 'fake' optimization, but helps
	a lot for the common case. We keep validating the entire tree in
	the background though.
	(gtk_tree_view_set_model): reset fixed_height_check

Wed Mar 20 16:36:08 2002  Owen Taylor  <otaylor@redhat.com>

        * gtk/*.c: Patch from Erwann Chenede, #73900 fixing
	a lot of warnings with Forte CC, mostly implicit
	casts between void * and function pointers.
	
	* gdk/gdkevents.c (gdk_event_get_state): GdkEventVisibility's
	state field is not a GdkModifierType. (Also #73900)

Wed Mar 20 12:35:22 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_grab_default): Remove
	leftover notification of has-default. (#75508, Jacob
	Berkman.)

Wed Mar 20 12:27:07 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccelgroup.c (gtk_accelerator_valid): Allow
	arrow keys as accelerators, as long as some modifier
	is pressed. (#75495)

	* gtk/gtkaccelgroup.c (gtk_accelerator_valid): Fix
	incorrect example in the docs.

Wed Mar 20 12:06:30 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_set_child_visible):
	Fix segfault when widget->parent is NULL. 
	(#75615, Alexey A. Malyshev) 

Wed Mar 20 11:32:07 2002  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c: Improve test to prevent infinite
	loop. (#74952, Thomas Leonard)

	* gtk/gtkmenushell.c (gtk_real_menu_shell_cycle_focus):
	Fix warning when toplevel menu shell isn't a menu
	bar. (Thomas Leonard, #75602)

Wed Mar 20 11:00:59 2002  Owen Taylor  <otaylor@redhat.com>

        * configure.in: Use $PKG_CONFIG, not pkg-config.
        (LEE Sau Dan, #75572)

Wed Mar 20 10:55:56 2002  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkevents-x11.c (gdk_event_translate): Fix assignment
	of time in scroll events. (Sven Neumann, #75574)

2002-03-20  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkdnd-win32.c (gdk_drag_find_window): Use
	gdk_window_get_toplevel(), as it is the top-level windows that are
	registered for DND.

	* gdk/win32/gdkwin32.h: Don't include gdkinternals.h.

2002-03-19  jacob berkman  <jacob@ximian.com>

	* gtk/gtkcombo.c (gtk_combo_find): fix infinite loop when
	gtk_combo_func() returns NULL (bug #75464)

2002-03-18  jacob berkman  <jacob@ximian.com>

	* gtk/gtkaspectframe.c (gtk_aspect_frame_class_init): set the
